2024-12-31  Jiahao Xu  <xujiahao@loongson.cn>
	    Deng Jianbo  <dengjianbo@loongson.cn>

	* config/loongarch/simd.md (cbranch<mode>4): New expander.

2024-12-31  Robin Dapp  <rdapp.gcc@gmail.com>

	PR target/118036
	* varasm.cc (output_constant_pool_2): Use native_encode_rtx for
	building the memory image of a const vector mask.

2024-12-30  Jeff Law  <jlaw@ventanamicro.com>

	PR target/106544
	* config/riscv/riscv.cc (riscv_print_operand): Issue an error for
	invalid operands rather than invalidly accessing INTVAL of an
	object that is not a CONST_INT.  Fix one error string for 'N'.

2024-12-30  Jeff Law  <jlaw@ventanamicro.com>

	PR target/118122
	* config/riscv/riscv.md (lui_constraint<X:mode>_and_to_or): Use
	X iterator rather than ANYI consistently.  Fix formatting.

2024-12-30  Richard Sandiford  <richard.sandiford@arm.com>
	    Saurabh Jha  <saurabh.jha@arm.com>

	* config/aarch64/aarch64.md (UNSPEC_BSL, UNSPEC_COMBINE, UNSPEC_DUP)
	(UNSPEC_DUP_LANE, UNSPEC_GET_LANE, UNSPEC_LD1_DUP, UNSPEC_LD1x2)
	(UNSPEC_LD1x3, UNSPEC_LD1x4, UNSPEC_SET_LANE, UNSPEC_ST1_LANE)
	(USNEPC_ST1x2, UNSPEC_ST1x3, UNSPEC_ST1x4, UNSPEC_VCREATE)
	(UNSPEC_VEC_COPY): New unspecs.
	* config/aarch64/iterators.md (UNSPEC_TBL): Likewise.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Add definitions
	of the mf8 data movement intrinsics.
	* config/aarch64/aarch64-protos.h
	(aarch64_advsimd_vector_array_mode): Declare.
	* config/aarch64/aarch64.cc
	(aarch64_advsimd_vector_array_mode): Make public.
	* config/aarch64/aarch64-builtins.h (qualifier_const_pointer): New
	aarch64_type_qualifiers member.
	* config/aarch64/aarch64-builtins.cc (AARCH64_SIMD_VGET_LOW_BUILTINS)
	(AARCH64_SIMD_VGET_HIGH_BUILTINS): Add mf8 variants.
	(aarch64_int_or_fp_type): Handle qualifier_modal_float.
	(aarch64_num_lanes): New function.
	(binary_two_lanes, load, load_lane, store, store_lane): New signatures.
	(unary_lane): Likewise.
	(simd_type::nunits): New member function.
	(simd_types): Add pointer types.
	(aarch64_fntype): Handle the new signatures.
	(require_immediate_lane_index): Use aarch64_num_lanes.
	(aarch64_pragma_builtins_checker::check): Handle the new intrinsics.
	(aarch64_convert_address): (aarch64_dereference_pointer):
	(aarch64_canonicalize_lane, aarch64_convert_to_lane_mask)
	(aarch64_pack_into_v128s, aarch64_expand_permute_pair)
	(aarch64_expand_tbl_tbx): New functions.
	(aarch64_expand_pragma_builtin): Handle the new intrinsics.
	(aarch64_force_gimple_val, aarch64_copy_vops, aarch64_fold_to_val)
	(aarch64_dereference, aarch64_get_lane_bit_index, aarch64_get_lane)
	(aarch64_set_lane, aarch64_fold_combine, aarch64_fold_load)
	(aarch64_fold_store, aarch64_ext_index, aarch64_rev_index)
	(aarch64_trn_index, aarch64_uzp_index, aarch64_zip_index)
	(aarch64_fold_permute): New functions, some split out from
	aarch64_general_gimple_fold_builtin.
	(aarch64_gimple_fold_pragma_builtin): New function.
	(aarch64_general_gimple_fold_builtin): Use the new functions above.
	* config/aarch64/aarch64-simd.md (aarch64_dup_lane<mode>)
	(aarch64_dup_lane_<vswap_width_name><mode>): Add "@" to name.
	(aarch64_simd_vec_set<mode>): Likewise.
	(*aarch64_simd_vec_copy_lane_<vswap_width_name><mode>): Likewise.
	(aarch64_simd_bsl<mode>): Likewise.
	(aarch64_combine<mode>): Likewise.
	(aarch64_cm<optab><mode><vczle><vczbe>): Likewise.
	(aarch64_simd_ld2r<vstruct_elt>): Likewise.
	(aarch64_vec_load_lanes<mode>_lane<vstruct_elt>): Likewise.
	(aarch64_simd_ld3r<vstruct_elt>): Likewise.
	(aarch64_simd_ld4r<vstruct_elt>): Likewise.
	(aarch64_ld1x3<vstruct_elt>): Likewise.
	(aarch64_ld1x4<vstruct_elt>): Likewise.
	(aarch64_st1x2<vstruct_elt>): Likewise.
	(aarch64_st1x3<vstruct_elt>): Likewise.
	(aarch64_st1x4<vstruct_elt>): Likewise.
	(aarch64_ld<nregs><vstruct_elt>): Likewise.
	(aarch64_ld1<VALL_F16: Likewise.mode>): Likewise.
	(aarch64_ld1x2<vstruct_elt>): Likewise.
	(aarch64_ld<nregs>_lane<vstruct_elt>): Likewise.
	(aarch64_<PERMUTE: Likewise.perm_insn><mode><vczle><vczbe>): Likewise.
	(aarch64_ext<mode>): Likewise.
	(aarch64_rev<REVERSE: Likewise.rev_op><mode><vczle><vczbe>): Likewise.
	(aarch64_st<nregs><vstruct_elt>): Likewise.
	(aarch64_st<nregs>_lane<vstruct_elt>): Likewise.
	(aarch64_st1<VALL_F16: Likewise.mode>): Likewise.

2024-12-30  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/t-aarch64 (aarch64-builtins.o): Depend on
	aarch64-simd-pragma-builtins.def.

2024-12-30  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc (simd_types::f8): Rename to...
	(simd_types::mf8): ...this.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Update accordingly.

2024-12-30  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc (simd_types): Use one macro
	invocation for each element type.

2024-12-30  Richard Sandiford  <richard.sandiford@arm.com>

	* read-rtl.cc (md_reader::handle_overloaded_name): Don't add
	arguments for uses of subst attributes.
	(apply_iterators): Only add instructions to an overloaded helper
	if they use the default subst iterator values.
	* doc/md.texi: Update documentation accordingly.
	* config/i386/i386-expand.cc (expand_vec_perm_broadcast_1): Update
	accordingly.

2024-12-30  kelefth  <konstantinos.eleftheriou@vrull.eu>

	PR rtl-optimization/117835
	PR rtl-optimization/117872
	* avoid-store-forwarding.cc
	(store_forwarding_analyzer::process_store_forwarding):
	Zero-extend the value stored in the base register instead of
	using a paradoxical subreg.

2024-12-30  Hans-Peter Nilsson  <hp@bitrange.com>

	PR target/117618
	* config/mmix/mmix.cc (mmix_setup_incoming_varargs):
	Correct handling of C23 (...)-functions.

2024-12-30  Lewis Hyatt  <lhyatt@gmail.com>

	PR tree-optimization/118205
	* tree-parloops.cc (reduction_phi): Return NULL if PHI parameter is
	not a phi node.

2024-12-29  Jeff Law  <jlaw@ventanamicro.com>

	PR target/116715
	* config/riscv/bitmanip.md: Drop bogus pattern.

2024-12-29  John David Anglin  <danglin@gcc.gnu.org>

	PR target/118121
	* configure.ac: Check for mkstemps declaration.
	* configure: Regenerate.
	* config.in: Regenerate.

2024-12-29  Jeff Law  <jlaw@ventanamicro.com>

	PR target/116720
	* config/riscv/thead.cc (th_mempair_operands_p): Test for
	aligned memory after swapping operands.  Simplify test for
	first memory access as well.

2024-12-28  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/118207
	* gimple-fold.cc (fold_array_ctor_reference): For RAW_DATA_CST,
	just set val to build_int_cst and fall through to the normal
	element handling code instead of returning build_int_cst right away.

2024-12-28  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/install.texi (Specific) <*-ibm-aix*>: Drop verbose
	references to PTFs for AIX.

2024-12-27  Jiahao Xu  <xujiahao@loongson.cn>

	* config/loongarch/lasx.md (vec_cmp<mode><mode256_i>): Remove.
	(vec_cmpu<ILASX:mode><mode256_i>): Remove.
	* config/loongarch/loongarch.cc (loongarch_expand_lsx_cmp):
	Ensure vector comparison instructions support CMP_OP1.
	* config/loongarch/lsx.md (vec_cmp<mode><mode_i>): Remove.
	(vec_cmpu<ILSX:mode><mode_i>): Remove.
	* config/loongarch/simd.md (ALLVEC, allmode_i): New mode iterators.
	(vec_cmp<mode><allmode_i>): New define_expand.
	(vec_cmpu<mode><allmode_i>): Likewise.

2024-12-26  John David Anglin  <danglin@gcc.gnu.org>

	PR target/118050
	* timevar.cc (get_time): Only use CLOCK_MONOTONIC if
	'_POSIX_TIMERS > 0 && defined(_POSIX_MONOTONIC_CLOCK)'.
	Otherise, use CLOCK_REALTIME.

2024-12-26  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/gm2.texi (Dialect): Move PM4 link to https.

2024-12-25  Maciej W. Rozycki  <macro@orcam.me.uk>

	* config/alpha/alpha.cc
	(alpha_get_mem_rtx_alignment_and_offset): New function.
	(alpha_expand_block_move, alpha_expand_block_clear): Use it for
	alignment retrieval.

2024-12-25  Maciej W. Rozycki  <macro@orcam.me.uk>

	* config/alpha/alpha.cc (alpha_expand_unaligned_load_words):
	Move address extraction until after the MEM referred has been
	adjusted for the offset supplied.
	(alpha_expand_unaligned_store_words): Likewise.

2024-12-25  Maciej W. Rozycki  <macro@orcam.me.uk>

	PR target/115459
	* config/alpha/alpha.cc (alpha_expand_block_clear): Adjust MEM
	to match inferred alignment.

2024-12-25  Maciej W. Rozycki  <macro@orcam.me.uk>

	* config/alpha/alpha.cc (alpha_expand_block_clear): Fold two
	legs of a conditional together.

2024-12-25  Maciej W. Rozycki  <macro@orcam.me.uk>

	* config/alpha/alpha.md (insvmisaligndi): Use "reg_or_0_operand"
	rather than "register_operand" for operand 3.

2024-12-25  Jiahao Xu  <xujiahao@loongson.cn>

	* config/loongarch/loongarch.cc
	(loongarch_ira_change_pseudo_allocno_class): New function.
	(TARGET_IRA_CHANGE_PSEUDO_ALLOCNO_CLASS): Define macro.

2024-12-23  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/invoke.texi (HPPA Options): Remove references
	to HP-UX 8 and HP-UX 9.

2024-12-22  Pan Li  <pan2.li@intel.com>

	* config/riscv/autovec.md: Align the operand for strided
	load/store pattern.

2024-12-21  Arsen Arsenović  <arsen@aarsen.me>

	PR middle-end/109224
	* gimple-ssa-warn-access.cc (new_delete_mismatch_p): Strip
	DEMANGLE_COMPONENT_TEMPLATE from the operator new and operator
	after demangling.

2024-12-21  Jeff Law  <jlaw@ventanamicro.com>

	PR middle-end/118084
	* config/riscv/riscv.cc (generate_reflecting_code_using_brev): Handle
	sub-word sized objects correctly.

2024-12-21  Pan Li  <pan2.li@intel.com>

	* match.pd: Refactor sorts of signed SAT_ADD match patterns.

2024-12-21  Mark Harmstone  <mark@harmstone.com>

	* vmsdbgout.cc (vmsdbgout_begin_block): Fix compilation error.

2024-12-20  Alexandre Oliva  <oliva@adacore.com>

	PR middle-end/118007
	* ipa-strub.cc (pass_ipa_strub::execute): Accept indirecting
	volatile args of pointer types.

2024-12-20  Alexandre Oliva  <oliva@adacore.com>

	PR middle-end/113506
	* emit-rtl.cc (add_insn_before): Don't set the block of a
	barrier.

2024-12-20  Uros Bizjak  <ubizjak@gmail.com>

	PR target/118067
	* config/i386/i386.md (*movdi_internal):
	Disable alternatives from/to mask registers without AVX512BW.
	(*movsi_internal): Ditto.

2024-12-20  Tamar Christina  <tamar.christina@arm.com>

	PR target/96342
	* config/aarch64/aarch64-protos.h
	(aarch64_sve_expand_vector_init_subvector): New.
	* config/aarch64/aarch64-sve.md (vec_init<mode><Vhalf>): New.
	(@aarch64_pack_partial<mode>): New.
	* config/aarch64/aarch64.cc (aarch64_sve_expand_vector_init_subvector): New.
	* config/aarch64/iterators.md (SVE_NO2E): New.
	(VHALF, Vhalf): Add SVE partial vectors.

2024-12-20  Tamar Christina  <tamar.christina@arm.com>
	    Victor Do Nascimento  <victor.donascimento@arm.com>

	PR target/96342
	* config/aarch64/aarch64-protos.h (add_sve_type_attribute): Declare.
	* config/aarch64/aarch64-sve-builtins.cc (add_sve_type_attribute): Make
	visibility global and support use for non_acle types.
	* config/aarch64/aarch64.cc
	(aarch64_simd_clone_compute_vecsize_and_simdlen): Create VLA simd clone
	when no simdlen is provided, according to ABI rules.
	(simd_clone_adjust_sve_vector_type): New helper function.
	(aarch64_simd_clone_adjust): Add '+sve' attribute to SVE simd clones
	and modify types to use SVE types.
	* omp-simd-clone.cc (simd_clone_mangle): Print 'x' for VLA simdlen.
	(simd_clone_adjust): Adapt safelen check to be compatible with VLA
	simdlen.

2024-12-20  Christophe Lyon  <christophe.lyon@linaro.org>

	PR target/118131
	* config/arm/arm.cc (output_move_neon): Check TARGET_NEON as
	needed.
	(arm_attr_length_move_neon): Add support for V2x and V4x MVE tuple
	modes.
	* config/arm/iterators.md (VSTRUCT2, VSTRUCT4): New.
	* config/arm/neon.md: Use VSTRUCT2 instead of OI and VSTRUCT4
	instead of XI in define_split.

2024-12-20  Christoph Müllner  <christoph.muellner@vrull.eu>

	* tree-ssa-forwprop.cc (get_vect_selector_index_map): Removed.
	(recognise_vec_perm_simplify_seq): Fix calculation of vec-perm
	selectors of narrowed sequence.
	(calc_perm_vec_perm_simplify_seqs): Fixing calculation of
	vec-perm selectors of the blended sequence.
	(process_vec_perm_simplify_seq_list): Add whitespace to dump
	string to avoid bad formatted dump output.

2024-12-20  Christoph Müllner  <christoph.muellner@vrull.eu>

	* common/config/riscv/riscv-common.cc (riscv_get_valid_option_values):
	Skip adding mtune entries that are already in the list.

2024-12-20  Jakub Jelinek  <jakub@redhat.com>

	PR c++/110345
	* tree.cc (type_hash_canon_hash): Hash TYPE_REF_IS_RVALUE for
	REFERENCE_TYPE.
	(type_cache_hasher::equal): Compare TYPE_REF_IS_RVALUE for
	REFERENCE_TYPE.

2024-12-20  Nathaniel Shead  <nathanieloshead@gmail.com>

	* doc/invoke.texi: Document -Wtemplate-names-tu-local.

2024-12-19  Patrick Palka  <ppalka@redhat.com>

	PR c++/118069
	* hwint.h (add_sat_hwi): New function.
	(mul_sat_hwi): Likewise.

2024-12-19  Tobias Burnus  <tburnus@baylibre.com>

	* omp-general.cc (vendor_properties): Add "nec".

2024-12-19  Andrew Carlotti  <andrew.carlotti@arm.com>

	* tree-assume.cc: Fix comment typos.

2024-12-19  Pan Li  <pan2.li@intel.com>

	PR target/118075
	* config/riscv/vector.md: Add the (mem:BLK (scratch)) as the
	lhs of strided store define insn.

2024-12-19  Alexandre Oliva  <oliva@adacore.com>

	* gimple-fold.cc (decode_field_reference): Add psignbit
	parameter.  Set it if the mask references sign-extending
	bits.
	(fold_truth_andor_for_ifcombine): Adjust calls with new
	variables.  Swap them along with other r?_* variables.  Handle
	extended sign bit compares with zero.
	* tree-ssa-ifcombine.cc (ifcombine_ifandif): If bits_test
	fails in a way that doesn't prevent other ifcombine strategies
	from passing, give them a try.

2024-12-19  Alexandre Oliva  <oliva@adacore.com>

	* gimple-fold.cc (decode_field_reference): Accept incoming
	mask.
	(fold_truth_andor_for_ifcombine): Handle some compares with
	powers of two, minus 1 or 0, like masked compares with zero.

2024-12-19  Alexandre Oliva  <oliva@adacore.com>

	PR tree-optimization/117915
	* tree-ssa-ifcombine.cc (ifcombine_mark_ssa_name): Move
	preconditions from...
	(ifcombine_mark_ssa_name_walk): ... here.

2024-12-19  Alexandre Oliva  <oliva@adacore.com>

	PR tree-optimization/118046
	* gimple-fold.cc (decode_field_reference): Don't follow more
	than one conversion.

2024-12-19  Alexandre Oliva  <oliva@adacore.com>

	* gimple-fold.cc (gimple_convert_def_p): Reject load stmts
	unless requested.
	(decode_field_reference): Accept a converting load at the last
	conversion matcher, subsuming the load identification.
	(fold_truth_andor_for_ifcombine): Refuse to merge operands
	when only one of them has an associated load stmt.  Swap
	operands of one of the compares if that helps them match.

2024-12-18  Eric Botcazou  <ebotcazou@adacore.com>

	PR target/118096
	* config/sparc/predicates.md (vec_cmp_operator): New predicate.
	(vec_cmpu_operator): Likewise.
	* config/sparc/sparc.md (vec_cmp<FPCMP:mode><P:mode>): Use the
	vec_cmp_operator predicate instead of FAILing the expansion.
	(vec_cmpu<FPCMP:mode><P:mode>): Likewise for vec_cmpu_operator.

2024-12-18  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/117248
	* lra-lives.cc (process_bb_lives): Update conflict hard regs even
	when clobber hard reg is not marked as dead.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* lto-cgraph.cc (lto_symtab_encoder_delete_node):
	Declare var later when initialized.
	* lto-streamer.h (struct lto_encoder_entry):
	Remove empty constructor.

2024-12-18  Vladimir N. Makarov  <vmakarov@redhat.com>

	Revert:
	2024-12-06  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/117248
	* lra-lives.cc (start_living, start_dying): Remove.
	(insn_regnos, out_insn_regnos, insn_regnos_live_after): New.
	(sparseset_contains_pseudos_p): Remove.
	(make_hard_regno_live, make_hard_regno_dead): Return true if
	something in liveness is changed.
	(mark_pseudo_live,  mark_pseudo_dead): Ditto.
	(mark_regno_live, mark_regno_dead): Ditto.
	(clear_sparseset_regnos, regnos_in_sparseset_p): Use set instead
	of dead_set.
	(process_bb_lives): Rewrite dealing with reg notes.  Update
	conflict hard regs even when clobber hard reg is not marked as
	dead.
	(lra_create_live_ranges_1): Add initialization/finalization of
	insn_regnos, out_insn_regnos, insn_regnos_live_after.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* ipa-devirt.cc (ipa_odr_summary_write):
	Add unused argument.
	* ipa-fnsummary.cc (ipa_fn_summary_write): Likewise.
	* ipa-icf.cc (sem_item_optimizer::write_summary): Likewise.
	* ipa-modref.cc (modref_write): Likewise.
	* ipa-prop.cc (ipa_prop_write_jump_functions): Likewise.
	(ipcp_write_transformation_summaries): Likewise.
	* ipa-sra.cc (ipa_sra_write_summary): Likewise.
	* lto-cgraph.cc (lto_symtab_encoder_delete): Delete remap.
	(lto_output_node): Remap order.
	(lto_output_varpool_node): Likewise.
	(output_cgraph_opt_summary): Add unused argument.
	* lto-streamer-out.cc (produce_symbol_asm): Renamed. Use remapped order.
	(produce_asm): Rename. New wrapper.
	(output_function): Propagate remapped order.
	(output_constructor): Likewise.
	(copy_function_or_variable): Likewise.
	(cmp_int): New.
	(create_order_remap): New.
	(lto_output): Create remap. Remap order.
	* lto-streamer.h (struct lto_symtab_encoder_d): Remap hash_map.
	(produce_asm): Add order argument.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* cgraph.h (symbol_table::register_symbol):
	Order can be already set.
	* cgraphclones.cc (cgraph_node::create_clone):
	Reuse order for clones.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* ipa-strub.cc (ipa_strub_set_mode_for_new_functions): Replace
	order with uid.
	(pass_ipa_strub_mode::execute): Likewise.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* Makefile.in: Add lto-ltrans-cache.o.
	* common.opt: New flags for configuring cache.
	* lto-opts.cc (lto_write_options): Don't stream the flags.
	* lto-wrapper.cc: Use ltrans cache.
	* lto-ltrans-cache.cc: New file.
	* lto-ltrans-cache.h: New file.

2024-12-18  Michal Jires  <mjires@suse.cz>

	* Makefile.in: Add lockfile.o.
	* lockfile.cc: New file.
	* lockfile.h: New file.

2024-12-18  Prathamesh Kulkarni  <prathameshk@nvidia.com>

	Revert:
	2024-12-18  Prathamesh Kulkarni  <prathameshk@nvidia.com>
		    Matthew Malcolmson  <mmalcolmson@nvidia.com>

	PR driver/81358
	* common.opt: New option -flink-libatomic.
	* gcc.cc (LINK_LIBATOMIC_SPEC): New macro.
	* config/gnu-user.h (GNU_USER_TARGET_LINK_GCC_C_SEQUENCE_SPEC): Use
	LINK_LIBATOMIC_SPEC.
	* doc/invoke.texi: Document -flink-libatomic.
	* configure.ac: Define TARGET_PROVIDES_LIBATOMIC.
	* configure: Regenerate.
	* config.in: Regenerate.

2024-12-18  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	* config/arm/thumb1.md (thumb1_cbz): Escape the semicolon.

2024-12-18  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/118081
	* gimple-fold.cc (decode_field_reference): Only set *xor_p to true
	if *xor_cmp_op is integer_zerop.

2024-12-18  Prathamesh Kulkarni  <prathameshk@nvidia.com>
	    Matthew Malcolmson  <mmalcolmson@nvidia.com>

	PR driver/81358
	* common.opt: New option -flink-libatomic.
	* gcc.cc (LINK_LIBATOMIC_SPEC): New macro.
	* config/gnu-user.h (GNU_USER_TARGET_LINK_GCC_C_SEQUENCE_SPEC): Use
	LINK_LIBATOMIC_SPEC.
	* doc/invoke.texi: Document -flink-libatomic.
	* configure.ac: Define TARGET_PROVIDES_LIBATOMIC.
	* configure: Regenerate.
	* config.in: Regenerate.

2024-12-18  Tobias Burnus  <tburnus@baylibre.com>

	* gimplify.cc (gimplify_call_expr): Update for OpenMP's
	append_args; cleanup of OpenMP's dispatch clause handling.

2024-12-18  Jakub Jelinek  <jakub@redhat.com>

	PR c/41045
	* stmt.cc (parse_output_constraint, parse_input_constraint): Handle
	- modifier.
	* recog.h (raw_constraint_p): Declare.
	* recog.cc (raw_constraint_p): New variable.
	(asm_operand_ok, constrain_operands): Handle - modifier.
	* common.md (i, s, n): For raw_constraint_p don't require
	LEGITIMATE_PIC_OPERAND_P.
	* doc/md.texi: Document - constraint modifier.

2024-12-18  Jakub Jelinek  <jakub@redhat.com>

	* final.cc (output_asm_insn): Add support for cc operand modifier.
	* doc/extend.texi (Generic Operand Modifiers): Document cc operand
	modifier.
	* doc/md.texi (@samp{:} in constraint): Mention the cc operand
	modifier and add small example.

2024-12-18  Jakub Jelinek  <jakub@redhat.com>

	* genpreds.cc (mangle): Add ':' mangling.
	(add_constraint): Allow : constraint.
	* common.md (:): New define_constraint.
	* stmt.cc (parse_output_constraint): Diagnose "=:".
	(parse_input_constraint): Handle ":" and diagnose invalid
	uses.
	* doc/md.texi (Simple Constraints): Document ":" constraint.

2024-12-18  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch.md (*crc_combine): New
	define_insn_and_split.

2024-12-18  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch.md (crc_rev<mode:SUBDI>si4): New
	define_expand.

2024-12-18  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch.md (@rbit<mode:GPR>): New
	define_insn template.
	(rbitsi_extended): New define_insn.
	(rbitqi): New define_insn.
	(rbithi): New define_expand.

2024-12-18  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch.md (QHSD): Remove.
	(loongarch_<crc>_w_<size>_w): Use QHSD instead of QHWD.
	(loongarch_<crc>_w_<size>_w_extended): Likewise.

2024-12-18  Sandra Loosemore  <sloosemore@baylibre.com>

	* doc/extend.texi (OpenACC): Fix paste-o.

2024-12-17  Sandra Loosemore  <sloosemore@baylibre.com>

	PR c/26154
	* common.opt.urls: Regenerated.
	* doc/extend.texi (C Extensions): Adjust menu for new sections.
	(Attribute Syntax): Mention OpenMP directives.
	(Pragmas): Mention OpenMP and OpenACC directives.
	(OpenMP): New section.
	(OpenACC): New section.
	* doc/invoke.texi (Invoking GCC): Adjust menu for new section.
	(Option Summary): Move OpenMP and OpenACC options to their own
	category.
	(C Dialect Options): Move documentation for -foffload, -fopenacc,
	-fopenacc-dim, -fopenmp, -fopenmd-simd, and
	-fopenmp-target-simd-clone to...
	(OpenMP and OpenACC Options): ...this new section.  Light
	copy-editing of the option descriptions.

2024-12-17  Richard Biener  <rguenther@suse.de>

	PR middle-end/118062
	* tree-vect-generic.cc (expand_vector_piecewise): Properly
	compute delta.

2024-12-17  Oliver Kozul  <Oliver.Kozul@rt-rk.com>

	* config/riscv/riscv.md (*lui_constraint<ANYI:mode>_and_to_or): New pattern

2024-12-17  Yangyu Chen  <cyy@cyyself.name>

	* common/config/riscv/riscv-ext-bitmask.def (RISCV_EXT_BITMASK): Remove svvptc.

2024-12-17  Anton Blanchard  <antonb@tenstorrent.com>

	* config/riscv/riscv-cores.def: Add tt-ascalon-d8.
	* config/riscv/riscv.cc (tt_ascalon_d8_tune_info): New.
	* doc/invoke.texi (RISC-V): Add tt-ascalon-d8 to -mcpu.

2024-12-17  Anton Blanchard  <antonb@tenstorrent.com>

	* doc/invoke.texi (RISC-V): Add thead-c906, xiangshan-nanhu to
	-mcpu, add generic-ooo and remove thead-c906 from -mtune.

2024-12-17  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/constraints.md (R): New constraint.
	* doc/md.texi: Document new constraint `R`.

2024-12-17  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/riscv.cc (riscv_print_operand): Add N.
	* doc/extend.texi: Document for N,

2024-12-17  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/corev.md (*cv_branch<mode>): Update modifier.
	(*branch<mode>): Ditto.
	* config/riscv/riscv.cc (riscv_print_operand): Update modifier.
	* config/riscv/riscv.md (*branch<mode>): Update modifier.

2024-12-17  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/constraints.md (cr): New.
	(cf): New.
	* config/riscv/riscv.h (reg_class): Add RVC_GR_REGS and
	RVC_FP_REGS.
	(REG_CLASS_NAMES): Ditto.
	(REG_CLASS_CONTENTS): Ditto.
	* doc/md.texi: Document cr and cf constraint.
	* config/riscv/riscv.cc (riscv_regno_to_class): Update
	FP_REGS to RVC_FP_REGS since it smaller set.
	(riscv_secondary_memory_needed): Handle RVC_FP_REGS.
	(riscv_register_move_cost): Ditto.

2024-12-17  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/constraints.md (c01): Rename to...
	(k01): ...this.
	(c02): Rename to...
	(k02): ...this.
	(c03): Rename to...
	(k03): ...this.
	(c04): Rename to...
	(k04): ...this.
	(c08): Rename to...
	(k08): ...this.
	* config/riscv/corev.md (riscv_cv_simd_add_h_si): Update
	constraints.
	(riscv_cv_simd_sub_h_si): Ditto.
	(riscv_cv_simd_cplxmul_i_si): Ditto.
	(riscv_cv_simd_subrotmj_si): Ditto.
	* config/riscv/riscv-v.cc (splat_to_scalar_move_p): Update
	constraints.
	* config/riscv/vector-iterators.md (stride_load_constraint):
	Update constraints.
	(stride_store_constraint): Ditto.

2024-12-17  Martin Jambor  <mjambor@suse.cz>

	* cgraph.h (symtab_node): Add a new overload of nonzero_address.
	* symtab.cc (symtab_node::nonzero_address): Add a new overload whith a
	parameter for delete_null_pointer_checks.  Make the original overload
	call the new one which has retains the actual implementation.
	* ipa-prop.h (ipa_get_range_from_ip_invariant): Declare.
	(ipa_range_set_and_normalize): Remove.
	* ipa-prop.cc (ipa_get_range_from_ip_invariant): New function.
	(ipa_range_set_and_normalize): Remove.
	* ipa-cp.cc (ipa_vr_intersect_with_arith_jfunc): Add a new parameter
	context_node. Use ipa_get_range_from_ip_invariant instead of
	ipa_range_set_and_normalize and pass to it the new parameter.
	(ipa_value_range_from_jfunc): Pass cs->caller as the context_node to
	ipa_vr_intersect_with_arith_jfunc.
	(propagate_vr_across_jump_function): Likewise.
	(ipa_get_range_from_ip_invariant): New function.
	* ipa-fnsummary.cc (evaluate_conditions_for_known_args): Use
	ipa_get_range_from_ip_invariant instead of ipa_range_set_and_normalize

2024-12-17  Martin Jambor  <mjambor@suse.cz>

	* ipa-prop.cc (ipa_compute_jump_functions_for_edge): Try harder to
	use the value range obtained from ranger for pointer values.

2024-12-17  Martin Jambor  <mjambor@suse.cz>

	* ipa-prop.cc: Include vr-values.h.
	(skip_a_safe_conversion_op): New function.
	(ipa_compute_jump_functions_for_edge): Use it.

2024-12-16  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/mmx.md: Fix tabs vs. spaces.

2024-12-16  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.cc (ix86_hard_regno_mode_ok):
	Remove explicit HImode handling for SSE2 XMM regnos.
	* config/i386/i386.h (VALID_SSE2_REG_MODE): Add HImode.

2024-12-16  David Malcolm  <dmalcolm@redhat.com>

	* libsarifreplay.cc (struct embedded_link): New.
	(maybe_consume_embedded_link): New.
	(sarif_replayer::make_plain_text_within_result_message): Handle
	embedded links by using the link text, for now.

2024-12-16  David Malcolm  <dmalcolm@redhat.com>

	* doc/libgdiagnostics/topics/logical-locations.rst
	(diagnostic_manager_new_logical_location): Add note about repeated
	calls.
	* libgdiagnostics.cc: Define INCLUDE_MAP.
	(class owned_nullable_string): Add copy ctor and move ctor.
	(owned_nullable_string::operator<): New.
	(diagnostic_logical_location::operator<): New.
	(diagnostic_manager::new_logical_location): Use m_logical_locs to
	"uniquify" instances, converting it to a std::map.
	(diagnostic_manager::logical_locs_map_t): New typedef.
	(diagnostic_manager::t m_logical_locs): Convert from a std::vector
	to a std::map.
	(diagnostic_execution_path::same_function_p): Update comment.

2024-12-16  David Malcolm  <dmalcolm@redhat.com>

	PR sarif-replay/117943
	* doc/libgdiagnostics/topics/physical-locations.rst
	(diagnostic_manager_new_file): Drop "const" from return type.
	* doc/libgdiagnostics/tutorial/02-physical-locations.rst: Drop
	"const" from "main_file" decl.
	* input.cc (file_cache::add_buffered_content): New.
	(file_cache_slot::set_content): New.
	(file_cache_slot::dump): Use m_file_path being null rather than
	m_fp to determine empty slots.  Dump m_fp.
	(find_end_of_line): Drop "const" from return type and param.  Add
	forward decl.
	(file_cache_slot::get_next_line): Fix "const"-ness.
	(selftest::test_reading_source_buffer): New.
	(selftest::input_cc_tests): Call it.
	* input.h (file_cache::add_buffered_content): New decl.
	* libgdiagnostics++.h (class file): Drop const-ness from m_inner.
	(file::set_buffered_content): New.
	* libgdiagnostics.cc (class content_buffer): New.
	(diagnostic_file::diagnostic_file): Add "mgr" param.
	(diagnostic_file::get_content): New.
	(diagnostic_file::set_buffered_content): New.
	(diagnostic_file::m_mgr): New.
	(diagnostic_file::m_content): New.
	(diagnostic_manager::new_file): Drop const-ness.  Pass *this to
	ctor.
	(diagnostic_file::set_buffered_content): New.
	(diagnostic_manager_new_file): Drop "const" from return type.
	(diagnostic_file_set_buffered_content): New entrypoint.
	(diagnostic_manager_debug_dump_file): Dump the content size,
	if any.
	* libgdiagnostics.h (diagnostic_manager_new_file): Drop "const"
	from return type.
	(diagnostic_file_set_buffered_content): New decl.
	* libgdiagnostics.map (diagnostic_file_set_buffered_content): New
	symbol.
	* libsarifreplay.cc (sarif_replayer::m_artifacts_arr): Convert
	from json::value to json::array.
	(sarif_replayer::handle_run_obj): Call handle_artifact_obj
	on all artifacts.
	(sarif_replayer::handle_artifact_obj): New.

2024-12-16  David Malcolm  <dmalcolm@redhat.com>

	PR sarif-replay/117943
	* diagnostic-format-text.cc
	(diagnostic_text_output_format::append_note): Use source-printing
	options from text_output.
	(diagnostic_text_output_format::update_printer): Copy
	source-printing options from dc.
	(default_diagnostic_text_finalizer): Use source-printing
	options from text_output.
	* diagnostic-format-text.h
	(diagnostic_text_output_format::diagnostic_text_output_format):
	Add optional diagnostic_source_printing_options param, using
	the context's if null.
	(diagnostic_text_output_format::get_source_printing_options): New
	accessor.
	(diagnostic_text_output_format::m_source_printing): New field.
	* diagnostic-path.cc (event_range::print): Use source-printing
	options from text_output.
	(selftest::test_interprocedural_path_1): Use source-printing
	options from dc.
	* diagnostic-show-locus.cc
	(gcc_rich_location::add_location_if_nearby): Likewise.
	(diagnostic_context::maybe_show_locus): Add "opts" param
	and use in place of m_source_printing.  Pass it to source_policy
	ctor.
	(diagnostic_source_print_policy::diagnostic_source_print_policy):
	Add overload taking a const diagnostic_source_printing_options &.
	* diagnostic.cc (diagnostic_context::initialize): Pass nullptr
	for source options when creating text sink, so that it uses
	the dc's options.
	(diagnostic_context::dump): Add an "output sinks:" heading and
	print "(none)" if there aren't any.
	(diagnostic_context::set_output_format): Split out code into...
	(diagnostic_context::remove_all_output_sinks): ...this new
	function.
	* diagnostic.h
	(diagnostic_source_print_policy::diagnostic_source_print_policy):
	Add overload taking a const diagnostic_source_printing_options &.
	(diagnostic_context::maybe_show_locus): Add "opts" param.
	(diagnostic_context::remove_all_output_sinks): New decl.
	(diagnostic_context::m_source_printing): New field.
	(diagnostic_show_locus): Add "opts" param and pass to
	maybe_show_locus.
	* libgdiagnostics.cc (sink::~sink): Delete.
	(sink::begin_group): Delete.
	(sink::end_group): Delete.
	(sink::emit): Delete.
	(sink::m_dc): Drop field.
	(diagnostic_text_sink::on_begin_text_diagnostic): Delete.
	(diagnostic_text_sink::get_source_printing_options): Use
	m_souece_printing.
	(diagnostic_text_sink::m_current_logical_loc): Drop field.
	(diagnostic_text_sink::m_inner_sink): New field.
	(diagnostic_text_sink::m_source_printing): New field.
	(diagnostic_manager::diagnostic_manager): Update for changes
	to fields.  Initialize m_dc.
	(diagnostic_manager::~diagnostic_manager): Call diagnostic_finish.
	(diagnostic_manager::get_file_cache): Drop.
	(diagnostic_manager::get_dc): New accessor.
	(diagnostic_manager::begin_group): Reimplement.
	(diagnostic_manager::end_group): Reimplement.
	(diagnostic_manager::get_prev_diag_logical_loc): New accessor.
	(diagnostic_manager::m_dc): New field.
	(diagnostic_manager::m_file_cache): Drop field.
	(diagnostic_manager::m_edit_context): Convert to a std::unique_ptr
	so that object can be constructed after m_dc is initialized.
	(diagnostic_manager::m_prev_diag_logical_loc): New field.
	(diagnostic_text_sink::diagnostic_text_sink): Reimplement.
	(get_color_rule): Delete.
	(diagnostic_text_sink::set_colorize): Reimplement.
	(diagnostic_text_sink::text_starter): New.
	(sarif_sink::sarif_sink): Reimplement.
	(diagnostic_manager::write_patch): Update for change to
	m_edit_context.
	(diagnostic_manager::emit): Update now that each sink has a
	corresponding diagnostic_output_format object within m_dc.

2024-12-16  David Malcolm  <dmalcolm@redhat.com>

	* diagnostic.cc (diagnostic_context::dump): Dump m_file_cache.
	* input.cc (file_cache_slot::dump): New decls and implementations.
	(file_cache::dump): New.
	* input.h (file_cache::dump): New decl.

2024-12-16  Robin Dapp  <rdapp@ventanamicro.com>

	* doc/md.texi: Add "3" suffix.

2024-12-16  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/112694
	PR target/116611.
	* config/riscv/riscv-v.cc (expand_vec_perm_const): Remove early
	return.
	* tree-vect-slp.cc (can_duplicate_and_interleave_p): Return
	false when we cannot create sub-elements.

2024-12-16  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/117383
	* config/riscv/riscv-protos.h (enum insn_type): Use TU policy.
	* config/riscv/riscv-v.cc (shuffle_compress_patterns): Set VL.

2024-12-16  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/118019
	* config/riscv/riscv.cc (riscv_builtin_vectorization_cost):
	Increase vec_construct cost.

2024-12-16  Mark Harmstone  <mark@harmstone.com>

	* dwarf2codeview.cc (write_s_frameproc): Align output.
	(write_s_inlinesite): Align output.

2024-12-15  John David Anglin  <danglin@gcc.gnu.org>

	PR target/118018
	* config/pa/pa.cc (pa_frame_pointer_required): Declare and
	implement.
	(TARGET_FRAME_POINTER_REQUIRED): Define.

2024-12-15  Tamar Christina  <tamar.christina@arm.com>

	* config/arm/arm-mve-builtins-base.cc (expand): Initialize new_base.

2024-12-15  Jakub Jelinek  <jakub@redhat.com>

	* tree-core.h (struct tree_exp): Remove condition_uid member.
	* tree.h (SET_EXPR_UID, EXPR_COND_UID): Remove.
	* gimplify.cc (nextuid): Rename to ...
	(nextconduid): ... this.
	(cond_uids): New static variable.
	(next_cond_uid, reset_cond_uid): Adjust for the renaming,
	formatting fix.
	(tree_associate_condition_with_expr): New function.
	(shortcut_cond_r, tag_shortcut_cond, shortcut_cond_expr): Use it
	instead of SET_EXPR_UID.
	(gimplify_cond_expr): Look up cond_uid in cond_uids hash map if
	non-NULL instead of using EXPR_COND_UID.
	(gimplify_function_tree): Delete cond_uids and set it to NULL.

2024-12-14  Jovan Vukic  <Jovan.Vukic@rt-rk.com>

	* match.pd: New pattern.
	* simplify-rtx.cc (match_plus_neg_pattern): New helper function.
	(simplify_context::simplify_binary_operation_1): New
	code to handle (a - 1) & -a, (a - 1) | -a and (a - 1) ^ -a.

2024-12-14  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* config/bpf/bpf.cc (bpf_resolve_overloaded_builtin): Add argument
	`complain'.

2024-12-14  Heiko Eißfeldt  <heiko@hexco.de>

	* doc/install.texi (Configuration): Fix typos in documentation
	for --enable-host-pie.

2024-12-14  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/118023
	* gimple-fold.cc (decode_field_reference): Return NULL_TREE if
	inner has non-type_has_mode_precision_p integral type.

2024-12-14  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/118024
	* gimple-ssa-warn-access.cc (matching_alloc_calls_p): Walk malloc
	attributes of alloc_decl and dealloc_decl in separate loops rather
	than in lock-step.  Use common_deallocs.contains rather than
	common_deallocs.add in the second loop.

2024-12-14  Jakub Jelinek  <jakub@redhat.com>

	PR c/118011
	* opts.cc (init_options_struct): Don't set opts->x_flag_short_enums to
	2.
	* toplev.cc (process_options): Test !OPTION_SET_P (flag_short_enums)
	rather than flag_short_enums == 2.

2024-12-13  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/117095
	* cse.cc (cse_extended_basic_block): Don't call record_jump_equiv
	if multiple_sets (insn).

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>
	    Jakub Jelinek  <jakub@redhat.com>

	PR target/114801
	* config/arm/arm-mve-builtins.cc
	(function_expander::add_input_operand): Handle CONST_INT
	predicates.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-base.cc (class vst24_impl): New.
	(class vld24_impl): New.
	(vld2q, vld4q, vst2q, vst4q): New.
	* config/arm/arm-mve-builtins-base.def (vld2q, vld4q, vst2q)
	(vst4q): New.
	* config/arm/arm-mve-builtins-base.h (vld2q, vld4q, vst2q, vst4q):
	New.
	* config/arm/arm-mve-builtins.cc (register_builtin_tuple_types):
	Add more asserts.
	* config/arm/arm.cc (TARGET_ARRAY_MODE): New.
	(output_move_neon): Handle MVE struct modes.
	(arm_print_operand_address): Likewise.
	(arm_hard_regno_mode_ok): Likewise.
	(arm_array_mode): New.
	* config/arm/arm.h (VALID_MVE_STRUCT_MODE): Likewise.
	* config/arm/arm_mve.h (vst4q): Delete.
	(vst2q): Delete.
	(vld2q): Delete.
	(vld4q): Delete.
	(vst4q_s8): Delete.
	(vst4q_s16): Delete.
	(vst4q_s32): Delete.
	(vst4q_u8): Delete.
	(vst4q_u16): Delete.
	(vst4q_u32): Delete.
	(vst4q_f16): Delete.
	(vst4q_f32): Delete.
	(vst2q_s8): Delete.
	(vst2q_u8): Delete.
	(vld2q_s8): Delete.
	(vld2q_u8): Delete.
	(vld4q_s8): Delete.
	(vld4q_u8): Delete.
	(vst2q_s16): Delete.
	(vst2q_u16): Delete.
	(vld2q_s16): Delete.
	(vld2q_u16): Delete.
	(vld4q_s16): Delete.
	(vld4q_u16): Delete.
	(vst2q_s32): Delete.
	(vst2q_u32): Delete.
	(vld2q_s32): Delete.
	(vld2q_u32): Delete.
	(vld4q_s32): Delete.
	(vld4q_u32): Delete.
	(vld4q_f16): Delete.
	(vld2q_f16): Delete.
	(vst2q_f16): Delete.
	(vld4q_f32): Delete.
	(vld2q_f32): Delete.
	(vst2q_f32): Delete.
	(__arm_vst4q_s8): Delete.
	(__arm_vst4q_s16): Delete.
	(__arm_vst4q_s32): Delete.
	(__arm_vst4q_u8): Delete.
	(__arm_vst4q_u16): Delete.
	(__arm_vst4q_u32): Delete.
	(__arm_vst2q_s8): Delete.
	(__arm_vst2q_u8): Delete.
	(__arm_vld2q_s8): Delete.
	(__arm_vld2q_u8): Delete.
	(__arm_vld4q_s8): Delete.
	(__arm_vld4q_u8): Delete.
	(__arm_vst2q_s16): Delete.
	(__arm_vst2q_u16): Delete.
	(__arm_vld2q_s16): Delete.
	(__arm_vld2q_u16): Delete.
	(__arm_vld4q_s16): Delete.
	(__arm_vld4q_u16): Delete.
	(__arm_vst2q_s32): Delete.
	(__arm_vst2q_u32): Delete.
	(__arm_vld2q_s32): Delete.
	(__arm_vld2q_u32): Delete.
	(__arm_vld4q_s32): Delete.
	(__arm_vld4q_u32): Delete.
	(__arm_vst4q_f16): Delete.
	(__arm_vst4q_f32): Delete.
	(__arm_vld4q_f16): Delete.
	(__arm_vld2q_f16): Delete.
	(__arm_vst2q_f16): Delete.
	(__arm_vld4q_f32): Delete.
	(__arm_vld2q_f32): Delete.
	(__arm_vst2q_f32): Delete.
	(__arm_vst4q): Delete.
	(__arm_vst2q): Delete.
	(__arm_vld2q): Delete.
	(__arm_vld4q): Delete.
	* config/arm/arm_mve_builtins.def (vst4q, vst2q, vld4q, vld2q):
	Delete.
	* config/arm/iterators.md (VSTRUCT): Add V2x16QI, V2x8HI, V2x4SI,
	V2x8HF, V2x4SF, V4x16QI, V4x8HI, V4x4SI, V4x8HF, V4x4SF.
	(MVE_VLD2_VST2, MVE_vld2_vst2, MVE_VLD4_VST4, MVE_vld4_vst4): New.
	* config/arm/mve.md (mve_vst4q<mode>): Update into ...
	(@mve_vst4q<mode>): ... this.
	(mve_vst2q<mode>): Update into ...
	(@mve_vst2q<mode>): ... this.
	(mve_vld2q<mode>): Update into ...
	(@mve_vld2q<mode>): ... this.
	(mve_vld4q<mode>): Update into ...
	(@mve_vld4q<mode>): ... this.
	* config/arm/vec-common.md (vec_load_lanesoi<mode>) Remove MVE
	support.
	(vec_load_lanesxi<mode>): Likewise.
	(vec_store_lanesoi<mode>): Likewise.
	(vec_store_lanesxi<mode>): Likewise.
	(vec_load_lanes<MVE_vld2_vst2><mode>):
	New.
	(vec_store_lanes<MVE_vld2_vst2><mode>): New.
	(vec_load_lanes<MVE_vld4_vst4><mode>): New.
	(vec_store_lanes<MVE_vld4_vst4><mode>): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (struct store_def): Add
	support for tuples.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (parse_type): Fix access
	to acle_vector_types.
	* config/arm/arm-mve-builtins.cc (wrap_type_in_struct): New.
	(register_type_decl): New.
	(register_builtin_tuple_types): Fix support for tuples.
	(function_resolver::infer_tuple_type): New.
	* config/arm/arm-mve-builtins.h
	(function_resolver::infer_tuple_type): Declare.
	(function_instance::tuple_type): Fix access to acle_vector_types.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-modes.def (MVE_STRUCT_MODES): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/iterators.md (MVE_vecs): Remove V2DF.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/mve.md (mve_vec_extract_sext_internal): Fix
	condition.
	(mve_vec_extract_zext_internal): Likewise.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-base.cc (vstrq_impl): Remove
	call_properties.
	(vldrq_impl): Likewise.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_ldrgbwbxu_qualifiers)
	(arm_ldrgbwbxu_z_qualifiers, arm_ldrgbwbs_qualifiers)
	(arm_ldrgbwbu_qualifiers, arm_ldrgbwbs_z_qualifiers)
	(arm_ldrgbwbu_z_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (vldrq_gather_base_impl):
	Add support for MODE_wb.
	* config/arm/arm-mve-builtins-shapes.cc (struct
	load_gather_base_def): Likewise.
	* config/arm/arm_mve.h (vldrdq_gather_base_wb_s64): Delete.
	(vldrdq_gather_base_wb_u64): Delete.
	(vldrdq_gather_base_wb_z_s64): Delete.
	(vldrdq_gather_base_wb_z_u64): Delete.
	(vldrwq_gather_base_wb_f32): Delete.
	(vldrwq_gather_base_wb_s32): Delete.
	(vldrwq_gather_base_wb_u32): Delete.
	(vldrwq_gather_base_wb_z_f32): Delete.
	(vldrwq_gather_base_wb_z_s32): Delete.
	(vldrwq_gather_base_wb_z_u32): Delete.
	(__arm_vldrdq_gather_base_wb_s64): Delete.
	(__arm_vldrdq_gather_base_wb_u64): Delete.
	(__arm_vldrdq_gather_base_wb_z_s64): Delete.
	(__arm_vldrdq_gather_base_wb_z_u64): Delete.
	(__arm_vldrwq_gather_base_wb_s32): Delete.
	(__arm_vldrwq_gather_base_wb_u32): Delete.
	(__arm_vldrwq_gather_base_wb_z_s32): Delete.
	(__arm_vldrwq_gather_base_wb_z_u32): Delete.
	(__arm_vldrwq_gather_base_wb_f32): Delete.
	(__arm_vldrwq_gather_base_wb_z_f32): Delete.
	* config/arm/arm_mve_builtins.def (vldrwq_gather_base_nowb_z_u)
	(vldrdq_gather_base_nowb_z_u, vldrwq_gather_base_nowb_u)
	(vldrdq_gather_base_nowb_u, vldrwq_gather_base_nowb_z_s)
	(vldrwq_gather_base_nowb_z_f, vldrdq_gather_base_nowb_z_s)
	(vldrwq_gather_base_nowb_s, vldrwq_gather_base_nowb_f)
	(vldrdq_gather_base_nowb_s, vldrdq_gather_base_wb_z_s)
	(vldrdq_gather_base_wb_z_u, vldrdq_gather_base_wb_s)
	(vldrdq_gather_base_wb_u, vldrwq_gather_base_wb_z_s)
	(vldrwq_gather_base_wb_z_f, vldrwq_gather_base_wb_z_u)
	(vldrwq_gather_base_wb_s, vldrwq_gather_base_wb_f)
	(vldrwq_gather_base_wb_u): Delete
	* config/arm/iterators.md (supf): Remove VLDRWQGBWB_S,
	VLDRWQGBWB_U, VLDRDQGBWB_S, VLDRDQGBWB_U.
	(VLDRWGBWBQ, VLDRDGBWBQ): Delete.
	* config/arm/mve.md (mve_vldrwq_gather_base_wb_<supf>v4si): Delete.
	(mve_vldrwq_gather_base_nowb_<supf>v4si): Delete.
	(mve_vldrwq_gather_base_wb_<supf>v4si_insn): Delete.
	(mve_vldrwq_gather_base_wb_z_<supf>v4si): Delete.
	(mve_vldrwq_gather_base_nowb_z_<supf>v4si): Delete.
	(mve_vldrwq_gather_base_wb_z_<supf>v4si_insn): Delete.
	(mve_vldrwq_gather_base_wb_fv4sf): Delete.
	(mve_vldrwq_gather_base_nowb_fv4sf): Delete.
	(mve_vldrwq_gather_base_wb_fv4sf_insn): Delete.
	(mve_vldrwq_gather_base_wb_z_fv4sf): Delete.
	(mve_vldrwq_gather_base_nowb_z_fv4sf): Delete.
	(mve_vldrwq_gather_base_wb_z_fv4sf_insn): Delete.
	(mve_vldrdq_gather_base_wb_<supf>v2di): Delete.
	(mve_vldrdq_gather_base_nowb_<supf>v2di): Delete.
	(mve_vldrdq_gather_base_wb_<supf>v2di_insn): Delete.
	(mve_vldrdq_gather_base_wb_z_<supf>v2di): Delete.
	(mve_vldrdq_gather_base_nowb_z_<supf>v2di): Delete.
	(mve_vldrdq_gather_base_wb_z_<supf>v2di_insn): Delete.
	(@mve_vldrq_gather_base_wb_<mode>): New.
	(@mve_vldrq_gather_base_wb_z_<mode>): New.
	* config/arm/unspecs.md (VLDRWQGBWB_S, VLDRWQGBWB_U, VLDRWQGBWB_F)
	(VLDRDQGBWB_S, VLDRDQGBWB_U): Delete
	(VLDRGBWBQ, VLDRGBWBQ_Z): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_ldrgbs_qualifiers)
	(arm_ldrgbu_qualifiers, arm_ldrgbs_z_qualifiers)
	(arm_ldrgbu_z_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (class
	vldrq_gather_base_impl): New.
	(vldrdq_gather_base, vldrwq_gather_base): New.
	* config/arm/arm-mve-builtins-base.def (vldrdq_gather_base)
	(vldrwq_gather_base): New.
	* config/arm/arm-mve-builtins-base.h: (vldrdq_gather_base)
	(vldrwq_gather_base): New.
	* config/arm/arm_mve.h (vldrwq_gather_base_s32): Delete.
	(vldrwq_gather_base_u32): Delete.
	(vldrwq_gather_base_z_u32): Delete.
	(vldrwq_gather_base_z_s32): Delete.
	(vldrdq_gather_base_s64): Delete.
	(vldrdq_gather_base_u64): Delete.
	(vldrdq_gather_base_z_s64): Delete.
	(vldrdq_gather_base_z_u64): Delete.
	(vldrwq_gather_base_f32): Delete.
	(vldrwq_gather_base_z_f32): Delete.
	(__arm_vldrwq_gather_base_s32): Delete.
	(__arm_vldrwq_gather_base_u32): Delete.
	(__arm_vldrwq_gather_base_z_s32): Delete.
	(__arm_vldrwq_gather_base_z_u32): Delete.
	(__arm_vldrdq_gather_base_s64): Delete.
	(__arm_vldrdq_gather_base_u64): Delete.
	(__arm_vldrdq_gather_base_z_s64): Delete.
	(__arm_vldrdq_gather_base_z_u64): Delete.
	(__arm_vldrwq_gather_base_f32): Delete.
	(__arm_vldrwq_gather_base_z_f32): Delete.
	* config/arm/arm_mve_builtins.def (vldrwq_gather_base_s)
	(vldrwq_gather_base_u, vldrwq_gather_base_z_s)
	(vldrwq_gather_base_z_u, vldrdq_gather_base_s)
	(vldrwq_gather_base_f, vldrdq_gather_base_z_s)
	(vldrwq_gather_base_z_f, vldrdq_gather_base_u)
	(vldrdq_gather_base_z_u): Delete.
	* config/arm/iterators.md (supf): Remove VLDRWQGB_S, VLDRWQGB_U,
	VLDRDQGB_S, VLDRDQGB_U.
	(VLDRWGBQ, VLDRDGBQ): Delete.
	* config/arm/mve.md (mve_vldrwq_gather_base_<supf>v4si): Delete.
	(mve_vldrwq_gather_base_z_<supf>v4si): Delete.
	(mve_vldrdq_gather_base_<supf>v2di): Delete.
	(mve_vldrdq_gather_base_z_<supf>v2di): Delete.
	(mve_vldrwq_gather_base_fv4sf): Delete.
	(mve_vldrwq_gather_base_z_fv4sf): Delete.
	(@mve_vldrq_gather_base_<mode>): New.
	(@mve_vldrq_gather_base_z_<mode>): New.
	* config/arm/unspecs.md (VLDRWQGB_S, VLDRWQGB_U, VLDRDQGB_S)
	(VLDRDQGB_U, VLDRWQGB_F): Delete.
	(VLDRGBQ, VLDRGBQ_Z): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (struct
	load_gather_base_def): New.
	* config/arm/arm-mve-builtins-shapes.h: (load_gather_base): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_ldrgu_qualifiers)
	(arm_ldrgs_qualifiers, arm_ldrgs_z_qualifiers)
	(arm_ldrgu_z_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (vldrq_gather_impl): Add
	support for shifted version.
	(vldrdq_gather_shifted, vldrhq_gather_shifted)
	(vldrwq_gather_shifted): New.
	* config/arm/arm-mve-builtins-base.def (vldrdq_gather_shifted)
	(vldrhq_gather_shifted, vldrwq_gather_shifted): New.
	* config/arm/arm-mve-builtins-base.h (vldrdq_gather_shifted)
	(vldrhq_gather_shifted, vldrwq_gather_shifted): New.
	* config/arm/arm_mve.h (vldrhq_gather_shifted_offset): Delete.
	(vldrhq_gather_shifted_offset_z): Delete.
	(vldrdq_gather_shifted_offset): Delete.
	(vldrdq_gather_shifted_offset_z): Delete.
	(vldrwq_gather_shifted_offset): Delete.
	(vldrwq_gather_shifted_offset_z): Delete.
	(vldrhq_gather_shifted_offset_s32): Delete.
	(vldrhq_gather_shifted_offset_s16): Delete.
	(vldrhq_gather_shifted_offset_u32): Delete.
	(vldrhq_gather_shifted_offset_u16): Delete.
	(vldrhq_gather_shifted_offset_z_s32): Delete.
	(vldrhq_gather_shifted_offset_z_s16): Delete.
	(vldrhq_gather_shifted_offset_z_u32): Delete.
	(vldrhq_gather_shifted_offset_z_u16): Delete.
	(vldrdq_gather_shifted_offset_s64): Delete.
	(vldrdq_gather_shifted_offset_u64): Delete.
	(vldrdq_gather_shifted_offset_z_s64): Delete.
	(vldrdq_gather_shifted_offset_z_u64): Delete.
	(vldrhq_gather_shifted_offset_f16): Delete.
	(vldrhq_gather_shifted_offset_z_f16): Delete.
	(vldrwq_gather_shifted_offset_f32): Delete.
	(vldrwq_gather_shifted_offset_s32): Delete.
	(vldrwq_gather_shifted_offset_u32): Delete.
	(vldrwq_gather_shifted_offset_z_f32): Delete.
	(vldrwq_gather_shifted_offset_z_s32): Delete.
	(vldrwq_gather_shifted_offset_z_u32): Delete.
	(__arm_vldrhq_gather_shifted_offset_s32): Delete.
	(__arm_vldrhq_gather_shifted_offset_s16): Delete.
	(__arm_vldrhq_gather_shifted_offset_u32): Delete.
	(__arm_vldrhq_gather_shifted_offset_u16): Delete.
	(__arm_vldrhq_gather_shifted_offset_z_s32): Delete.
	(__arm_vldrhq_gather_shifted_offset_z_s16): Delete.
	(__arm_vldrhq_gather_shifted_offset_z_u32): Delete.
	(__arm_vldrhq_gather_shifted_offset_z_u16): Delete.
	(__arm_vldrdq_gather_shifted_offset_s64): Delete.
	(__arm_vldrdq_gather_shifted_offset_u64): Delete.
	(__arm_vldrdq_gather_shifted_offset_z_s64): Delete.
	(__arm_vldrdq_gather_shifted_offset_z_u64): Delete.
	(__arm_vldrwq_gather_shifted_offset_s32): Delete.
	(__arm_vldrwq_gather_shifted_offset_u32): Delete.
	(__arm_vldrwq_gather_shifted_offset_z_s32): Delete.
	(__arm_vldrwq_gather_shifted_offset_z_u32): Delete.
	(__arm_vldrhq_gather_shifted_offset_f16): Delete.
	(__arm_vldrhq_gather_shifted_offset_z_f16): Delete.
	(__arm_vldrwq_gather_shifted_offset_f32): Delete.
	(__arm_vldrwq_gather_shifted_offset_z_f32): Delete.
	(__arm_vldrhq_gather_shifted_offset): Delete.
	(__arm_vldrhq_gather_shifted_offset_z): Delete.
	(__arm_vldrdq_gather_shifted_offset): Delete.
	(__arm_vldrdq_gather_shifted_offset_z): Delete.
	(__arm_vldrwq_gather_shifted_offset): Delete.
	(__arm_vldrwq_gather_shifted_offset_z): Delete.
	* config/arm/arm_mve_builtins.def
	(vldrhq_gather_shifted_offset_z_u, vldrhq_gather_shifted_offset_u)
	(vldrhq_gather_shifted_offset_z_s, vldrhq_gather_shifted_offset_s)
	(vldrdq_gather_shifted_offset_s, vldrhq_gather_shifted_offset_f)
	(vldrwq_gather_shifted_offset_f, vldrwq_gather_shifted_offset_s)
	(vldrdq_gather_shifted_offset_z_s)
	(vldrhq_gather_shifted_offset_z_f)
	(vldrwq_gather_shifted_offset_z_f)
	(vldrwq_gather_shifted_offset_z_s, vldrdq_gather_shifted_offset_u)
	(vldrwq_gather_shifted_offset_u, vldrdq_gather_shifted_offset_z_u)
	(vldrwq_gather_shifted_offset_z_u): Delete.
	* config/arm/iterators.md (supf): Remove VLDRHQGSO_S, VLDRHQGSO_U,
	VLDRDQGSO_S, VLDRDQGSO_U, VLDRWQGSO_S, VLDRWQGSO_U.
	(VLDRHGSOQ, VLDRDGSOQ, VLDRWGSOQ): Delete.
	* config/arm/mve.md
	(mve_vldrhq_gather_shifted_offset_<supf><mode>): Delete.
	(mve_vldrhq_gather_shifted_offset_z_<supf><mode>): Delete.
	(mve_vldrdq_gather_shifted_offset_<supf>v2di): Delete.
	(mve_vldrdq_gather_shifted_offset_z_<supf>v2di): Delete.
	(mve_vldrhq_gather_shifted_offset_fv8hf): Delete.
	(mve_vldrhq_gather_shifted_offset_z_fv8hf): Delete.
	(mve_vldrwq_gather_shifted_offset_fv4sf): Delete.
	(mve_vldrwq_gather_shifted_offset_<supf>v4si): Delete.
	(mve_vldrwq_gather_shifted_offset_z_fv4sf): Delete.
	(mve_vldrwq_gather_shifted_offset_z_<supf>v4si): Delete.
	(@mve_vldrq_gather_shifted_offset_<mode>): New.
	(@mve_vldrq_gather_shifted_offset_extend_v4si<US>): New.
	(@mve_vldrq_gather_shifted_offset_z_<mode>): New.
	(@mve_vldrq_gather_shifted_offset_z_extend_v4si<US>): New.
	* config/arm/unspecs.md (VLDRHQGSO_S, VLDRHQGSO_U, VLDRDQGSO_S)
	(VLDRDQGSO_U, VLDRHQGSO_F, VLDRWQGSO_F, VLDRWQGSO_S, VLDRWQGSO_U):
	Delete.
	(VLDRGSOQ, VLDRGSOQ_Z, VLDRGSOQ_EXT, VLDRGSOQ_EXT_Z): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-base.cc (class vldrq_gather_impl):
	New.
	(vldrbq_gather, vldrdq_gather, vldrhq_gather, vldrwq_gather): New.
	* config/arm/arm-mve-builtins-base.def (vldrbq_gather)
	(vldrdq_gather, vldrhq_gather, vldrwq_gather): New.
	* config/arm/arm-mve-builtins-base.h (vldrbq_gather)
	(vldrdq_gather, vldrhq_gather, vldrwq_gather): New.
	* config/arm/arm_mve.h (vldrbq_gather_offset): Delete.
	(vldrbq_gather_offset_z): Delete.
	(vldrhq_gather_offset): Delete.
	(vldrhq_gather_offset_z): Delete.
	(vldrdq_gather_offset): Delete.
	(vldrdq_gather_offset_z): Delete.
	(vldrwq_gather_offset): Delete.
	(vldrwq_gather_offset_z): Delete.
	(vldrbq_gather_offset_u8): Delete.
	(vldrbq_gather_offset_s8): Delete.
	(vldrbq_gather_offset_u16): Delete.
	(vldrbq_gather_offset_s16): Delete.
	(vldrbq_gather_offset_u32): Delete.
	(vldrbq_gather_offset_s32): Delete.
	(vldrbq_gather_offset_z_s16): Delete.
	(vldrbq_gather_offset_z_u8): Delete.
	(vldrbq_gather_offset_z_s32): Delete.
	(vldrbq_gather_offset_z_u16): Delete.
	(vldrbq_gather_offset_z_u32): Delete.
	(vldrbq_gather_offset_z_s8): Delete.
	(vldrhq_gather_offset_s32): Delete.
	(vldrhq_gather_offset_s16): Delete.
	(vldrhq_gather_offset_u32): Delete.
	(vldrhq_gather_offset_u16): Delete.
	(vldrhq_gather_offset_z_s32): Delete.
	(vldrhq_gather_offset_z_s16): Delete.
	(vldrhq_gather_offset_z_u32): Delete.
	(vldrhq_gather_offset_z_u16): Delete.
	(vldrdq_gather_offset_s64): Delete.
	(vldrdq_gather_offset_u64): Delete.
	(vldrdq_gather_offset_z_s64): Delete.
	(vldrdq_gather_offset_z_u64): Delete.
	(vldrhq_gather_offset_f16): Delete.
	(vldrhq_gather_offset_z_f16): Delete.
	(vldrwq_gather_offset_f32): Delete.
	(vldrwq_gather_offset_s32): Delete.
	(vldrwq_gather_offset_u32): Delete.
	(vldrwq_gather_offset_z_f32): Delete.
	(vldrwq_gather_offset_z_s32): Delete.
	(vldrwq_gather_offset_z_u32): Delete.
	(__arm_vldrbq_gather_offset_u8): Delete.
	(__arm_vldrbq_gather_offset_s8): Delete.
	(__arm_vldrbq_gather_offset_u16): Delete.
	(__arm_vldrbq_gather_offset_s16): Delete.
	(__arm_vldrbq_gather_offset_u32): Delete.
	(__arm_vldrbq_gather_offset_s32): Delete.
	(__arm_vldrbq_gather_offset_z_s8): Delete.
	(__arm_vldrbq_gather_offset_z_s32): Delete.
	(__arm_vldrbq_gather_offset_z_s16): Delete.
	(__arm_vldrbq_gather_offset_z_u8): Delete.
	(__arm_vldrbq_gather_offset_z_u32): Delete.
	(__arm_vldrbq_gather_offset_z_u16): Delete.
	(__arm_vldrhq_gather_offset_s32): Delete.
	(__arm_vldrhq_gather_offset_s16): Delete.
	(__arm_vldrhq_gather_offset_u32): Delete.
	(__arm_vldrhq_gather_offset_u16): Delete.
	(__arm_vldrhq_gather_offset_z_s32): Delete.
	(__arm_vldrhq_gather_offset_z_s16): Delete.
	(__arm_vldrhq_gather_offset_z_u32): Delete.
	(__arm_vldrhq_gather_offset_z_u16): Delete.
	(__arm_vldrdq_gather_offset_s64): Delete.
	(__arm_vldrdq_gather_offset_u64): Delete.
	(__arm_vldrdq_gather_offset_z_s64): Delete.
	(__arm_vldrdq_gather_offset_z_u64): Delete.
	(__arm_vldrwq_gather_offset_s32): Delete.
	(__arm_vldrwq_gather_offset_u32): Delete.
	(__arm_vldrwq_gather_offset_z_s32): Delete.
	(__arm_vldrwq_gather_offset_z_u32): Delete.
	(__arm_vldrhq_gather_offset_f16): Delete.
	(__arm_vldrhq_gather_offset_z_f16): Delete.
	(__arm_vldrwq_gather_offset_f32): Delete.
	(__arm_vldrwq_gather_offset_z_f32): Delete.
	(__arm_vldrbq_gather_offset): Delete.
	(__arm_vldrbq_gather_offset_z): Delete.
	(__arm_vldrhq_gather_offset): Delete.
	(__arm_vldrhq_gather_offset_z): Delete.
	(__arm_vldrdq_gather_offset): Delete.
	(__arm_vldrdq_gather_offset_z): Delete.
	(__arm_vldrwq_gather_offset): Delete.
	(__arm_vldrwq_gather_offset_z): Delete.
	* config/arm/arm_mve_builtins.def (vldrbq_gather_offset_u)
	(vldrbq_gather_offset_s, vldrbq_gather_offset_z_s)
	(vldrbq_gather_offset_z_u, vldrhq_gather_offset_z_u)
	(vldrhq_gather_offset_u, vldrhq_gather_offset_z_s)
	(vldrhq_gather_offset_s, vldrdq_gather_offset_s)
	(vldrhq_gather_offset_f, vldrwq_gather_offset_f)
	(vldrwq_gather_offset_s, vldrdq_gather_offset_z_s)
	(vldrhq_gather_offset_z_f, vldrwq_gather_offset_z_f)
	(vldrwq_gather_offset_z_s, vldrdq_gather_offset_u)
	(vldrwq_gather_offset_u, vldrdq_gather_offset_z_u)
	(vldrwq_gather_offset_z_u): Delete.
	* config/arm/iterators.md (MVE_u_elem): New.
	(supf): Remove VLDRBQGO_S, VLDRBQGO_U, VLDRHQGO_S, VLDRHQGO_U,
	VLDRDQGO_S, VLDRDQGO_U, VLDRWQGO_S, VLDRWQGO_U.
	(VLDRBGOQ, VLDRHGOQ, VLDRDGOQ, VLDRWGOQ): Delete.
	* config/arm/mve.md (mve_vldrbq_gather_offset_<supf><mode>):
	Delete.
	(mve_vldrbq_gather_offset_z_<supf><mode>): Delete.
	(mve_vldrhq_gather_offset_<supf><mode>): Delete.
	(mve_vldrhq_gather_offset_z_<supf><mode>): Delete.
	(mve_vldrdq_gather_offset_<supf>v2di): Delete.
	(mve_vldrdq_gather_offset_z_<supf>v2di): Delete.
	(mve_vldrhq_gather_offset_fv8hf): Delete.
	(mve_vldrhq_gather_offset_z_fv8hf): Delete.
	(mve_vldrwq_gather_offset_fv4sf): Delete.
	(mve_vldrwq_gather_offset_<supf>v4si): Delete.
	(mve_vldrwq_gather_offset_z_fv4sf): Delete.
	(mve_vldrwq_gather_offset_z_<supf>v4si): Delete.
	(@mve_vldrq_gather_offset_<mode>): New.
	(@mve_vldrq_gather_offset_extend_<mode><US>): New.
	(@mve_vldrq_gather_offset_z_<mode>): New.
	(@mve_vldrq_gather_offset_z_extend_<mode><US>): New.
	* config/arm/unspecs.md (VLDRBQGO_S, VLDRBQGO_U, VLDRHQGO_S)
	(VLDRHQGO_U, VLDRDQGO_S, VLDRDQGO_U, VLDRHQGO_F, VLDRWQGO_F)
	(VLDRWQGO_S, VLDRWQGO_U): Delete.
	(VLDRGOQ, VLDRGOQ_Z, VLDRGOQ_EXT, VLDRGOQ_EXT_Z): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (struct load_ext_gather):
	New.
	(struct load_ext_gather_offset_def): New.
	* config/arm/arm-mve-builtins-shapes.h (load_ext_gather_offset):
	New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_strsbwbs_qualifiers)
	(arm_strsbwbu_qualifiers, arm_strsbwbs_p_qualifiers)
	(arm_strsbwbu_p_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (vstrq_scatter_base_impl):
	Add support for MODE_wb.
	* config/arm/arm-mve-builtins-shapes.cc (parse_type): Add support
	for 'b' type.
	(store_scatter_base): Add support for MODE_wb.
	* config/arm/arm-mve-builtins.cc
	(function_resolver::require_pointer_to_type): New.
	* config/arm/arm-mve-builtins.h
	(function_resolver::require_pointer_to_type): New.
	* config/arm/arm_mve.h (vstrdq_scatter_base_wb): Delete.
	(vstrdq_scatter_base_wb_p): Delete.
	(vstrwq_scatter_base_wb_p): Delete.
	(vstrwq_scatter_base_wb): Delete.
	(vstrdq_scatter_base_wb_p_s64): Delete.
	(vstrdq_scatter_base_wb_p_u64): Delete.
	(vstrdq_scatter_base_wb_s64): Delete.
	(vstrdq_scatter_base_wb_u64): Delete.
	(vstrwq_scatter_base_wb_p_s32): Delete.
	(vstrwq_scatter_base_wb_p_f32): Delete.
	(vstrwq_scatter_base_wb_p_u32): Delete.
	(vstrwq_scatter_base_wb_s32): Delete.
	(vstrwq_scatter_base_wb_u32): Delete.
	(vstrwq_scatter_base_wb_f32): Delete.
	(__arm_vstrdq_scatter_base_wb_s64): Delete.
	(__arm_vstrdq_scatter_base_wb_u64): Delete.
	(__arm_vstrdq_scatter_base_wb_p_s64): Delete.
	(__arm_vstrdq_scatter_base_wb_p_u64): Delete.
	(__arm_vstrwq_scatter_base_wb_p_s32): Delete.
	(__arm_vstrwq_scatter_base_wb_p_u32): Delete.
	(__arm_vstrwq_scatter_base_wb_s32): Delete.
	(__arm_vstrwq_scatter_base_wb_u32): Delete.
	(__arm_vstrwq_scatter_base_wb_f32): Delete.
	(__arm_vstrwq_scatter_base_wb_p_f32): Delete.
	(__arm_vstrdq_scatter_base_wb): Delete.
	(__arm_vstrdq_scatter_base_wb_p): Delete.
	(__arm_vstrwq_scatter_base_wb_p): Delete.
	(__arm_vstrwq_scatter_base_wb): Delete.
	* config/arm/arm_mve_builtins.def (vstrwq_scatter_base_wb_u)
	(vstrdq_scatter_base_wb_u, vstrwq_scatter_base_wb_p_u)
	(vstrdq_scatter_base_wb_p_u, vstrwq_scatter_base_wb_s)
	(vstrwq_scatter_base_wb_f, vstrdq_scatter_base_wb_s)
	(vstrwq_scatter_base_wb_p_s, vstrwq_scatter_base_wb_p_f)
	(vstrdq_scatter_base_wb_p_s): Delete.
	* config/arm/iterators.md (supf): Remove VSTRWQSBWB_S,
	VSTRWQSBWB_U, VSTRDQSBWB_S, VSTRDQSBWB_U.
	(VSTRDSBQ, VSTRWSBWBQ, VSTRDSBWBQ): Delete.
	* config/arm/mve.md (mve_vstrwq_scatter_base_wb_<supf>v4si): Delete.
	(mve_vstrwq_scatter_base_wb_p_<supf>v4si): Delete.
	(mve_vstrwq_scatter_base_wb_fv4sf): Delete.
	(mve_vstrwq_scatter_base_wb_p_fv4sf): Delete.
	(mve_vstrdq_scatter_base_wb_<supf>v2di): Delete.
	(mve_vstrdq_scatter_base_wb_p_<supf>v2di): Delete.
	(@mve_vstrq_scatter_base_wb_<mode>): New.
	(@mve_vstrq_scatter_base_wb_p_<mode>): New.
	* config/arm/unspecs.md (VSTRWQSBWB_S, VSTRWQSBWB_U, VSTRWQSBWB_F)
	(VSTRDQSBWB_S, VSTRDQSBWB_U): Delete.
	(VSTRSBWBQ, VSTRSBWBQ_P): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_strsbs_qualifiers)
	(arm_strsbu_qualifiers, arm_strsbs_p_qualifiers)
	(arm_strsbu_p_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (class
	vstrq_scatter_base_impl): New.
	(vstrwq_scatter_base, vstrdq_scatter_base): New.
	* config/arm/arm-mve-builtins-base.def (vstrwq_scatter_base)
	(vstrdq_scatter_base): New.
	* config/arm/arm-mve-builtins-base.h (vstrwq_scatter_base)
	(vstrdq_scatter_base): New.
	* config/arm/arm_mve.h (vstrwq_scatter_base): Delete.
	(vstrwq_scatter_base_p): Delete.
	(vstrdq_scatter_base_p): Delete.
	(vstrdq_scatter_base): Delete.
	(vstrwq_scatter_base_s32): Delete.
	(vstrwq_scatter_base_u32): Delete.
	(vstrwq_scatter_base_p_s32): Delete.
	(vstrwq_scatter_base_p_u32): Delete.
	(vstrdq_scatter_base_p_s64): Delete.
	(vstrdq_scatter_base_p_u64): Delete.
	(vstrdq_scatter_base_s64): Delete.
	(vstrdq_scatter_base_u64): Delete.
	(vstrwq_scatter_base_f32): Delete.
	(vstrwq_scatter_base_p_f32): Delete.
	(__arm_vstrwq_scatter_base_s32): Delete.
	(__arm_vstrwq_scatter_base_u32): Delete.
	(__arm_vstrwq_scatter_base_p_s32): Delete.
	(__arm_vstrwq_scatter_base_p_u32): Delete.
	(__arm_vstrdq_scatter_base_p_s64): Delete.
	(__arm_vstrdq_scatter_base_p_u64): Delete.
	(__arm_vstrdq_scatter_base_s64): Delete.
	(__arm_vstrdq_scatter_base_u64): Delete.
	(__arm_vstrwq_scatter_base_f32): Delete.
	(__arm_vstrwq_scatter_base_p_f32): Delete.
	(__arm_vstrwq_scatter_base): Delete.
	(__arm_vstrwq_scatter_base_p): Delete.
	(__arm_vstrdq_scatter_base_p): Delete.
	(__arm_vstrdq_scatter_base): Delete.
	* config/arm/arm_mve_builtins.def (vstrwq_scatter_base_s)
	(vstrwq_scatter_base_u, vstrwq_scatter_base_p_s)
	(vstrwq_scatter_base_p_u, vstrdq_scatter_base_s)
	(vstrwq_scatter_base_f, vstrdq_scatter_base_p_s)
	(vstrwq_scatter_base_p_f, vstrdq_scatter_base_u)
	(vstrdq_scatter_base_p_u): Delete.
	* config/arm/iterators.md (MVE_4): New.
	(supf): Remove VSTRWQSB_S, VSTRWQSB_U.
	(VSTRWSBQ): Delete.
	* config/arm/mve.md (mve_vstrwq_scatter_base_<supf>v4si): Delete.
	(mve_vstrwq_scatter_base_p_<supf>v4si): Delete.
	(mve_vstrdq_scatter_base_p_<supf>v2di): Delete.
	(mve_vstrdq_scatter_base_<supf>v2di): Delete.
	(mve_vstrwq_scatter_base_fv4sf): Delete.
	(mve_vstrwq_scatter_base_p_fv4sf): Delete.
	(@mve_vstrq_scatter_base_<mode>): New.
	(@mve_vstrq_scatter_base_p_<mode>): New.
	* config/arm/unspecs.md (VSTRWQSB_S, VSTRWQSB_U, VSTRWQSB_F):
	Delete.
	(VSTRSBQ, VSTRSBQ_P): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (store_scatter_base): New.
	* config/arm/arm-mve-builtins-shapes.h (store_scatter_base): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins.cc (report_out_of_range_multiple):
	New.
	(function_checker::require_signed_immediate): New.
	(function_checker::require_immediate_range_multiple): New.
	* config/arm/arm-mve-builtins.h
	(function_checker::require_immediate_range_multiple): New.
	(function_checker::require_signed_immediate): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-builtins.cc (arm_strss_qualifiers)
	(arm_strsu_qualifiers, arm_strsu_p_qualifiers)
	(arm_strss_p_qualifiers): Delete.
	* config/arm/arm-mve-builtins-base.cc (class vstrq_scatter_impl):
	Add support for shifted version.
	(vstrdq_scatter_shifted, vstrhq_scatter_shifted)
	(vstrwq_scatter_shifted): New.
	* config/arm/arm-mve-builtins-base.def (vstrhq_scatter_shifted)
	(vstrwq_scatter_shifted, vstrdq_scatter_shifted): New.
	* config/arm/arm-mve-builtins-base.h (vstrhq_scatter_shifted)
	(vstrwq_scatter_shifted, vstrdq_scatter_shifted): New.
	* config/arm/arm_mve.h (vstrhq_scatter_shifted_offset): Delete.
	(vstrhq_scatter_shifted_offset_p): Delete.
	(vstrdq_scatter_shifted_offset_p): Delete.
	(vstrdq_scatter_shifted_offset): Delete.
	(vstrwq_scatter_shifted_offset_p): Delete.
	(vstrwq_scatter_shifted_offset): Delete.
	(vstrhq_scatter_shifted_offset_s32): Delete.
	(vstrhq_scatter_shifted_offset_s16): Delete.
	(vstrhq_scatter_shifted_offset_u32): Delete.
	(vstrhq_scatter_shifted_offset_u16): Delete.
	(vstrhq_scatter_shifted_offset_p_s32): Delete.
	(vstrhq_scatter_shifted_offset_p_s16): Delete.
	(vstrhq_scatter_shifted_offset_p_u32): Delete.
	(vstrhq_scatter_shifted_offset_p_u16): Delete.
	(vstrdq_scatter_shifted_offset_p_s64): Delete.
	(vstrdq_scatter_shifted_offset_p_u64): Delete.
	(vstrdq_scatter_shifted_offset_s64): Delete.
	(vstrdq_scatter_shifted_offset_u64): Delete.
	(vstrhq_scatter_shifted_offset_f16): Delete.
	(vstrhq_scatter_shifted_offset_p_f16): Delete.
	(vstrwq_scatter_shifted_offset_f32): Delete.
	(vstrwq_scatter_shifted_offset_p_f32): Delete.
	(vstrwq_scatter_shifted_offset_p_s32): Delete.
	(vstrwq_scatter_shifted_offset_p_u32): Delete.
	(vstrwq_scatter_shifted_offset_s32): Delete.
	(vstrwq_scatter_shifted_offset_u32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_s32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_s16): Delete.
	(__arm_vstrhq_scatter_shifted_offset_u32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_u16): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p_s32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p_s16): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p_u32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p_u16): Delete.
	(__arm_vstrdq_scatter_shifted_offset_p_s64): Delete.
	(__arm_vstrdq_scatter_shifted_offset_p_u64): Delete.
	(__arm_vstrdq_scatter_shifted_offset_s64): Delete.
	(__arm_vstrdq_scatter_shifted_offset_u64): Delete.
	(__arm_vstrwq_scatter_shifted_offset_p_s32): Delete.
	(__arm_vstrwq_scatter_shifted_offset_p_u32): Delete.
	(__arm_vstrwq_scatter_shifted_offset_s32): Delete.
	(__arm_vstrwq_scatter_shifted_offset_u32): Delete.
	(__arm_vstrhq_scatter_shifted_offset_f16): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p_f16): Delete.
	(__arm_vstrwq_scatter_shifted_offset_f32): Delete.
	(__arm_vstrwq_scatter_shifted_offset_p_f32): Delete.
	(__arm_vstrhq_scatter_shifted_offset): Delete.
	(__arm_vstrhq_scatter_shifted_offset_p): Delete.
	(__arm_vstrdq_scatter_shifted_offset_p): Delete.
	(__arm_vstrdq_scatter_shifted_offset): Delete.
	(__arm_vstrwq_scatter_shifted_offset_p): Delete.
	(__arm_vstrwq_scatter_shifted_offset): Delete.
	* config/arm/arm_mve_builtins.def
	(vstrhq_scatter_shifted_offset_p_u)
	(vstrhq_scatter_shifted_offset_u)
	(vstrhq_scatter_shifted_offset_p_s)
	(vstrhq_scatter_shifted_offset_s, vstrdq_scatter_shifted_offset_s)
	(vstrhq_scatter_shifted_offset_f, vstrwq_scatter_shifted_offset_f)
	(vstrwq_scatter_shifted_offset_s)
	(vstrdq_scatter_shifted_offset_p_s)
	(vstrhq_scatter_shifted_offset_p_f)
	(vstrwq_scatter_shifted_offset_p_f)
	(vstrwq_scatter_shifted_offset_p_s)
	(vstrdq_scatter_shifted_offset_u, vstrwq_scatter_shifted_offset_u)
	(vstrdq_scatter_shifted_offset_p_u)
	(vstrwq_scatter_shifted_offset_p_u): Delete.
	* config/arm/iterators.md (MVE_VLD_ST_scatter_shifted): New.
	(MVE_scatter_shift): New.
	(supf): Remove VSTRHQSSO_S, VSTRHQSSO_U, VSTRDQSSO_S, VSTRDQSSO_U,
	VSTRWQSSO_U, VSTRWQSSO_S.
	(VSTRHSSOQ, VSTRDSSOQ, VSTRWSSOQ): Delete.
	* config/arm/mve.md (mve_vstrhq_scatter_shifted_offset_p_<supf><mode>): Delete.
	(mve_vstrhq_scatter_shifted_offset_p_<supf><mode>_insn): Delete.
	(mve_vstrhq_scatter_shifted_offset_<supf><mode>): Delete.
	(mve_vstrhq_scatter_shifted_offset_<supf><mode>_insn): Delete.
	(mve_vstrdq_scatter_shifted_offset_p_<supf>v2di): Delete.
	(mve_vstrdq_scatter_shifted_offset_p_<supf>v2di_insn): Delete.
	(mve_vstrdq_scatter_shifted_offset_<supf>v2di): Delete.
	(mve_vstrdq_scatter_shifted_offset_<supf>v2di_insn): Delete.
	(mve_vstrhq_scatter_shifted_offset_fv8hf): Delete.
	(mve_vstrhq_scatter_shifted_offset_fv8hf_insn): Delete.
	(mve_vstrhq_scatter_shifted_offset_p_fv8hf): Delete.
	(mve_vstrhq_scatter_shifted_offset_p_fv8hf_insn): Delete.
	(mve_vstrwq_scatter_shifted_offset_fv4sf): Delete.
	(mve_vstrwq_scatter_shifted_offset_fv4sf_insn): Delete.
	(mve_vstrwq_scatter_shifted_offset_p_fv4sf): Delete.
	(mve_vstrwq_scatter_shifted_offset_p_fv4sf_insn): Delete.
	(mve_vstrwq_scatter_shifted_offset_p_<supf>v4si): Delete.
	(mve_vstrwq_scatter_shifted_offset_p_<supf>v4si_insn): Delete.
	(mve_vstrwq_scatter_shifted_offset_<supf>v4si): Delete.
	(mve_vstrwq_scatter_shifted_offset_<supf>v4si_insn): Delete.
	(@mve_vstrq_scatter_shifted_offset_<mode>): New.
	(@mve_vstrq_scatter_shifted_offset_p_<mode>): New.
	(mve_vstrq_truncate_scatter_shifted_offset_v4si): New.
	(mve_vstrq_truncate_scatter_shifted_offset_p_v4si): New.
	* config/arm/unspecs.md (VSTRDQSSO_S, VSTRDQSSO_U, VSTRWQSSO_S)
	(VSTRWQSSO_U, VSTRHQSSO_F, VSTRWQSSO_F, VSTRHQSSO_S, VSTRHQSSO_U):
	Delete.
	(VSTRSSOQ, VSTRSSOQ_P, VSTRSSOQ_TRUNC, VSTRSSOQ_TRUNC_P): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-base.cc (class vstrq_scatter_impl):
	New.
	(vstrbq_scatter, vstrhq_scatter, vstrwq_scatter, vstrdq_scatter):
	New.
	* config/arm/arm-mve-builtins-base.def (vstrbq_scatter)
	(vstrhq_scatter, vstrwq_scatter, vstrdq_scatter): New.
	* config/arm/arm-mve-builtins-base.h (vstrbq_scatter)
	(vstrhq_scatter, vstrwq_scatter, vstrdq_scatter): New.
	* config/arm/arm-mve-builtins.cc (integer_64): New.
	* config/arm/arm_mve.h (vstrbq_scatter_offset): Delete.
	(vstrbq_scatter_offset_p): Delete.
	(vstrhq_scatter_offset): Delete.
	(vstrhq_scatter_offset_p): Delete.
	(vstrdq_scatter_offset_p): Delete.
	(vstrdq_scatter_offset): Delete.
	(vstrwq_scatter_offset_p): Delete.
	(vstrwq_scatter_offset): Delete.
	(vstrbq_scatter_offset_s8): Delete.
	(vstrbq_scatter_offset_u8): Delete.
	(vstrbq_scatter_offset_u16): Delete.
	(vstrbq_scatter_offset_s16): Delete.
	(vstrbq_scatter_offset_u32): Delete.
	(vstrbq_scatter_offset_s32): Delete.
	(vstrbq_scatter_offset_p_s8): Delete.
	(vstrbq_scatter_offset_p_s32): Delete.
	(vstrbq_scatter_offset_p_s16): Delete.
	(vstrbq_scatter_offset_p_u8): Delete.
	(vstrbq_scatter_offset_p_u32): Delete.
	(vstrbq_scatter_offset_p_u16): Delete.
	(vstrhq_scatter_offset_s32): Delete.
	(vstrhq_scatter_offset_s16): Delete.
	(vstrhq_scatter_offset_u32): Delete.
	(vstrhq_scatter_offset_u16): Delete.
	(vstrhq_scatter_offset_p_s32): Delete.
	(vstrhq_scatter_offset_p_s16): Delete.
	(vstrhq_scatter_offset_p_u32): Delete.
	(vstrhq_scatter_offset_p_u16): Delete.
	(vstrdq_scatter_offset_p_s64): Delete.
	(vstrdq_scatter_offset_p_u64): Delete.
	(vstrdq_scatter_offset_s64): Delete.
	(vstrdq_scatter_offset_u64): Delete.
	(vstrhq_scatter_offset_f16): Delete.
	(vstrhq_scatter_offset_p_f16): Delete.
	(vstrwq_scatter_offset_f32): Delete.
	(vstrwq_scatter_offset_p_f32): Delete.
	(vstrwq_scatter_offset_p_s32): Delete.
	(vstrwq_scatter_offset_p_u32): Delete.
	(vstrwq_scatter_offset_s32): Delete.
	(vstrwq_scatter_offset_u32): Delete.
	(__arm_vstrbq_scatter_offset_s8): Delete.
	(__arm_vstrbq_scatter_offset_s32): Delete.
	(__arm_vstrbq_scatter_offset_s16): Delete.
	(__arm_vstrbq_scatter_offset_u8): Delete.
	(__arm_vstrbq_scatter_offset_u32): Delete.
	(__arm_vstrbq_scatter_offset_u16): Delete.
	(__arm_vstrbq_scatter_offset_p_s8): Delete.
	(__arm_vstrbq_scatter_offset_p_s32): Delete.
	(__arm_vstrbq_scatter_offset_p_s16): Delete.
	(__arm_vstrbq_scatter_offset_p_u8): Delete.
	(__arm_vstrbq_scatter_offset_p_u32): Delete.
	(__arm_vstrbq_scatter_offset_p_u16): Delete.
	(__arm_vstrhq_scatter_offset_s32): Delete.
	(__arm_vstrhq_scatter_offset_s16): Delete.
	(__arm_vstrhq_scatter_offset_u32): Delete.
	(__arm_vstrhq_scatter_offset_u16): Delete.
	(__arm_vstrhq_scatter_offset_p_s32): Delete.
	(__arm_vstrhq_scatter_offset_p_s16): Delete.
	(__arm_vstrhq_scatter_offset_p_u32): Delete.
	(__arm_vstrhq_scatter_offset_p_u16): Delete.
	(__arm_vstrdq_scatter_offset_p_s64): Delete.
	(__arm_vstrdq_scatter_offset_p_u64): Delete.
	(__arm_vstrdq_scatter_offset_s64): Delete.
	(__arm_vstrdq_scatter_offset_u64): Delete.
	(__arm_vstrwq_scatter_offset_p_s32): Delete.
	(__arm_vstrwq_scatter_offset_p_u32): Delete.
	(__arm_vstrwq_scatter_offset_s32): Delete.
	(__arm_vstrwq_scatter_offset_u32): Delete.
	(__arm_vstrhq_scatter_offset_f16): Delete.
	(__arm_vstrhq_scatter_offset_p_f16): Delete.
	(__arm_vstrwq_scatter_offset_f32): Delete.
	(__arm_vstrwq_scatter_offset_p_f32): Delete.
	(__arm_vstrbq_scatter_offset): Delete.
	(__arm_vstrbq_scatter_offset_p): Delete.
	(__arm_vstrhq_scatter_offset): Delete.
	(__arm_vstrhq_scatter_offset_p): Delete.
	(__arm_vstrdq_scatter_offset_p): Delete.
	(__arm_vstrdq_scatter_offset): Delete.
	(__arm_vstrwq_scatter_offset_p): Delete.
	(__arm_vstrwq_scatter_offset): Delete.
	* config/arm/arm_mve_builtins.def (vstrbq_scatter_offset_s)
	(vstrbq_scatter_offset_u, vstrbq_scatter_offset_p_s)
	(vstrbq_scatter_offset_p_u, vstrhq_scatter_offset_p_u)
	(vstrhq_scatter_offset_u, vstrhq_scatter_offset_p_s)
	(vstrhq_scatter_offset_s, vstrdq_scatter_offset_s)
	(vstrhq_scatter_offset_f, vstrwq_scatter_offset_f)
	(vstrwq_scatter_offset_s, vstrdq_scatter_offset_p_s)
	(vstrhq_scatter_offset_p_f, vstrwq_scatter_offset_p_f)
	(vstrwq_scatter_offset_p_s, vstrdq_scatter_offset_u)
	(vstrwq_scatter_offset_u, vstrdq_scatter_offset_p_u)
	(vstrwq_scatter_offset_p_u) Delete.
	* config/arm/iterators.md (MVE_VLD_ST_scatter): New.
	(MVE_scatter_offset): New.
	(MVE_elem_ch): Add entry for V2DI.
	(supf): Remove VSTRBQSO_S, VSTRBQSO_U, VSTRHQSO_S, VSTRHQSO_U,
	VSTRDQSO_S, VSTRDQSO_U, VSTRWQSO_U, VSTRWQSO_S.
	(VSTRBSOQ, VSTRHSOQ, VSTRDSOQ, VSTRWSOQ): Delete.
	* config/arm/mve.md (mve_vstrbq_scatter_offset_<supf><mode>):
	Delete.
	(mve_vstrbq_scatter_offset_<supf><mode>_insn): Delete.
	(mve_vstrbq_scatter_offset_p_<supf><mode>): Delete.
	(mve_vstrbq_scatter_offset_p_<supf><mode>_insn): Delete.
	(mve_vstrhq_scatter_offset_p_<supf><mode>): Delete.
	(mve_vstrhq_scatter_offset_p_<supf><mode>_insn): Delete.
	(mve_vstrhq_scatter_offset_<supf><mode>): Delete.
	(mve_vstrhq_scatter_offset_<supf><mode>_insn): Delete.
	(mve_vstrdq_scatter_offset_p_<supf>v2di): Delete.
	(mve_vstrdq_scatter_offset_p_<supf>v2di_insn): Delete.
	(mve_vstrdq_scatter_offset_<supf>v2di): Delete.
	(mve_vstrdq_scatter_offset_<supf>v2di_insn): Delete.
	(mve_vstrhq_scatter_offset_fv8hf): Delete.
	(mve_vstrhq_scatter_offset_fv8hf_insn): Delete.
	(mve_vstrhq_scatter_offset_p_fv8hf): Delete.
	(mve_vstrhq_scatter_offset_p_fv8hf_insn): Delete.
	(mve_vstrwq_scatter_offset_fv4sf): Delete.
	(mve_vstrwq_scatter_offset_fv4sf_insn): Delete.
	(mve_vstrwq_scatter_offset_p_fv4sf): Delete.
	(mve_vstrwq_scatter_offset_p_fv4sf_insn): Delete.
	(mve_vstrwq_scatter_offset_p_<supf>v4si): Delete.
	(mve_vstrwq_scatter_offset_p_<supf>v4si_insn): Delete.
	(mve_vstrwq_scatter_offset_<supf>v4si): Delete.
	(mve_vstrwq_scatter_offset_<supf>v4si_insn): Delete.
	(@mve_vstrq_scatter_offset_<mode>): New.
	(@mve_vstrq_scatter_offset_p_<mode>): New.
	(@mve_vstrq_truncate_scatter_offset_<mode>): New.
	(@mve_vstrq_truncate_scatter_offset_p_<mode>): New.
	* config/arm/unspecs.md (VSTRBQSO_S, VSTRBQSO_U, VSTRHQSO_S)
	(VSTRDQSO_S, VSTRDQSO_U, VSTRWQSO_S, VSTRWQSO_U, VSTRHQSO_F)
	(VSTRWQSO_F, VSTRHQSO_U): Delete.
	(VSTRQSO, VSTRQSO_P, VSTRQSO_TRUNC, VSTRQSO_TRUNC_P): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (struct store_scatter): New.
	(struct store_scatter_offset_def): New.
	* config/arm/arm-mve-builtins-shapes.h (store_scatter_offset): New.

2024-12-13  Christophe Lyon  <christophe.lyon@linaro.org>

	* config/arm/arm-mve-builtins-shapes.cc (struct
	nonoverloaded_base): Implement mode_after_pred.
	(struct overloaded_base): Likewise.
	* config/arm/arm-mve-builtins.cc (function_builder::get_name):
	Call mode_after_pred as needed.
	* config/arm/arm-mve-builtins.h (function_shape): Add
	mode_after_pred.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/111600
	* Makefile.in:  Add insn-recog split.
	* configure: Regenerate.
	* configure.ac: Document that the number of insnemit partitions is
	used for insn-recog as well.
	* genconditions.cc (write_one_condition): Use fprintf.
	* genpreds.cc (write_predicate_expr): Ditto.
	(write_init_reg_class_start_regs): Ditto.
	* genrecog.cc (write_header): Add header file to includes.
	(printf_indent): Use fprintf.
	(change_state): Ditto.
	(print_code): Ditto.
	(print_host_wide_int): Ditto.
	(print_parameter_value): Ditto.
	(print_test_rtx): Ditto.
	(print_nonbool_test): Ditto.
	(print_label_value): Ditto.
	(print_test): Ditto.
	(print_decision): Ditto.
	(print_state): Ditto.
	(print_subroutine_call): Ditto.
	(print_acceptance): Ditto.
	(print_subroutine_start): Ditto.
	(print_pattern): Ditto.
	(print_subroutine): Ditto.
	(print_subroutine_group): Ditto.
	(handle_arg): Add -O and -H for output and header file handling.
	(main): Use callback.
	* gentarget-def.cc (def_target_insn): Use fprintf.
	* read-md.cc (md_reader::print_c_condition): Ditto.
	* read-md.h (class md_reader): Ditto.

2024-12-13  Tamar Christina  <tamar.christina@arm.com>

	* config/aarch64/tuning_models/cortexx925.h: Set L1 cache size to 64b.
	* config/aarch64/tuning_models/neoverse512tvb.h: Likewise.
	* config/aarch64/tuning_models/neoversen1.h: Likewise.
	* config/aarch64/tuning_models/neoversen2.h: Likewise.
	* config/aarch64/tuning_models/neoversen3.h: Likewise.
	* config/aarch64/tuning_models/neoversev1.h: Likewise.
	* config/aarch64/tuning_models/neoversev2.h: Likewise.
	(neoversev2_prefetch_tune): Removed.
	* config/aarch64/tuning_models/neoversev3.h: Likewise.
	* config/aarch64/tuning_models/neoversev3ae.h: Likewise.

2024-12-13  Tamar Christina  <tamar.christina@arm.com>

	* config/aarch64/aarch64-fusion-pairs.def (AARCH64_FUSE_NEOVERSE_BASE):
	New.
	* config/aarch64/tuning_models/neoverse512tvb.h: Use it.
	* config/aarch64/tuning_models/neoversen2.h: Use it.
	* config/aarch64/tuning_models/neoversen3.h: Use it.
	* config/aarch64/tuning_models/neoversev1.h: Use it.
	* config/aarch64/tuning_models/neoversev2.h: Use it.
	* config/aarch64/tuning_models/neoversev3.h: Use it.
	* config/aarch64/tuning_models/neoversev3ae.h: Use it.
	* config/aarch64/tuning_models/cortexx925.h: Add fusions.
	* config/aarch64/tuning_models/generic_armv9_a.h: Add fusions.

2024-12-13  Jakub Jelinek  <jakub@redhat.com>

	PR target/116979
	* config/i386/mmx.md (vec_fmaddsubv2sf4, vec_fmsubaddv2sf4): New
	define_expand patterns.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	* config/riscv/riscv-protos.h (riscv_register_move_cost):
	Export.
	* config/riscv/riscv-v.cc (shuffle_extract_and_slide1up_patterns):
	Rename...
	(shuffle_off_by_one_patterns): ... to this and add slideup/slidedown
	variant.
	(expand_vec_perm_const_1): Call renamed function.
	* config/riscv/riscv.cc (riscv_secondary_memory_needed): Remove
	static.
	(riscv_register_move_cost): Add VR<->GR/FR handling.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	* config/riscv/riscv-v.cc (shuffle_even_odd_patterns): New
	function.
	(expand_vec_perm_const_1): Use new function.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	* config/riscv/riscv-v.cc (shuffle_interleave_patterns): New
	function.
	(expand_vec_perm_const_1): Use new function.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	* config/riscv/riscv-v.cc (shuffle_slide_patterns): New.
	(expand_vec_perm_const_1): Call new function.

2024-12-13  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/117353
	PR target/117878
	* config/riscv/riscv-v.cc (expand_const_vector): Use predicated
	instead of simple shift.

2024-12-13  Pan Li  <pan2.li@intel.com>

	PR target/117990
	* config/riscv/vector.md: Add the (mem:BLK (scratch)) to the
	vector strided load.

2024-12-13  Sandra Loosemore  <sloosemore@baylibre.com>

	PR middle-end/111659
	* doc/extend.texi (Common Variable Attributes): Copy-edit description
	of the strict_flex_array attribute levels.
	* doc/invoke.texi (C Dialect Options): Swap documented behavior for
	levels 0 and 3.  Copy the description for the other levels from the
	attribute instead of indirecting to it.

2024-12-12  John David Anglin  <danglin@gcc.gnu.org>

	* config/pa/pa.cc (pa_emit_hpdiv_const): Clobber r1, r25,
	r25 and return register.
	* config/pa/pa.md (divsi3): Revise clobbers and operands.
	Remove second clobber from div:SI insns.
	(udivsi3, modsi3, umodsi3): Likewise.

2024-12-12  Sandra Loosemore  <sloosemore@baylibre.com>

	* attr-urls.def: Regenerate.

2024-12-12  Sandra Loosemore  <sloosemore@baylibre.com>
	    Peter Eisentraut  <peter@eisentraut.org>

	PR c/115532
	* common.opt.urls: Regenerated.
	* doc/invoke.texi (Option Summary): Don't try to list all the
	-Wsuggest-attribute= variants inline here.
	(Warning Options): Likewise.  Add @opindex for
	Wsuggest-attribute=returns_nonnull and its no- form.  Remove
	@itemx for no- form.

2024-12-12  Jakub Jelinek  <jakub@redhat.com>

	PR sanitizer/115127
	* match.pd (clz (X) == C, ctz (X) == C, ctz (X) >= C): Don't
	optimize if -fsanitize=builtin and not yet in SSA form.

2024-12-12  Tobias Burnus  <tburnus@baylibre.com>

	* gimplify.cc (gimplify_call_expr): When handling OpenMP's dispatch,
	add diagnostic when there is a ptr vs. addr mismatch between
	need_device_{addr,ptr} and {is,has}_device_{ptr,addr}, respectively.

2024-12-12  Georg-Johann Lay  <avr@gjlay.de>

	PR target/118000
	* config/avr/avr.cc (avr_init_expanders) <sreg_rtx>
	<rampd_rtx, rampx_rtx, rampy_rtx, rampz_rtx>: Set MEM_VOLATILE_P.
	(avr_out_cpymem) [ELPM && EBI]: Restore RAMPZ to 0 after.

2024-12-12  Alexandre Oliva  <oliva@adacore.com>

	* gimple-fold.cc (fold_truth_andor_for_ifcombine): Limit the
	size of the bitregion in get_best_mode calls by the inner
	object's type size, if known.
	(make_bit_field_load): Reuse SSA_NAME if we're attempting to
	issue an identical load.

2024-12-12  Alexandre Oliva  <oliva@adacore.com>

	* fold-const.cc (make_bit_field): Export.
	(unextend, all_ones_mask_p): Drop.
	(decode_field_reference, fold_truth_andor_1): Move
	field compare merging logic...
	* gimple-fold.cc: (fold_truth_andor_for_ifcombine) ... here,
	with -Wtautological-compare warning guards, and...
	(decode_field_reference): ... here.  Rework for gimple.
	(gimple_convert_def_p, gimple_binop_def_p): New.
	(compute_split_boundary_from_align): New.
	(make_bit_field_load, build_split_load): New.
	(reuse_split_load): New.
	* fold-const.h: (make_bit_field_ref): Declare
	(fold_truth_andor_for_ifcombine): Declare.
	* tree-ssa-ifcombine.cc (ifcombine_ifandif): Try
	fold_truth_andor_for_ifcombine.
	* common.opt (Wtautological-compare): Move here.

2024-12-12  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_ctz): New constexpr function.
	(section_common::flags): Assert minimal bit width.

2024-12-12  Georg-Johann Lay  <avr@gjlay.de>

	PR target/118001
	* doc/extend.texi (AVR Named Address Spaces): Document __flashx.
	* config/avr/avr.h (ADDR_SPACE_FLASHX): New enum value.
	* config/avr/avr-protos.h (avr_out_fload, avr_mem_flashx_p)
	(avr_fload_libgcc_p, avr_load_libgcc_mem_p)
	(avr_load_libgcc_insn_p): New.
	* config/avr/avr.cc (avr_addrspace): Add ADDR_SPACE_FLASHX.
	(avr_decl_flashx_p, avr_mem_flashx_p, avr_fload_libgcc_p)
	(avr_load_libgcc_mem_p, avr_load_libgcc_insn_p, avr_out_fload):
	New functions.
	(avr_adjust_insn_length) [ADJUST_LEN_FLOAD]: Handle case.
	(avr_progmem_p) [avr_decl_flashx_p]: return 2.
	(avr_addr_space_legitimate_address_p) [ADDR_SPACE_FLASHX]:
	Has same behavior like ADDR_SPACE_MEMX.
	(avr_addr_space_convert): Use pointer sizes rather then ASes.
	(avr_addr_space_contains): New function.
	(avr_convert_to_type): Use it.
	(avr_emit_cpymemhi): Handle ADDR_SPACE_FLASHX.
	* config/avr/avr.md (adjust_len) <fload>: New attr value.
	(gen_load<mode>_libgcc): Renamed from load<mode>_libgcc.
	(xload8<mode>_A): Iterate over MOVMODE rather than over ALL1.
	(fxmov<mode>_A): New from xloadv<mode>_A.
	(xmov<mode>_8): New from xload<mode>_A.
	(fmov<mode>): New insns.
	(fxload<mode>_A): New from xload<mode>_A.
	(fxload_<mode>_libgcc): New from xload_<mode>_libgcc.
	(*fxload_<mode>_libgcc): New from *xload_<mode>_libgcc.
	(mov<mode>) [avr_mem_flashx_p]: Hande ADDR_SPACE_FLASHX.
	(cpymemx_<mode>): Make sure the address space is not lost
	when splitting.
	(*cpymemx_<mode>) [ADDR_SPACE_FLASHX]: Use __movmemf_<mode> for asm.
	(*ashlqi.1.zextpsi_split): New combine pattern.
	* config/avr/predicates.md (nox_general_operand): Don't match
	when avr_mem_flashx_p is true.
	* config/avr/avr-passes.cc (AVR_LdSt_Props):
	ADDR_SPACE_FLASHX has no post_inc.

2024-12-12  Martin Uecker  <uecker@tugraz.at>

	PR c/113688
	PR c/114014
	PR c/114713
	PR c/117724
	* tree.cc (gimple_canonical_types_compatible_p): Add exception.

2024-12-12  Martin Uecker  <uecker@tugraz.at>

	* tree.cc (gimple_canonical_types_compatible_p): Add exception.
	(verify_type): Add exception.

2024-12-12  Sam James  <sam@gentoo.org>

	* config/i386/i386.opt.urls: Regenerate.

2024-12-12  Jakub Jelinek  <jakub@redhat.com>

	* gimple-crc-optimization.cc (crc_optimization::optimize_crc_loop):
	Comment spelling fix, is succeeded -> succeeded.

2024-12-12  Sandra Loosemore  <sloosemore@baylibre.com>

	PR target/117150
	* doc/invoke.texi (RS/6000 and PowerPC Options): Move description
	of -mstack-protector-guard-symbol from here...
	(x86 Options): ...to here.

2024-12-11  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/116778
	* ira-int.h (x_ira_class_hard_reg_index): Fix comment typo.
	* lra-eliminations.cc (lra_fp_pseudo_p): New function.
	* lra-int.h (lra_fp_pseudo_p): External declaration.
	* lra-spills.cc (lra_need_for_spills_p): Fix formatting.
	* lra.cc (lra): Use lra_fp_pseudo_p in lra_create_live_range after
	lra_remat.

2024-12-11  Filip Kastl  <fkastl@suse.cz>
	    Andi Kleen  <ak@gcc.gnu.org>

	PR middle-end/117091
	PR middle-end/117352
	* doc/invoke.texi: Add switch-lower-slow-alg-max-cases.
	* params.opt: Add switch-lower-slow-alg-max-cases.
	* tree-switch-conversion.cc (jump_table_cluster::find_jump_tables):
	Note in a comment that we are looking for jump tables in
	case sequences delimited by the already found bit tests.
	(bit_test_cluster::find_bit_tests): Decide between
	find_bit_tests_fast() and find_bit_tests_slow().
	(bit_test_cluster::find_bit_tests_fast): New function.
	(bit_test_cluster::find_bit_tests_slow): New function.
	(switch_decision_tree::analyze_switch_statement): Report
	exceeding the limit.
	* tree-switch-conversion.h: Add find_bit_tests_fast() and
	find_bit_tests_slow().

2024-12-11  David Malcolm  <dmalcolm@redhat.com>

	* diagnostic-highlight-colors.h: Tweak comment.
	* pretty-print-markup.h (class pp_element_quoted_string): New,
	based on pretty-print.cc's selftest::test_element, adding an
	optional highlight color.
	* pretty-print.cc (class test_element): Drop.
	(selftest::test_pp_format): Use pp_element_quoted_string.
	(selftest::test_urlification): Likewise.

2024-12-11  David Malcolm  <dmalcolm@redhat.com>

	PR other/116253
	* diagnostic-format-text.cc (build_prefix): Don't add the
	"note: " prefix when showing nested diagnostics.

2024-12-11  David Malcolm  <dmalcolm@redhat.com>

	PR other/116253
	* diagnostic-format-text.cc (on_report_diagnostic): When showing
	locations for nested messages on new lines, don't print
	UNKNOWN_LOCATION or BUILTINS_LOCATION.

2024-12-11  David Malcolm  <dmalcolm@redhat.com>

	* input.cc (file_cache::initialize_input_context): Rename member
	"in_context" to "m_input_context".
	(file_cache::add_file): Likewise.
	* input.h (class file_cache): Likewise.

2024-12-11  Martin Jambor  <mjambor@suse.cz>

	* ipa-cp.h: Forward declare class ipa_vr.
	(ipa_vr_operation_and_type_effects) Declare.
	* ipa-cp.cc (ipa_vr_operation_and_type_effects): Make public.
	* ipa-prop.cc (update_jump_functions_after_inlining): Also update
	value range jump functions.

2024-12-11  Victor Do Nascimento  <victor.donascimento@arm.com>
	    Tamar Christina  <tamar.christina@arm.com>

	PR target/96342
	* expr.cc (store_constructor): Enable poly_{u}int64 type usage.
	(get_inner_reference): Ditto.

2024-12-11  Victor Do Nascimento  <victor.donascimento@arm.com>
	    Tamar Christina  <tamar.christina@arm.com>

	PR target/96342
	* expr.cc (store_constructor): add support for variable-length
	vectors.

2024-12-11  Victor Do Nascimento  <victor.donascimento@arm.com>

	PR target/96342
	* tree-vect-stmts.cc (vectorizable_simd_clone_call):
	s/vectype/masktype/ in call to vect_get_loop_mask.

2024-12-11  Andre Vieira  <andre.simoesdiasvieira@arm.com>
	    Victor Do Nascimento  <victor.donascimento@arm.com>
	    Tamar Christina  <tamar.christina@arm.com>

	PR target/96342
	* target.def (TARGET_SIMD_CLONE_USABLE): Add argument.
	* tree-vect-stmts.cc (vectorizable_simd_clone_call): Pass stmt_info to
	call TARGET_SIMD_CLONE_USABLE.
	* config/aarch64/aarch64.cc (aarch64_simd_clone_usable): Add argument
	and use it to reject the use of SVE simd clones with Advanced SIMD
	modes.
	* config/gcn/gcn.cc (gcn_simd_clone_usable): Add unused argument.
	* config/i386/i386.cc (ix86_simd_clone_usable): Likewise.
	* doc/tm.texi: Regenerate

2024-12-11  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/114932
	* fold-const.cc (operand_compare::operand_equal_p): Use it.
	(operand_compare::verify_hash_value): Likewise.
	(operand_compare::hash_operand): Likewise.
	(test_operand_equality::test): New.
	(fold_const_cc_tests): Use it.
	* tree-core.h (enum operand_equal_flag): Add OEP_ASSUME_WRAPV.
	* tree-ssa-loop-ivopts.cc (record_group_use): Check for structural eq.

2024-12-11  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/114932
	* fold-const.cc (operand_compare::operand_equal_p): Split into one that
	takes explicit type parameters and use that in public one.
	* fold-const.h (class operand_compare): Add operand_equal_p private
	overload.

2024-12-11  Soumya AR  <soumyaa@nvidia.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64.cc (aarch64_ptrue_reg): New overload.
	* config/aarch64/aarch64-protos.h (aarch64_ptrue_reg): Likewise.
	* config/aarch64/aarch64-sve.md: Extended sdiv_pow2<mode>3
	and *sdiv_pow2<mode>3 to support Neon modes.

2024-12-11  Soumya AR  <soumyaa@nvidia.com>

	* config/aarch64/aarch64-sve2.md
	(*aarch64_sve2_nbsl_unpred<mode>): New pattern to match unpredicated
	form.
	(*aarch64_sve2_bsl1n_unpred<mode>): Likewise.
	(*aarch64_sve2_bsl2n_unpred<mode>): Likewise.

2024-12-11  liuhongt  <hongtao.liu@intel.com>

	PR tree-optimization/117888
	* tree-ssa-loop-ivcanon.cc (try_unroll_loop_completely): Use
	cunrolli instead of cunrolli && !loop->inner to check if it's
	innermost loop.
	(canonicalize_loop_induction_variables): Add new parameter
	const_sbitmap innermost, and pass
	cunrolli
	&& (unsigned) loop->num < SBITMAP_SIZE (innermost)
	&& bitmap_bit_p (innermost, loop->num) as "cunrolli" to
	try_unroll_loop_completely
	(canonicalize_induction_variables): Pass innermost to
	canonicalize_loop_induction_variables.
	(tree_unroll_loops_completely_1): Add new parameter
	const_sbitmap innermost.
	(tree_unroll_loops_completely): Move local variable cunrolli
	to parameter to indicate it's from pass cunrolli, also track
	all "original" innermost loop at the beginning.

2024-12-10  David Malcolm  <dmalcolm@redhat.com>

	PR other/117944
	* libsarifreplay.cc (sarif_replayer::handle_result_obj): Get any
	helpUri	from the rule_obj and pass it to add_rule.

2024-12-10  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/117946
	* lra-assigns.cc: (find_hard_regno_for_1): Use the biggest mode to
	check ira_prohibited_class_mode_regs.

2024-12-10  Marek Polacek  <polacek@redhat.com>

	PR c++/117880
	* fold-const.cc (operand_compare::operand_equal_p) <case tcc_unary>:
	Use OP_SAME_WITH_NULL instead of OP_SAME.

2024-12-10  Wilco Dijkstra  <wilco.dijkstra@arm.com>

	PR target/117675
	* config/arm/arm.cc (arm_ldrd_legitimate_address): New function.
	* config/arm/arm-protos.h (arm_ldrd_legitimate_address): New prototype.
	* config/arm/constraints.md: Add new Uo constraint.
	* config/arm/predicates.md (arm_ldrd_memory_operand): Add new predicate.
	* config/arm/sync.md (arm_atomic_loaddi2_ldrd): Use
	arm_ldrd_memory_operand and Uo.

2024-12-10  Wilco Dijkstra  <wilco.dijkstra@arm.com>

	* config/aarch64/aarch64-tuning-flags.def (AARCH64_EXTRA_TUNE_BASE): New define.
	* config/aarch64/tuning_models/ampere1b.h: Use AARCH64_EXTRA_TUNE_BASE.
	* config/aarch64/tuning_models/cortexx925.h: Likewise.
	* config/aarch64/tuning_models/fujitsu_monaka.h: Likewise.
	* config/aarch64/tuning_models/generic_armv8_a.h: Likewise.
	* config/aarch64/tuning_models/generic_armv9_a.h: Likewise.
	* config/aarch64/tuning_models/neoversen1.h: Likewise.
	* config/aarch64/tuning_models/neoversen2.h: Likewise.
	* config/aarch64/tuning_models/neoversen3.h: Likewise.
	* config/aarch64/tuning_models/neoversev1.h: Likewise.
	* config/aarch64/tuning_models/neoversev2.h: Likewise.
	* config/aarch64/tuning_models/neoversev3.h: Likewise.
	* config/aarch64/tuning_models/neoversev3ae.h: Likewise.

2024-12-10  Wilco Dijkstra  <wilco.dijkstra@arm.com>

	* config/aarch64/aarch64.h (AARCH64_EXPAND_ALIGNMENT): Remove.
	(DATA_ALIGNMENT): Use aarch64_data_alignment.
	(LOCAL_ALIGNMENT): Use aarch64_stack_alignment.
	* config/aarch64/aarch64.cc (aarch64_data_alignment): New function.
	(aarch64_stack_alignment): Likewise.
	* config/aarch64/aarch64-protos.h (aarch64_data_alignment): New prototype.
	(aarch64_stack_alignment): Likewise.

2024-12-10  Wilco Dijkstra  <wdijkstr@ip-10-252-53-150.eu-west-1.compute.internal>

	* config/aarch64/aarch64.cc (aarch64_classify_address): Treat SIMD structs
	identically in little and bigendian.
	* config/aarch64/aarch64-simd.md (aarch64_mov<mode>): Remove VSTRUCT
	instructions.
	(aarch64_be_mov<mode>): Allow little-endian, rename to aarch64_mov<mode>.
	(aarch64_be_movoi): Allow little-endian, rename to aarch64_movoi.
	(aarch64_be_movci): Allow little-endian, rename to aarch64_movci.
	(aarch64_be_movxi): Allow little-endian, rename to aarch64_movxi.
	Remove big-endian special case in define_split variants.

2024-12-10  Arsen Arsenović  <arsen@aarsen.me>
	    Iain Sandoe  <iain@sandoe.co.uk>

	* dumpfile.cc (FIRST_ME_AUTO_NUMBERED_DUMP): Bump to 6 for sake
	of the coroutine dump.

2024-12-10  Richard Sandiford  <richard.sandiford@arm.com>

	* doc/md.texi (vcond@var{m}@var{n}, vcondu@var{m}@var{n})
	(vcondeq@var{m}@var{n}): Delete.
	(vcond_mask_@var{m}@var{n}): Redocument in standalone form.
	* internal-fn.def (VCOND, VCONDU, VCONDEQ): Delete.
	* internal-fn.cc (expand_vec_cond_optab_fn): Delete.
	* optabs.def (vcond_optab, vcondu_optab, vcondeq_optab): Delete.

2024-12-10  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-protos.h (aarch64_expand_sve_vcond): Delete.
	* config/aarch64/aarch64-simd.md (<su><maxmin>v2di3): Expand into
	separate vec_cmp and vcond_mask instructions, instead of using vcond.
	(vcond<mode><mode>, vcond<v_cmp_mixed><mode>, vcondu<mode><mode>)
	(vcondu<mode><v_cmp_mixed>): Delete.
	* config/aarch64/aarch64-sve.md (vcond<SVE_ALL:mode><SVE_I:mode>)
	(vcondu<SVE_ALL:mode><SVE_I:mode>, vcond<mode><v_fp_equiv>): Likewise.
	* config/aarch64/aarch64.cc (aarch64_expand_sve_vcond): Likewise.
	* config/aarch64/iterators.md (V_FP_EQUIV, v_fp_equiv, V_cmp_mixed)
	(v_cmp_mixed): Likewise.

2024-12-10  Saurabh Jha  <saurabh.jha@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc
	(aarch64_pragma_builtins_checker::require_immediate_lane_index): New
	overload.
	(aarch64_pragma_builtins_checker::check): Add support for FP8FMA
	intrinsics.
	(aarch64_expand_pragma_builtins): Likewise.
	* config/aarch64/aarch64-c.cc
	(aarch64_update_cpp_builtins): Conditionally define TARGET_FP8FMA.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Add the FP8FMA
	intrinsics.
	* config/aarch64/aarch64-simd.md:
	(@aarch64_<FMLAL_FP8_HF:insn><mode): New pattern.
	(@aarch64_<FMLAL_FP8_HF:insn>_lane<V8HF_ONLY:mode><VB:mode>):
	Likewise.
	(@aarch64_<FMLALL_FP8_SF:insn><mode): Likewise.
	(@aarch64_<FMLALL_FP8_SF:insn>_lane<V8HF_ONLY:mode><VB:mode>):
	Likewise.
	* config/aarch64/iterators.md (V8HF_ONLY): New mode iterator.
	(SVE2_FP8_TERNARY_VNX8HF): Rename to...
	(FMLAL_FP8_HF): ...this.
	(SVE2_FP8_TERNARY_LANE_VNX8HF): Delete in favor of FMLAL_FP8_HF.
	(SVE2_FP8_TERNARY_VNX4SF): Rename to...
	(FMLALL_FP8_SF): ...this.
	(SVE2_FP8_TERNARY_LANE_VNX4SF): Delete in favor of FMLALL_FP8_SF.
	(sve2_fp8_fma_op_vnx8hf, sve2_fp8_fma_op_vnx4sf): Fold into...
	(insn): ...here.
	* config/aarch64/aarch64-sve2.md: Update uses accordingly.

2024-12-10  Saurabh Jha  <saurabh.jha@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc
	(enum class): Add ternary_lane.
	(aarch64_fntype): Hnadle ternary_lane.
	(aarch64_pragma_builtins_checker::require_immediate_lane_index): New
	function.
	(aarch64_pragma_builtins_checker::check): Handle the new intrinsics.
	(aarch64_expand_pragma_builtin): Likewise.
	* config/aarch64/aarch64-c.cc
	(aarch64_update_cpp_builtins): Define TARGET_FP8DOT2 and
	TARGET_FP8DOT4.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Define vdot
	and vdot_lane intrinsics.
	* config/aarch64/aarch64-simd.md
	(@aarch64_<fpm_uns_op><mode>): New pattern.
	(@aarch64_<fpm_uns_op>_lane<VQ_HSF_VDOT:mode><VB:mode>): Likewise.
	* config/aarch64/iterators.md (VQ_HSF_VDOT): New mode iterator.
	(UNSPEC_VDOT, UNSPEC_VDOT_LANE): New unspecs.
	(fpm_uns_op): Handle them.
	(VNARROWB, Vnbtype): New mode attributes.
	(FPM_VDOT, FPM_VDOT_LANE): New int iterators.

2024-12-10  Saurabh Jha  <saurabh.jha@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc
	(FLAG_USES_FPMR, FLAG_FP8): New flags.
	(ENTRY): Modified to support ternary operations.
	(enum class): New variants to support new signatures.
	(struct aarch64_pragma_builtins_data): Extend types to 4 elements.
	(aarch64_fntype): Handle new signatures.
	(aarch64_get_low_unspec): New function.
	(aarch64_convert_to_v64): New function, split out from...
	(aarch64_expand_pragma_builtin): ...here.  Handle new signatures.
	* config/aarch64/aarch64-c.cc
	(aarch64_update_cpp_builtins): New flag for FP8.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Define new fp8
	intrinsics.
	(ENTRY_BINARY, ENTRY_BINARY_LANE): Update for new ENTRY interface.
	(ENTRY_UNARY, ENTRY_TERNARY, ENTRY_UNARY_FPM): New macros.
	(ENTRY_BINARY_VHSDF_SIGNED): Likewise.
	* config/aarch64/aarch64-simd.md
	(@aarch64_<fpm_uns_op><mode>): New pattern.
	(@aarch64_<fpm_uns_op><mode>_high): Likewise.
	(@aarch64_<fpm_uns_op><mode>_high_be): Likewise.
	(@aarch64_<fpm_uns_op><mode>_high_le): Likewise.
	* config/aarch64/iterators.md (V4SF_ONLY, VQ_BHF): New mode iterators.
	(UNSPEC_FCVTN_FP8, UNSPEC_FCVTN2_FP8, UNSPEC_F1CVTL_FP8)
	(UNSPEC_F1CVTL2_FP8, UNSPEC_F2CVTL_FP8, UNSPEC_F2CVTL2_FP8)
	(UNSPEC_FSCALE): New unspecs.
	(VPACKB, VPACKBtype): New mode attributes.
	(b): Add support for V[48][BH]F.
	(FPM_UNARY_UNS, FPM_BINARY_UNS, SCALE_UNS): New int iterators.
	(insn): New int attribute.

2024-12-10  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117912
	* tree-ssa-sccvn.cc (copy_reference_ops_from_ref): For addresses
	of zero-sized components do not set ->off if the object size pass
	didn't run.
	For OOB ARRAY_REF accesses in address expressions avoid setting
	->off if the object size pass didn't run.
	(valueize_refs_1): Likewise.

2024-12-10  Antoni Boucher  <bouanto@zoho.com>

	PR target/117923
	* config/aarch64/aarch64-builtins.cc: Remove GTY marker on aarch64_simd_types,
	aarch64_simd_types_trees (new variable), rename aarch64_simd_types to
	aarch64_simd_types_trees.
	* config/aarch64/aarch64-builtins.h: Remove GTY marker on aarch64_simd_types,
	aarch64_simd_types_trees (new variable).
	* config/aarch64/aarch64-sve-builtins-shapes.cc: Rename aarch64_simd_types to
	aarch64_simd_types_trees.
	* config/aarch64/aarch64-sve-builtins.cc: Rename aarch64_simd_types to
	aarch64_simd_types_trees.

2024-12-09  Mariam Arutunian  <mariamarutunian@gmail.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-protos.h (aarch64_expand_crc_using_pmull): New
	extern function declaration.
	(aarch64_expand_reversed_crc_using_pmull):  Likewise.
	* config/aarch64/aarch64.cc (aarch64_expand_crc_using_pmull): New
	function.
	(aarch64_expand_reversed_crc_using_pmull):  Likewise.
	* config/aarch64/aarch64.md (crc_rev<ALLI:mode><ALLX:mode>4): New
	expander for reversed CRC.
	(crc<ALLI:mode><ALLX:mode>4): New expander for bit-forward CRC.
	* config/aarch64/iterators.md (crc_data_type): New mode attribute.

2024-12-09  Marek Polacek  <polacek@redhat.com>

	PR driver/117942
	* opts-common.cc (decode_cmdline_options_to_array): Also detect
	--diagnostics-plain-output.

2024-12-09  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-simd.md (aarch64_get_lane<mode>): Add
	"@" to the name.

2024-12-09  Richard Biener  <rguenther@suse.de>

	* late-combine.cc (late_combine::execute): Delete RTL SSA.

2024-12-09  Richard Biener  <rguenther@suse.de>

	* timevar.def (TV_DUP_COMPGOTO): Add.
	* bb-reorder.cc (pass_data_duplicate_computed_gotos): Use
	TV_DUP_COMPGOTO.

2024-12-09  Juergen Christ  <jchrist@linux.ibm.com>

	* config/s390/s390.cc (s390_canonicalize_comparison): Add
	missing UNSPEC_CC_TO_INT case.

2024-12-09  Matthew Malcomson  <mmalcomson@nvidia.com>

	* config/aarch64/aarch64-c.cc
	(aarch64_resolve_overloaded_builtin,aarch64_check_builtin_call):
	Add new unused boolean parameter to match target hook
	definition.
	* config/arm/arm-builtins.cc (arm_check_builtin_call): Likewise.
	* config/arm/arm-c.cc (arm_resolve_overloaded_builtin):
	Likewise.
	* config/arm/arm-protos.h (arm_check_builtin_call): Likewise.
	* config/avr/avr-c.cc (avr_resolve_overloaded_builtin):
	Likewise.
	* config/riscv/riscv-c.cc (riscv_check_builtin_call,
	riscv_resolve_overloaded_builtin): Likewise.
	* config/rs6000/rs6000-c.cc (altivec_resolve_overloaded_builtin):
	Likewise.
	* config/rs6000/rs6000-protos.h (altivec_resolve_overloaded_builtin):
	Likewise.
	* config/s390/s390-c.cc (s390_resolve_overloaded_builtin):
	Likewise.
	* doc/tm.texi: Regenerate.
	* target.def (TARGET_RESOLVE_OVERLOADED_BUILTIN,
	TARGET_CHECK_BUILTIN_CALL): Update prototype to include a
	boolean parameter that indicates whether errors should be
	emitted.  Update documentation to mention this fact.

2024-12-09  Jakub Jelinek  <jakub@redhat.com>

	PR sanitizer/117960
	* doc/invoke.texi (fsanitize=hwaddress): Clarify on which targets
	it is supported.

2024-12-09  Richard Earnshaw  <rearnsha@arm.com>

	PR target/114189
	* config/arm/arm-protos.h (arm_expand_vcond): Delete prototype.
	* config/arm/arm.cc (arm_expand_vcond): Delete function.
	* config/arm/vec-common.md (vcond<mode><mode>): Delete pattern
	(vcond<V_cvtto><mode>): Likewise.
	(vcond<VH_cvtto><mode>): Likewise.
	(vcondu<mode><v_cmp_result>): Likewise.

2024-12-09  Richard Biener  <rguenther@suse.de>

	PR middle-end/117932
	* df-core.cc (df_worklist_propagate_forward): Elide
	age check for the first iteration, adjust for
	last_change_age change.
	(df_worklist_propagate_backward): Likewise.
	(df_worklist_dataflow_doublequeue): Make last_change_age
	indexed by BB index, avoid clearing both age arrays.

2024-12-09  Richard Biener  <rguenther@suse.de>

	PR middle-end/117932
	* df-core.cc (df_worklist_propagate_forward): When WORKLIST
	is NULL, do not set bits there.
	(df_worklist_propagate_backward): Likewise.
	(df_worklist_dataflow_doublequeue): Separate first pass
	over all blocks with NULL worklist.
	(df_worklist_dataflow): Do not initialize pending and adjust.

2024-12-09  Thomas Schwinge  <tschwinge@baylibre.com>

	* config.gcc [nvptx-*]: Switch default from '-march=sm_30' to
	'-march=sm_52'.
	* doc/install.texi (Nvidia PTX Options): Update.

2024-12-09  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/gcn/gcn.cc (gcn_vec_constant): Fix 'real_from_integer'
	usage.

2024-12-09  Kyrylo Tkachov  <ktkachov@nvidia.com>

	* config/aarch64/aarch64-option-extensions.def (sve-b16b16,
	f32mm, f64mm, sve2p1, sme-f64f64, sme-i16i64, sme-b16b16,
	sme-f16f16, mops): Update FEATURE_STRING field.

2024-12-09  Simon Martin  <simon@nasilyan.com>

	PR c++/117845
	* tree-eh.cc (honor_protect_cleanup_actions): Support empty
	finally sequences.

2024-12-08  Lewis Hyatt  <lhyatt@gmail.com>

	* gimple.h (struct gphi): Update word marking comments to reflect
	the new size of location_t.
	(struct gimple): Likewise. Add a comment about padding.
	* common.opt: Mark -flarge-source-files as Ignored.
	* common.opt.urls: Regenerate.
	* doc/invoke.texi: Remove -flarge-source-files.
	* toplev.cc (process_options): Remove support for
	-flarge-source-files.

2024-12-08  Dimitar Dimitrov  <dimitar@dinux.eu>

	* config/pru/pru.cc (pru_print_operand): Implement c and n
	inline assembly operand modifiers.

2024-12-07  Eric Botcazou  <ebotcazou@adacore.com>

	* config/sparc/sparc.md (VIS4B instructions): Add comments.

2024-12-07  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_print_operand_address): Use
	avr_insn_location as location for late (during final) diagnostic.

2024-12-07  Jakub Jelinek  <jakub@redhat.com>

	PR target/117930
	* config/i386/i386.md (crotate): New define_code_attr.
	(*<insn><mode>3_add, *<insn><mode>3_add_1,
	*<insn><mode>3_sub, *<insn><mode>3_sub_1): New define_insn_and_split
	patterns plus following define_split for constant first input
	operand.

2024-12-07  Denis Chertykov  <chertykov@gmail.com>

	PR target/116778
	* lra-lives.cc (complete_info_p): Clarification of the comment.
	* lra.cc (lra): Create a full live info after rematerialization.

2024-12-07  Kito Cheng  <kito.cheng@sifive.com>

	Revert:
	2024-12-05  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/riscv-vector-builtins-shapes.cc
	(vsetvl_def::get_name): Adjust return type.
	(loadstore_def::get_name): Ditto.
	(indexed_loadstore_def::get_name): Ditto.
	(th_loadstore_width_def::get_name): Ditto.
	(th_indexed_loadstore_width_def::get_name): Ditto.
	(alu_def::get_name): Ditto.
	(alu_frm_def::get_name): Ditto.
	(widen_alu_frm_def::get_name): Ditto.
	(narrow_alu_frm_def::get_name): Ditto.
	(reduc_alu_frm_def::get_name): Ditto.
	(widen_alu_def::get_name): Ditto.
	(no_mask_policy_def::get_name): Ditto.
	(return_mask_def::get_name): Ditto.
	(narrow_alu_def::get_name): Ditto.
	(move_def::get_name): Ditto.
	(mask_alu_def::get_name): Ditto.
	(reduc_alu_def::get_name): Ditto.
	(th_extract_def::get_name): Ditto.
	(scalar_move_def::get_name): Ditto.
	(vundefined_def::get_name): Ditto.
	(misc_def::get_name): Ditto.
	(vset_def::get_name): Ditto.
	(vcreate_def: Ditto.::get_name): Ditto.
	(read_vl_def::get_name): Ditto.
	(fault_load_def::get_name): Ditto.
	(vlenb_def::get_name): Ditto.
	(seg_loadstore_def::get_name): Ditto.
	(seg_indexed_loadstore_def::get_name): Ditto.
	(seg_fault_load_def::get_name): Ditto.
	(crypto_vv_def::get_name): Ditto.
	(crypto_vi_def::get_name): Ditto.
	(crypto_vv_no_op_type_def::get_name): Ditto.
	(sf_vqmacc_def::get_name): Ditto.
	(sf_vqmacc_def::get_name): Ditto.
	(sf_vfnrclip_def::get_name): Ditto.
	* config/riscv/riscv-vector-builtins.cc
	(function_builder::add_unique_function): Adjust the type for the
	function name holder.
	(function_builder::add_overloaded_function): Ditto.
	* config/riscv/riscv-vector-builtins.h (function_shape::get_name): Add
	const to the return type.

2024-12-07  Lewis Hyatt  <lhyatt@gmail.com>

	* libgdiagnostics.cc (struct diagnostic_manager): Use location_t(-1)
	instead of UINT_MAX to support 64-bit location_t as well.
	(diagnostic_manager::diagnostic_manager): Change hard-coded "5" to
	line_map_suggested_range_bits.

2024-12-07  Lewis Hyatt  <lhyatt@gmail.com>

	* rtl.def (DEBUG_INSN): Use new format code 'L' for location_t fields.
	(INSN): Likewise.
	(JUMP_INSN): Likewise.
	(CALL_INSN): Likewise.
	(ASM_INPUT): Likewise.
	(ASM_OPERANDS): Likewise.
	* rtl.h (union rtunion): Add new location_t RT_LOC member for use by
	the 'L' format.
	(struct rtx_debug_insn): Adjust comment.
	(struct rtx_nonjump_insn): Adjust comment.
	(struct rtx_call_insn): Adjust comment.
	(XLOC): New accessor macro for rtunion::rt_loc.
	(X0LOC): Likewise.
	(XCLOC): Likewise.
	(INSN_LOCATION): Use XLOC instead of XUINT to retrieve a location_t.
	(NOTE_MARKER_LOCATION): Likewise for XCUINT -> XCLOC.
	(ASM_OPERANDS_SOURCE_LOCATION): Likewise.
	(ASM_INPUT_SOURCE_LOCATION):Likewise.
	(gen_rtx_ASM_INPUT): Adjust to use sL format instead of si.
	(gen_rtx_INSN): Adjust prototype to use location_r rather than int
	for the location.
	* cfgrtl.cc (force_nonfallthru_and_redirect): Change type of LOC
	local variable from int to location_t.
	* rtlhash.cc (add_rtx): Support 'L' format in the switch statement.
	* var-tracking.cc (loc_cmp): Likewise.
	* alias.cc (rtx_equal_for_memref_p): Likewise.
	* config/alpha/alpha.cc (summarize_insn): Likewise.
	* config/ia64/ia64.cc (rtx_needs_barrier): Likewise.
	* config/rs6000/rs6000.cc (rs6000_hash_constant): Likewise.
	* cse.cc (hash_rtx): Likewise.
	(exp_equiv_p): Likewise.
	* cselib.cc (rtx_equal_for_cselib_1): Likewise.
	(cselib_hash_rtx): Likewise.
	(cselib_expand_value_rtx_1): Likewise.
	* emit-rtl.cc (copy_insn_1): Likewise.
	(gen_rtx_INSN): Change the location argument from int to location_t,
	and call the corresponding gen_rtf_fmt_* function.
	* final.cc (leaf_renumber_regs_insn): Support 'L' format in the
	switch statement.
	* genattrtab.cc (attr_rtx_1): Likewise.
	* genemit.cc (gen_exp): Likewise.
	* gengenrtl.cc (type_from_format): Likewise.
	(accessor_from_format): Likewise.
	* gengtype.cc (adjust_field_rtx_def): Likewise.
	* genpeep.cc (match_rtx): Likewise; just mark gcc_unreachable() for
	now.
	* genrecog.cc (find_operand): Support 'L' format in the switch statement.
	(find_matching_operand): Likewise.
	(validate_pattern): Likewise.
	* gensupport.cc (subst_pattern_match): Likewise.
	(get_alternatives_number): Likewise.
	(collect_insn_data): Likewise.
	(alter_predicate_for_insn): Likewise.
	(alter_constraints): Likewise.
	(subst_dup): Likewise.
	* jump.cc (rtx_renumbered_equal_p): Likewise.
	* loop-invariant.cc (hash_invariant_expr_1): Likewise.
	* lra-constraints.cc (operands_match_p): Likewise.
	* lra.cc (lra_rtx_hash): Likewise.
	* print-rtl.cc (rtx_writer::print_rtx_operand_code_i): Refactor
	location_t-relevant code to...
	(rtx_writer::print_rtx_operand_code_L): ...new function here.
	(rtx_writer::print_rtx_operand): Support 'L' format in the switch statement.
	* print-rtl.h (rtx_writer::print_rtx_operand_code_L): Add prototype
	for new function.
	* read-rtl-function.cc (function_reader::read_rtx_operand): Support
	'L' format in the switch statement.
	(function_reader::read_rtx_operand_i_or_n): Rename to...
	(function_reader::read_rtx_operand_inL): ...this, and support 'L' as
	well.
	* read-rtl.cc (apply_int_iterator): Support 'L' format in the switch
	statement.
	(rtx_reader::read_rtx_operand): Likewise.
	* reload.cc (operands_match_p): Likewise.
	* rtl.cc (rtx_format): Add new code 'L'.
	(rtx_equal_p): Support 'L' in the switch statement. Remove dead code
	in the handling for 'i' and 'n'.

2024-12-07  Lewis Hyatt  <lhyatt@gmail.com>

	* final.cc (reemit_insn_block_notes): Don't try to call
	INSN_LOCATION on a NOTE rtl object. Don't call change_scope () for a
	NOTE missing a location.

2024-12-07  Lewis Hyatt  <lhyatt@gmail.com>

	* tree-parloops.cc (struct reduction_info): Store the result of the
	reduction PHI rather than the PHI itself.
	(reduction_info::reduc_phi): New member function.
	(reduction_hasher::equal): Adapt to the change in struct reduction_info.
	(reduction_phi): Likewise.
	(initialize_reductions): Likewise.
	(create_call_for_reduction_1): Likewise.
	(transform_to_exit_first_loop_alt): Likewise.
	(transform_to_exit_first_loop): Likewise.
	(build_new_reduction): Likewise.
	(set_reduc_phi_uids): Likewise.
	(try_create_reduction_list): Likewise.
	* tree-ssa-loop-split.cc (split_loop): Remember the PHI result
	variable so that the PHI can be found in case it is resized and move
	to a new address.
	* tree-vect-loop-manip.cc (vect_loop_versioning): After calling
	loop_version(), fix up stored PHI pointers in case they have
	changed.
	* tree-vectorizer.cc (vec_info::resync_stmt_addr): New function.
	* tree-vectorizer.h (vec_info::resync_stmt_addr): Declare.

2024-12-06  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/117467
	* gimple-range-infer.cc (infer_range_manager::add_ranges): Check
	range_of_expr to see if the inferred range is needed.

2024-12-06  Andrew MacLeod  <amacleod@redhat.com>

	* gimple-range-cache.cc (ranger_cache::ranger_cache): Create the
	infer oracle using THIS as the range_query.
	* gimple-range-infer.cc (gimple_infer_range::gimple_infer_range):
	Add a range_query to the constructor and use it.
	(infer_range_manager::infer_range_manager): Add a range_query.
	* gimple-range-infer.h (gimple_infer_range): Adjust prototype.
	(infer_range_manager): Add a range_query.
	* value-query.cc (range_query::create_infer_oracle): Add a range_query.
	* value-query.h (range_query::create_infer_oracle): Update prototype.

2024-12-06  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/117467
	* gimple-range-cache.cc (ranger_cache::entry_range): Do not
	invoke range_from_dom for invariant ssa-names.

2024-12-06  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/117248
	* lra-lives.cc (start_living, start_dying): Remove.
	(insn_regnos, out_insn_regnos, insn_regnos_live_after): New.
	(sparseset_contains_pseudos_p): Remove.
	(make_hard_regno_live, make_hard_regno_dead): Return true if
	something in liveness is changed.
	(mark_pseudo_live,  mark_pseudo_dead): Ditto.
	(mark_regno_live, mark_regno_dead): Ditto.
	(clear_sparseset_regnos, regnos_in_sparseset_p): Use set instead
	of dead_set.
	(process_bb_lives): Rewrite dealing with reg notes.  Update
	conflict hard regs even when clobber hard reg is not marked as
	dead.
	(lra_create_live_ranges_1): Add initialization/finalization of
	insn_regnos, out_insn_regnos, insn_regnos_live_after.

2024-12-06  Jeff Law  <jlaw@ventanamicro.com>

	PR tree-optimization/117895
	* expr.cc (calculate_table_based_CRC): Drop CRC_MODE argument.
	Convert DATA to CRC's mode, then do calculations in CRC's mode.
	(expand_crc_table_based): Corresponding changes.
	(expand_reversed_crc_table_based): Corresponding changes.

2024-12-06  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.cc (ix86_decompose_address):
	Add missing part from my previous commit.

2024-12-06  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.cc (ix86_decompose_address): Eliminate
	common code and use use UINTVAL and HOST_WIDE_INT_UC macros
	in the condition for AND wrapped address.

2024-12-06  Uros Bizjak  <ubizjak@gmail.com>

	PR target/117926
	* config/i386/mmx.md (UNSPEC_3DNOW): New unspec.
	(mmx_addv2sf3): Tag insn with UNSPEC_3DNOW tag.
	(*mmx_addv2sf3): Ditto.
	(mmx_sub2vsf3): Ditto.
	(mmx_subrv2sf3): Ditto.
	(*mmx_subv2sf3): Ditto.
	(mmx_mulv2sf3): Ditto.
	(mmx_<smaxmin:code>v2sf3): Ditto.
	(*mmx_<smaxmin:code>v2sf3): Ditto.
	(mmx_ieee_<ieee_maxmin>v2sf3): Ditto.
	(mmx_eqv2sf3): Ditto.
	(*mmx_eqv2sf3): Ditto.
	(mmx_gtv2sf3): Ditto.
	(mmx_gev2sf3): Ditto.
	(mmx_fix_truncv2sfv2si2): Ditto.
	(mmx_floatv2siv2sf2): Ditto.

2024-12-06  David Malcolm  <dmalcolm@redhat.com>

	* diagnostic.cc (diagnostic_context::override_urlifier): New.
	* diagnostic.h (diagnostic_context::override_urlifier): New decl.
	* doc/extend.texi (Nvidia PTX Function Attributes): Update
	@cindex to specify that "kernel" is a function attribute and
	"shared" is a variable attribute, so that these entries are
	recognized by the regex in regenerate-attr-urls.py.
	* doc/tm.texi: Regenerate.
	* doc/tm.texi.in (TARGET_DOCUMENTATION_NAME): New.
	* gcc-attribute-urlifier.cc: New file.
	* gcc-urlifier.cc: Include diagnostic.h.
	(gcc_urlifier::make_doc): Convert to...
	(make_doc_url): ...this.
	(auto_override_urlifier::auto_override_urlifier): New.
	(auto_override_urlifier::~auto_override_urlifier): New.
	(selftest::gcc_urlifier_cc_tests): Split out body into...
	(selftest::test_gcc_urlifier): ...this.
	* gcc-urlifier.h: Include "pretty-print-urlifier.h" and "label-text.h".
	(make_doc_url): New decl.
	(class auto_override_urlifier): New.
	(class attribute_urlifier): New.
	(class auto_urlify_attributes): New.
	* gimple-ssa-warn-access.cc: Include "gcc-urlifier.h".
	(pass_waccess::execute): Use auto_urlify_attributes.
	* gimplify.cc: Include "gcc-urlifier.h".
	(expand_FALLTHROUGH): Use auto_urlify_attributes.
	* internal-fn.cc: Define INCLUDE_MEMORY and include
	"gcc-urlifier.h.
	(expand_FALLTHROUGH): Use auto_urlify_attributes.
	* ipa-pure-const.cc: Include "gcc-urlifier.h.
	(suggest_attribute): Use auto_urlify_attributes.
	* ipa-strub.cc: Include "gcc-urlifier.h.
	(can_strub_p): Use auto_urlify_attributes.
	* regenerate-attr-urls.py: New file.
	* selftest-run-tests.cc (selftest::run_tests): Call
	gcc_attribute_urlifier_cc_tests.
	* selftest.h (selftest::gcc_attribute_urlifier_cc_tests): New
	decl.
	* target.def (documentation_name): New DEFHOOKPOD.
	* tree-cfg.cc: Include "gcc-urlifier.h.
	(do_warn_unused_result): Use auto_urlify_attributes.
	* tree-ssa-uninit.cc: Include "gcc-urlifier.h.
	(maybe_warn_read_write_only): Use auto_urlify_attributes.
	(maybe_warn_pass_by_reference): Likewise.

2024-12-06  David Malcolm  <dmalcolm@redhat.com>

	* Makefile.in (OBJS): Add -attribute-urlifier.o.
	(ATTR_URLS_HTML_DEPS): New.
	(regenerate-attr-urls): New.
	(regenerate-attr-urls-unit-test): New.
	* attr-urls.def: New file.
	* attribs.cc: Include "gcc-urlifier.h".
	(decl_attributes): Use auto_urlify_attributes.
	* config/aarch64/aarch64.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/arc/arc.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/arm/arm.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/bfin/bfin.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/bpf/bpf.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/epiphany/epiphany.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/gcn/gcn.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/h8300/h8300.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/i386/i386.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/ia64/ia64.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/m32c/m32c.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/m32r/m32r.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/m68k/m68k.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/mcore/mcore.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/microblaze/microblaze.cc (TARGET_DOCUMENTATION_NAME):
	New.
	* config/mips/mips.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/msp430/msp430.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/nds32/nds32.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/nvptx/nvptx.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/riscv/riscv.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/rl78/rl78.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/rs6000/rs6000.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/rx/rx.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/s390/s390.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/sh/sh.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/stormy16/stormy16.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/v850/v850.cc (TARGET_DOCUMENTATION_NAME): New.
	* config/visium/visium.cc (TARGET_DOCUMENTATION_NAME): New.

2024-12-06  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.opt.urls: Rebuild.

2024-12-06  Georg-Johann Lay  <avr@gjlay.de>

	* common/config/avr/avr-common.cc
	(avr_option_optimization_table): Default to -fno-optimize-crc.

2024-12-06  kelefth  <konstantinos.eleftheriou@vrull.eu>

	PR rtl-optimization/117816
	* avoid-store-forwarding.cc (store_forwarding_analyzer::avoid_store_forwarding):
	Reject the transformation when having instructions that may
	throw exceptions in the sequence.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-sm.def: Add '89'.
	* config/nvptx/nvptx-gen.h: Regenerate.
	* config/nvptx/nvptx-gen.opt: Likewise.
	* config/nvptx/nvptx.cc (first_ptx_version_supporting_sm): Adjust.
	* config/nvptx/nvptx.opt (-march-map=sm_89, -march-map=sm_90)
	(march-map=sm_90a): Likewise.
	* config.gcc: Likewise.
	* doc/invoke.texi (Nvidia PTX Options): Document '-march=sm_89'.
	* config/nvptx/gen-multilib-matches-tests: Extend.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-opts.h (enum ptx_version): Add
	'PTX_VERSION_7_8'.
	* config/nvptx/nvptx.cc (ptx_version_to_string)
	(ptx_version_to_number): Adjust.
	* config/nvptx/nvptx.h (TARGET_PTX_7_8): New.
	* config/nvptx/nvptx.opt (Enum(ptx_version)): Add 'EnumValue'
	'7.8' for 'PTX_VERSION_7_8'.
	* doc/invoke.texi (Nvidia PTX Options): Document '-mptx=7.8'.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-sm.def: Add '52'.
	* config/nvptx/nvptx-gen.h: Regenerate.
	* config/nvptx/nvptx-gen.opt: Likewise.
	* config/nvptx/nvptx.cc (first_ptx_version_supporting_sm): Adjust.
	* config/nvptx/nvptx.opt (-march-map=sm_52): Likewise.
	* config.gcc: Likewise.
	* doc/invoke.texi (Nvidia PTX Options): Document '-march=sm_52'.
	* config/nvptx/gen-multilib-matches-tests: Extend.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-sm.def: Add '37'.
	* config/nvptx/nvptx-gen.h: Regenerate.
	* config/nvptx/nvptx-gen.opt: Likewise.
	* config/nvptx/nvptx.cc (first_ptx_version_supporting_sm): Adjust.
	* config/nvptx/nvptx.opt (-march-map=sm_37, -march-map=sm_50):
	Likewise.
	* config.gcc: Likewise.
	* doc/invoke.texi (Nvidia PTX Options): Document '-march=sm_37'.
	* config/nvptx/gen-multilib-matches-tests: Extend.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-opts.h (enum ptx_version): Add
	'PTX_VERSION_4_1'.
	* config/nvptx/nvptx.cc (ptx_version_to_string)
	(ptx_version_to_number): Adjust.
	* config/nvptx/nvptx.h (TARGET_PTX_4_1): New.
	* config/nvptx/nvptx.opt (Enum(ptx_version)): Add 'EnumValue'
	'4.1' for 'PTX_VERSION_4_1'.
	* doc/invoke.texi (Nvidia PTX Options): Document '-mptx=4.1'.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx.h (TARGET_PTX_4_2): New.
	* config/nvptx/nvptx.opt (Enum(ptx_version)): Add 'EnumValue'
	'4.2' for 'PTX_VERSION_4_2'.
	* doc/invoke.texi (Nvidia PTX Options): Document '-mptx=4.2'.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx-opts.h (enum ptx_version): Remove
	'PTX_VERSION_3_0'.
	* config/nvptx/nvptx.cc (first_ptx_version_supporting_sm)
	(default_ptx_version_option, ptx_version_to_string)
	(ptx_version_to_number): Adjust.
	* config/nvptx/nvptx.h: Comment.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config.gcc: nvptx: Support '--with-multilib-list'.
	* config/nvptx/gen-multilib-matches.sh: Adjust.
	* configure.ac: Likewise.
	* configure: Regenerate.
	* doc/install.texi: Update.
	* doc/invoke.texi: Align.
	* config/nvptx/gen-multilib-matches-tests: Extend.

2024-12-06  Jakub Jelinek  <jakub@redhat.com>

	* gimplify.cc (gimplify_init_ctor_eval): Use RAW_DATA_UCHAR_ELT
	macro.
	* gimple-fold.cc (fold_array_ctor_reference): Likewise.
	* tree-pretty-print.cc (dump_generic_node): Use RAW_DATA_UCHAR_ELT
	and RAW_DATA_SCHAR_ELT macros.
	* fold-const.cc (fold): Use RAW_DATA_UCHAR_ELT macro.

2024-12-06  Richard Biener  <rguenther@suse.de>

	* match.pd: Remove redundant :c, reported by genmatch as
	duplicate patterns.

2024-12-06  Richard Biener  <rguenther@suse.de>

	* match.pd (.SAT_ADD patterns using IFN_ADD_OVERFLOW): Remove :c that
	only causes duplicate patterns.

2024-12-06  Hau Hsu  <hau.hsu@sifive.com>
	    Kito Cheng  <kito.cheng@sifive.com>

	* config.gcc (riscv*-*-*): Add support for --with-cmodel configure option.
	(all_defaults): Add cmodel.
	* config/riscv/riscv.h (TARGET_DEFAULT_CMODEL): Remove.
	* doc/install.texi: Document --with-cmodel configure option.
	* doc/invoke.texi (-mcmodel): Mention --with-cmodel configure option.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/gen-multilib-matches.sh: Support '--selftest'.
	* config/nvptx/t-nvptx (t-nvptx-gen-multilib-matches:): Invoke it.
	* config/nvptx/gen-multilib-matches-tests: New.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/gen-h.sh: Don't pass in '$1'; compute it locally.
	* config/nvptx/gen-multilib-matches.sh: Likewise.
	* config/nvptx/gen-omp-device-properties.sh: Likewise.
	* config/nvptx/gen-opt.sh: Likewise.
	* config/nvptx/t-nvptx (s-nvptx-gen-h:, s-nvptx-gen-opt:)
	(t-nvptx-gen-multilib-matches:): Adjust.
	* config/nvptx/t-omp-device (omp-device-properties-nvptx):
	Likewise.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/gen-multilib-matches.sh: Encapsulate main logic.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/t-nvptx (multilib_matches): Don't use the 'shell'
	function of 'make'.
	* config/nvptx/gen-multilib-matches.sh: Adjust.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	PR target/117916
	* config/nvptx/nvptx.opt (misa=, mptx=): Tag as 'Negative' of
	themselves.

2024-12-06  Thomas Schwinge  <tschwinge@baylibre.com>

	PR testsuite/82250
	* gimple-fold.cc (gimple_fold_builtin_acc_on_device): Revert last
	change.

2024-12-06  Jakub Jelinek  <jakub@redhat.com>

	* tree.h (RAW_DATA_UCHAR_ELT, RAW_DATA_SCHAR_ELT): Define.

2024-12-06  Jennifer Schmitz  <jschmitz@nvidia.com>

	PR target/106329
	* config/aarch64/aarch64-sve-builtins-base.cc
	(svac_impl::fold): Add folding if pfalse predicate.
	(svadda_impl::fold): Likewise.
	(class svaddv_impl): Likewise.
	(class svandv_impl): Likewise.
	(svclast_impl::fold): Likewise.
	(svcmp_impl::fold): Likewise.
	(svcmp_wide_impl::fold): Likewise.
	(svcmpuo_impl::fold): Likewise.
	(svcntp_impl::fold): Likewise.
	(class svcompact_impl): Likewise.
	(class svcvtnt_impl): Likewise.
	(class sveorv_impl): Likewise.
	(class svminv_impl): Likewise.
	(class svmaxnmv_impl): Likewise.
	(class svmaxv_impl): Likewise.
	(class svminnmv_impl): Likewise.
	(class svorv_impl): Likewise.
	(svpfirst_svpnext_impl::fold): Likewise.
	(svptest_impl::fold): Likewise.
	(class svsplice_impl): Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.cc
	(class svcvtxnt_impl): Likewise.
	(svmatch_svnmatch_impl::fold): Likewise.
	* config/aarch64/aarch64-sve-builtins.cc
	(is_pfalse): Return true if tree is pfalse.
	(gimple_folder::fold_pfalse): Fold calls with pfalse predicate.
	(gimple_folder::fold_call_to): Fold call to lhs = t for given tree t.
	(gimple_folder::fold_to_stmt_vops): Helper function that folds the
	call to given stmt and adjusts virtual operands.
	(gimple_folder::fold): Call fold_pfalse.
	* config/aarch64/aarch64-sve-builtins.h (is_pfalse): Declare is_pfalse.

2024-12-06  Richard Biener  <rguenther@suse.de>

	PR rtl-optimization/117922
	* timevar.def (TV_FOLD_MEM_OFFSETS): New.
	* fold-mem-offsets.cc (pass_data_fold_mem): Use TV_FOLD_MEM_OFFSETS.

2024-12-05  Uros Bizjak  <ubizjak@gmail.com>

	PR target/117860
	* config/i386/i386.cc (ix86_canonicalize_comparison): Swap
	operands of GTU comparison to canonicalize addcarry/subborrow
	comparison.
	(ix86_cc_mode): Return CCCmode for the comparison of
	addcarry/subborrow pattern.
	* config/i386/i386.md (addcarry<mode>): Swap operands of
	PLUS RTX to make it canonical.
	(*addcarry<mode>_1): Ditto.
	(addcarry peephole2s): Update RTXes for addcarry<mode>_1 change.
	(*add<dwi>3_doubleword_cc_overflow_1): Ditto.
	(*subborrow<mode>_1): New insn pattern.

2024-12-05  Richard Earnshaw  <rearnsha@arm.com>

	* config/arm/mmintrin.h: Raise an error if this header is used.
	Remove other content.

2024-12-05  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-simd-pragma-builtins.def
	(ENTRY_TERNARY_VLUT8): Use FLAG_QUIET rather than FLAG_DEFAULT.
	(ENTRY_TERNARY_VLUT16): Likewise.

2024-12-05  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc (FLAG_QUIET): Redefine to 0,
	replacing the old flag with...
	(FLAG_AUTO_FP): ...this.
	(FLAG_DEFAULT): Redefine to FLAG_AUTO_FP.
	(aarch64_call_properties): Update accordingly.

2024-12-05  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc (FLAG_NONE): Rename to...
	(FLAG_DEFAULT): ...this and update all references.
	* config/aarch64/aarch64-simd-builtins.def: Update all references
	here too.
	* config/aarch64/aarch64-simd-pragma-builtins.def: Likewise.

2024-12-05  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc (FLAG_AUTO_FP): Rename to...
	(FLAG_QUIET): ...this and update all references.
	* config/aarch64/aarch64-simd-builtins.def: Update all references
	here too.

2024-12-05  Pan Li  <pan2.li@intel.com>

	* match.pd: Refactor sorts of unsigned SAT_TRUNC match patterns.

2024-12-05  Richard Biener  <rguenther@suse.de>

	PR middle-end/117801
	* tree-outof-ssa.cc (ssa_is_replaceable_p): Make
	direct internal function calls replaceable.
	* expr.cc (get_def_for_expr): Handle replacements with calls.
	(get_def_for_expr_class): Likewise.
	(optimize_bitfield_assignment_op): Likewise.
	(expand_expr_real_1): Likewise.  Properly expand direct
	internal function defs.
	* cfgexpand.cc (expand_call_stmt): Handle replacements with calls.
	(avoid_deep_ter_for_debug): Likewise, always create a debug temp
	for calls.
	(expand_debug_expr): Likewise, give up for calls.
	(expand_gimple_basic_block): Likewise.
	* ccmp.cc (ccmp_candidate_p): Likewise.
	(get_compare_parts): Likewise.

2024-12-05  Arvin Zhong  <Arvin.Zhong@armchina.com>

	* config/arm/arm-cpus.in (star-mc1): Add CDE options.
	* doc/invoke.texi (cdecp options): Document for star-mc1.

2024-12-05  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/113994
	PR rtl-optimization/116799
	* loop-doloop.cc: Include targhooks.h.
	(doloop_optimize): Also punt on intersection of modified
	with df_get_live_in (desc->out_edge->dest).
	(doloop_optimize_loops): Call df_analyze.  Use
	LI_ONLY_INNERMOST or LI_FROM_INNERMOST instead of 0 as
	second loops_list argument.

2024-12-05  Jakub Jelinek  <jakub@redhat.com>

	PR c/107980
	* ginclude/stdarg.h (va_start): For C23+ change parameters from
	v, ... to just ... and define to __builtin_c23_va_start(__VA_ARGS__)
	rather than __builtin_va_start(v, 0).

2024-12-05  Georg-Johann Lay  <avr@gjlay.de>

	PR target/107957
	* config/avr/avr-passes-fuse-move.h (bbinfo_t) <try_mem0_p>:
	Add static property.
	* config/avr/avr-passes.cc (bbinfo_t::try_mem0_p): Define it.
	(optimize_data_t::try_mem0): New method.
	(bbinfo_t::optimize_one_block) [bbinfo_t::try_mem0_p]: Run try_mem0.
	(bbinfo_t::optimize_one_function): Set bbinfo_t::try_mem0_p.
	* config/avr/avr.md (pushhi1_insn): Also allow zero as source.
	(define_split) [avropt_split_ldst]: Only run avr_split_ldst()
	when avr-fuse-move has been run at least once.
	* doc/invoke.texi (AVR Options) <-msplit-ldst>: Document it.

2024-12-05  Georg-Johann Lay  <avr@gjlay.de>

	PR target/107957
	* config/avr/avr.opt (-msplit-ldst, avropt_split_ldst):
	New option and associated var.
	* common/config/avr/avr-common.cc (avr_option_optimization_table)
	[OPT_LEVELS_2_PLUS]: Turn on -msplit_ldst.
	* config/avr/avr-passes.cc (splittable_address_p)
	(avr_byte_maybe_mem, avr_split_ldst): New functions.
	* config/avr/avr-protos.h (avr_split_ldst): New proto.
	* config/avr/avr.md (define_split) [avropt_split_ldst]: Run
	avr_split_ldst().

2024-12-05  Georg-Johann Lay  <avr@gjlay.de>

	PR target/64242
	* config/avr/avr.md (nonlocal_goto): Don't restore
	hard_frame_pointer_rtx directly, but copy it to local
	register, and only set hard_frame_pointer_rtx from it
	after emit_stack_restore().

2024-12-05  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr-protos.h (avr_out_add_msb): New proto.
	* config/avr/avr.cc (avr_out_add_msb): New function.
	(avr_adjust_insn_length) [ADJUST_LEN_ADD_GE0,
	ADJUST_LEN_ADD_LT0]: Handle cases.
	* config/avr/avr.md (adjust_len) <add_lt0, add_ge0>: New attr values.
	(QISI2): New mode iterator.
	(C_MSB): New mode_attr.
	(*add<mode>3...msb_split, *add<mode>3.ge0, *add<mode>3.lt0)
	(*sub<mode>3...msb_split, *sub<mode>3.ge0, *sub<mode>3.lt0): New
	patterns replacing old ones, but with iterators and
	using avr_out_add_msb() for asm out.

2024-12-05  Filip Kastl  <fkastl@suse.cz>

	* doc/invoke.texi: Add store-forwarding-max-distance.

2024-12-05  Filip Kastl  <fkastl@suse.cz>

	* params.opt: Add missing '=' after -param=cycle-accurate-model.

2024-12-05  Jakub Jelinek  <jakub@redhat.com>

	PR c/41045
	* output.h (insn_noperands): Declare.
	* final.cc (insn_noperands): No longer static.
	* varasm.cc (assemble_asm): Handle ASM_EXPR.
	* lto-streamer-out.cc (lto_output_toplevel_asms): Add sorry_at
	for non-STRING_CST toplevel asm for now.
	* doc/extend.texi (Basic @code{asm}, Extended @code{asm}): Document
	that extended asm is now allowed outside of functions with certain
	restrictions.

2024-12-05  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/riscv-vector-builtins-shapes.cc
	(vsetvl_def::get_name): Adjust return type.
	(loadstore_def::get_name): Ditto.
	(indexed_loadstore_def::get_name): Ditto.
	(th_loadstore_width_def::get_name): Ditto.
	(th_indexed_loadstore_width_def::get_name): Ditto.
	(alu_def::get_name): Ditto.
	(alu_frm_def::get_name): Ditto.
	(widen_alu_frm_def::get_name): Ditto.
	(narrow_alu_frm_def::get_name): Ditto.
	(reduc_alu_frm_def::get_name): Ditto.
	(widen_alu_def::get_name): Ditto.
	(no_mask_policy_def::get_name): Ditto.
	(return_mask_def::get_name): Ditto.
	(narrow_alu_def::get_name): Ditto.
	(move_def::get_name): Ditto.
	(mask_alu_def::get_name): Ditto.
	(reduc_alu_def::get_name): Ditto.
	(th_extract_def::get_name): Ditto.
	(scalar_move_def::get_name): Ditto.
	(vundefined_def::get_name): Ditto.
	(misc_def::get_name): Ditto.
	(vset_def::get_name): Ditto.
	(vcreate_def: Ditto.::get_name): Ditto.
	(read_vl_def::get_name): Ditto.
	(fault_load_def::get_name): Ditto.
	(vlenb_def::get_name): Ditto.
	(seg_loadstore_def::get_name): Ditto.
	(seg_indexed_loadstore_def::get_name): Ditto.
	(seg_fault_load_def::get_name): Ditto.
	(crypto_vv_def::get_name): Ditto.
	(crypto_vi_def::get_name): Ditto.
	(crypto_vv_no_op_type_def::get_name): Ditto.
	(sf_vqmacc_def::get_name): Ditto.
	(sf_vqmacc_def::get_name): Ditto.
	(sf_vfnrclip_def::get_name): Ditto.
	* config/riscv/riscv-vector-builtins.cc
	(function_builder::add_unique_function): Adjust the type for the
	function name holder.
	(function_builder::add_overloaded_function): Ditto.
	* config/riscv/riscv-vector-builtins.h (function_shape::get_name): Add
	const to the return type.

2024-12-04  David Malcolm  <dmalcolm@redhat.com>

	* doc/libgdiagnostics/topics/execution-paths.rst: Add '§' before
	references to section of SARIF spec.
	* doc/libgdiagnostics/topics/fix-it-hints.rst: Likewise.
	* doc/libgdiagnostics/tutorial/01-hello-world.rst: Fix typo.
	* doc/libgdiagnostics/tutorial/02-physical-locations.rst: Likewise.
	* doc/libgdiagnostics/tutorial/04-notes.rst: Likewise.
	* doc/libgdiagnostics/tutorial/06-fix-it-hints.rst: Add link to
	diagnostic_add_fix_it_hint_replace.
	* doc/libgdiagnostics/tutorial/07-execution-paths.rst: Add '§'.

2024-12-04  Vineet Gupta  <vineetg@rivosinc.com>

	* haifa-sched.cc (model_choose_insn): Dump unscheduled_preds.
	(model_dump_pressure_summary): Dump bb->index.
	(model_start_schedule): Pass bb.
	* sched-rgn.cc (debug_dependencies): Dump SD_LIST_HARD_BACK deps.

2024-12-04  Vineet Gupta  <vineetg@rivosinc.com>

	PR target/11472
	* params.opt (--param=cycle-accurate-model=): New opt.
	* doc/invoke.texi (cycle-accurate-model): Document.
	* haifa-sched.cc (model_excess_group_cost): Return negative
	delta if param_cycle_accurate_model is 0.
	(model_excess_cost): Ceil negative baseECC to 0 only if
	param_cycle_accurate_model is 1.
	Dump the actual ECC value.
	* config/riscv/riscv.cc (riscv_option_override): Set param
	to 0.

2024-12-04  Georg-Johann Lay  <avr@gjlay.de>

	PR target/84211
	* config/avr/avr-passes.cc (insninfo_t) <m_insn>: Preset to 0.
	(run_find_plies) [hamm=0, dump_file]: Don't print INSN_UID
	for a null m_insn.

2024-12-04  David Malcolm  <dmalcolm@redhat.com>

	PR translation/90160
	* config/arm/arm.cc (arm_option_check_internal): Use quotes in
	messages that refer to command-line options.  Tweak wording.

2024-12-04  Andreas Schwab  <schwab@suse.de>

	PR bootstrap/117893
	* configure.ac: Use shell loop to remove -O flags.
	* configure: Regenerate.

2024-12-04  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/116083
	* tree-vect-slp.cc (vect_build_slp_tree_1): Compute vector
	type and max_nunits only once.  Remove check for matching
	vector type of each lane and replace it with matching check
	for LHS type.

2024-12-04  Pan Li  <pan2.li@intel.com>

	PR target/117878
	* config/riscv/riscv-v.cc (vlmax_avl_type_p): Add assert for
	out of range access.
	(nonvlmax_avl_type_p): Ditto.

2024-12-04  Andrew Pinski  <quic_apinski@quicinc.com>

	PR tree-optimization/117243
	PR tree-optimization/116749
	* tree-ssa-phiopt.cc (replace_phi_edge_with_variable): Reset loop
	estimates if the cond_block was an exit to a loop.

2024-12-03  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_insn_location): New variable.
	(avr_final_prescan_insn): Set avr_insn_location.
	(avr_asm_final_postscan_insn): Unset avr_insn_location after last insn.
	(avr_print_operand): Pass avr_insn_location to warning_at.

2024-12-03  David Malcolm  <dmalcolm@redhat.com>

	* doc/libgdiagnostics/conf.py: Remove "author".  Change
	"copyright" field to the FSF.

2024-12-03  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117726
	* config/avr/avr-passes.cc (avr_split_shift_p)
	[ASHIFT, LSHIFTRT]: Allow offsets of bitsize - 1.
	(avr_split_shift4) [ASHIFT, LSHIFTRT]: Also split offset 31.
	(avr_split_shift3) [ASHIFT, LSHIFTRT]: Also split offset 23.
	(avr_split_shift2) [ASHIFT, LSHIFTRT]: Also split offset 15.

2024-12-03  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117874
	* tree-vect-slp.cc (vect_build_slp_tree_2): Perform early
	reassoc checks before eating into discovery limit.

2024-12-03  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117874
	* tree-vectorizer.h (vec_info_shared::n_stmts): Remove.
	(LOOP_VINFO_N_STMTS): Likewise.
	* tree-vectorizer.cc (vec_info_shared::vec_info_shared): Adjust.
	* tree-vect-loop.cc (vect_get_datarefs_in_loop): Do not
	count stmts.
	(vect_analyze_loop_2): Adjust.  Pass stmt_vec_info.length ()
	to vect_analyze_slp as SLP tree size limit.

2024-12-03  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117726
	* config/avr/avr-passes.cc (avr_emit_shift): All 8-bit shifts with
	an offset of 6 have 3-operand alternatives.
	* config/avr/avr.cc (ashlqi3_out, lshrqi3_out) [case 6]:
	Implement as 3-operand insn.
	(avr_rtx_costs_1) [QImode, ASHIFT + LSHIFTRT]: Adjust
	costs for offset of 6.
	* config/avr/avr.md (*ashlqi3_split, *ashlqi3)
	(*lshrqi3_split, *lshrqi3): Add "r,r,C06" alternative.

2024-12-03  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-option-extensions.def: (fp8): fix FEATURE_STRING.
	(fp8fma, ssve-fp8fma): Likewise.
	(fp8dot4, ssve-fp8dot4, fp8dot2, ssve-fp8dot2): Likewise.

2024-12-03  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/117420
	* tree-ssanames.h (get_known_nonzero_bits): Declare.
	* tree-ssanames.cc (get_nonzero_bits): New wrapper function.  Move old
	definition to ...
	(get_nonzero_bits_1): ... here, add static.  Change widest_int in
	function comment to wide_int.
	(get_known_nonzero_bits_1, get_known_nonzero_bits): New functions.
	* match.pd (with_possible_nonzero_bits2): Rename to ...
	(with_possible_nonzero_bits): ... this.  Guard the bit_and case with
	#if GENERIC.  Change to a normal match predicate without parameters.
	Rename the old with_possible_nonzero_bits match to ...
	(with_possible_nonzero_bits_1): ... this.
	(with_certain_nonzero_bits2): Remove.
	(with_known_nonzero_bits_1, with_known_nonzero_bits): New match
	predicates.
	(X == C (or X & Z == Y | C) is impossible if ~nonzero(X) & C != 0):
	Use with_known_nonzero_bits@0 instead of
	(with_certain_nonzero_bits2 @1), use with_possible_nonzero_bits@0
	instead of (with_possible_nonzero_bits2 @0) and
	get_known_nonzero_bits (@1) instead of wi::to_wide (@1).

2024-12-03  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/117847
	* gimple-lower-bitint.cc (gimple_lower_bitint) <case LROTATE_EXPR>:
	Use m = (p - n) % p instead of m = p - n for the other shift count.

2024-12-03  Tobias Burnus  <tburnus@baylibre.com>

	* cgraphunit.cc (varpool_node::finalize_decl): Set alignment
	based on OpenMP's 'omp allocate' attribute/directive.

2024-12-03  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-simd-pragma-builtins.def: Add a flags
	field to each entry.
	* config/aarch64/aarch64-builtins.cc: Update includes accordingly.
	(aarch64_pragma_builtins_data): Add a flags field.
	(aarch64_init_pragma_builtins): Use the flags field to add attributes
	to the function declaration.

2024-12-03  Saurabh Jha  <saurabh.jha@arm.com>
	    Vladimir Miloserdov  <vladimir.miloserdov@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc
	(aarch64_builtin_signatures): Add binary_lane.
	(aarch64_fntype): Handle it.
	(simd_types): Add 16-bit x2 types.
	(aarch64_pragma_builtins_checker): New class.
	(aarch64_general_check_builtin_call): Use it.
	(aarch64_expand_pragma_builtin): Add support for lut unspecs.
	* config/aarch64/aarch64-option-extensions.def
	(AARCH64_OPT_EXTENSION): Add lut option.
	* config/aarch64/aarch64-simd-pragma-builtins.def
	(ENTRY_BINARY_LANE): Modify to use new ENTRY macro.
	(ENTRY_TERNARY_VLUT8): Macro to declare lut intrinsics.
	(ENTRY_TERNARY_VLUT16): Macro to declare lut intrinsics.
	(REQUIRED_EXTENSIONS): Declare lut intrinsics.
	* config/aarch64/aarch64-simd.md
	(@aarch64_<vluti_uns_op><VLUT:mode><VB:mode>): Instruction
	pattern for luti2 and luti4 intrinsics.
	(@aarch64_lutx2<VLUT:mode><VB:mode>): Instruction pattern for
	luti4x2 intrinsics.
	* config/aarch64/aarch64.h
	(TARGET_LUT): lut flag.
	* config/aarch64/iterators.md: Iterators and attributes for lut.
	* doc/invoke.texi: Document extension in AArch64 Options.

2024-12-03  Saurabh Jha  <saurabh.jha@arm.com>
	    Vladimir Miloserdov  <vladimir.miloserdov@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-builtins.cc
	(ENTRY): Modify to add support of return and argument types.
	(struct simd_type): New struct to declare types using mode and
	qualifiers.
	(struct aarch64_pragma_builtins_data): Replace mode with
	the array of types to support return and argument types.
	(aarch64_fntype): Modify to handle different signatures.
	(aarch64_expand_pragma_builtin): Modify to handle different
	signatures.
	* config/aarch64/aarch64-simd-pragma-builtins.def
	(ENTRY_VHSDF): Rename to ENTRY_BINARY_VHSDF.
	(ENTRY_BINARY): New macro to declare binary intrinsics.
	(ENTRY_BINARY_VHSDF): Remove signature argument and use
	ENTRY_BINARY.

2024-12-03  Saurabh Jha  <saurabh.jha@arm.com>
	    Vladimir Miloserdov  <vladimir.miloserdov@arm.com>
	    Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/iterators.md: Reorder some declarations,
	putting them under the associated heading comment.

2024-12-03  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-protos.h (aarch64_v64_mode): Declare.
	(aarch64_vq_mode): Rename to...
	(aarch64_v128_mode): ...this.
	* config/aarch64/aarch64.cc (aarch64_v64_mode): New function,
	split out from...
	(aarch64_simd_container_mode): ...here.
	(aarch64_vq_mode): Rename to...
	(aarch64_v128_mode): ...this and update callers.
	* config/aarch64/aarch64-sve-builtins-base.cc: Likewise update calls.

2024-12-03  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-sve-builtins.cc (report_non_ice)
	(report_out_of_range, report_neither_nor, report_not_one_of)
	(report_not_enum): Move to...
	* config/aarch64/aarch64.cc: ...here, putting them in the aarch64
	namespace, and...
	* config/aarch64/aarch64-protos.h: ...declare them here.

2024-12-03  Pan Li  <pan2.li@intel.com>

	* match.pd: Refactor sorts of unsigned SAT_SUB match patterns.

2024-12-03  Heiko Eißfeldt  <heiko@hexco.de>
	    Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/114540
	* varasm.cc (decode_reg_name_and_count): Use strtoul instead of atoi
	and simplify verification that the whole asmspec contains just decimal
	digits.

2024-12-03  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117874
	* tree-vect-loop.cc (vect_analyze_loop_2): When non-SLP
	analysis fails, try single-lane SLP.

2024-12-02  David Malcolm  <dmalcolm@redhat.com>

	* doc/libgdiagnostics/tutorial/01-hello-world.rst: Update linker
	command for renaming.

2024-12-02  Jeff Law  <jlaw@ventanamicro.com>

	* configure.ac: Add sym-exec subdirectory.

2024-12-02  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.md (movdi+1, movdf+1, movxf+2): Split
	constraints so that the operands cannot both be "o".

2024-12-02  Jakub Jelinek  <jakub@redhat.com>

	* config/mingw/mingw-stdint.h: Add newline at the end of the file.
	* config/mingw/winnt-dll.cc: Likewise.
	* sym-exec/sym-exec-expression.h: Likewise.
	* sym-exec/sym-exec-expression.cc: Likewise.
	* sym-exec/sym-exec-condition.cc: Likewise.
	* sym-exec/sym-exec-expr-is-a-helper.h: Likewise.
	* sym-exec/sym-exec-condition.h: Likewise.
	* hwint.cc: Likewise.
	* crc-verification.cc: Likewise.
	* sarif-spec-urls.def: Likewise.

2024-12-02  Andre Vieira  <andre.simoesdiasvieira@arm.com>

	* config/arm/arm_mve.h: Add Runtime Library Exception.
	* config/arm/arm_mve_types.h: Likewise.

2024-12-02  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/116352
	PR tree-optimization/117876
	* tree-vect-slp.cc (vect_slp_can_convert_to_external): New.
	(vect_slp_convert_to_external): Call it.
	(vect_build_slp_tree_2): Likewise.

2024-12-02  yulong  <shiyulong@iscas.ac.cn>

	* config/riscv/generic-vector-ooo.md: New reservation.
	* config/riscv/genrvv-type-indexer.cc (main): New type.
	* config/riscv/riscv-vector-builtins-bases.cc (enum frm_op_type): Delete it.
	* config/riscv/riscv-vector-builtins-bases.h (enum frm_op_type): Redefine in h file.
	* config/riscv/riscv-vector-builtins-shapes.cc (struct sf_vfnrclip_def): New function.
	(SHAPE): Ditto.
	* config/riscv/riscv-vector-builtins-shapes.h: Ditto.
	* config/riscv/riscv-vector-builtins.cc (DEF_RVV_TYPE_INDEX): New builtins def.
	* config/riscv/riscv-vector-builtins.def (DEF_RVV_TYPE_INDEX): New base def.
	(signed_eew8_index): Ditto.
	* config/riscv/riscv-vector-builtins.h (enum required_ext): New extension.
	(required_ext_to_isa_name): Ditto.
	(required_extensions_specified): Ditto.
	(struct function_group_info): Ditto.
	* config/riscv/riscv.md: New attr.
	* config/riscv/sifive-vector-builtins-bases.cc (class sf_vfnrclip_x_f_qf): New function.
	(class sf_vfnrclip_xu_f_qf): Ditto.
	(BASE): New base_name.
	* config/riscv/sifive-vector-builtins-bases.h: New function_base.
	* config/riscv/sifive-vector-builtins-functions.def
	(REQUIRED_EXTENSIONS): New intrinsics def.
	(sf_vfnrclip_x_f_qf): Ditto.
	(sf_vfnrclip_xu_f_qf): Ditto.
	* config/riscv/sifive-vector.md (@pred_sf_vfnrclip<v_su><mode>_x_f_qf): New RTL mode.
	* config/riscv/vector-iterators.md: New iterator.

2024-12-02  Andreas Schwab  <schwab@suse.de>

	* config/riscv/riscv.cc (fli_value_hf, fli_value_sf)
	(fli_value_df): Use integer constants.  Constify.
	(riscv_float_const_rtx_index_for_fli): Add const.

2024-12-02  H.J. Lu  <hjl.tools@gmail.com>

	* config/i386/i386-features.cc (pass_apx_nf_convert): Change
	pass_rpad to pass_apx_nf_convert in comments.

2024-12-01  Slava Barinov  <v.barinov@samsung.com>

	* configure.ac: Only remove -O[0-9] if not preceded with comma
	* configure: Regenerated

2024-12-01  Jovan Vukic  <Jovan.Vukic@rt-rk.com>

	* tree-ssa-phiopt.cc (rhs_is_fed_for_value_replacement): Add a new
	optimization opportunity for BIT_IOR_EXPR and a != b.
	(operand_equal_for_value_replacement): Ditto.

2024-12-01  Mariam Arutunian  <mariamarutunian@gmail.com>

	* gimple-crc-optimization.cc (optimize_crc_loop): New function.
	(execute): Add optimize_crc_loop function call.

2024-12-01  Mariam Arutunian  <mariamarutunian@gmail.com>

	* Makefile.in (OBJS): Add crc-verification.o.
	* crc-verification.cc: New file.
	* crc-verification.h: New file.
	* gimple-crc-optimization.cc (loop_calculates_crc): New function.
	(is_output_crc): Likewise.
	(swap_crc_and_data_if_needed): Likewise.
	(validate_crc_and_data): Likewise.
	(optimize_crc_loop): Likewise.
	(get_output_phi): Likewise.
	(execute): Add check whether potential CRC loop calculates CRC.
	* sym-exec/sym-exec-state.cc (create_reversed_lfsr): New function.
	(create_forward_lfsr): Likewise.
	(last_set_bit): Likewise.
	(create_lfsr): Likewise.
	* sym-exec/sym-exec-state.h (is_bit_vector): Reorder, make the function public and static.
	(create_reversed_lfsr) New static function declaration.
	(create_forward_lfsr) New static function declaration.

2024-12-01  Matevos Mehrabyan  <matevosmehrabyan@gmail.com>

	* Makefile.in (OBJS): Add sym-exec/sym-exec-expression.o,
	sym-exec/sym-exec-state.o, sym-exec/sym-exec-condition.o.
	* configure (sym-exec): New subdir.
	* sym-exec/sym-exec-condition.cc: New file.
	* sym-exec/sym-exec-condition.h: New file.
	* sym-exec/sym-exec-expr-is-a-helper.h: New file.
	* sym-exec/sym-exec-expression.cc: New file.
	* sym-exec/sym-exec-expression.h: New file.
	* sym-exec/sym-exec-state.cc: New file.
	* sym-exec/sym-exec-state.h: New file.
	Co-authored-by: Mariam Arutunian <mariamarutunian@gmail.com>

2024-12-01  Mariam Arutunian  <mariamarutunian@gmail.com>

	* Makefile.in (OBJS): Add gimple-crc-optimization.o.
	* common.opt (foptimize-crc): New option.
	* common.opt.urls: Regenerate to add foptimize-crc.
	* doc/invoke.texi (-foptimize-crc): Add documentation.
	* gimple-crc-optimization.cc: New file.
	* opts.cc (default_options_table): Add OPT_foptimize_crc.
	(enable_fdo_optimizations): Enable optimize_crc.
	* passes.def (pass_crc_optimization): Add new pass.
	* timevar.def (TV_GIMPLE_CRC_OPTIMIZATION): New timevar.
	* tree-pass.h (make_pass_crc_optimization): New extern function
	declaration.

2024-12-01  Mark Harmstone  <mark@harmstone.com>

	* configure.ac (HAVE_GAS_CV_UCOMP): New check.
	* configure: Regenerate.
	* config.in: Regenerate.
	* dwarf2codeview.cc (enum binary_annotation_opcode): Define.
	(struct codeview_function): Add htab_next and inline_loc;
	(struct cv_func_hasher): Define.
	(cv_func_htab): New global variable.
	(new_codeview_function): Add new codeview_function to hash table.
	(codeview_begin_block): Record location of inline block.
	(codeview_end_block): Add dummy source line at end of inline block.
	(find_line_function): New function.
	(write_binary_annotations): New function.
	(write_s_inlinesite): Call write_binary_annotations.
	(codeview_debug_finish): Delete cv_func_htab.

2024-12-01  Andrew Pinski  <quic_apinski@quicinc.com>

	PR tree-optimization/117859
	* tree-ssa-sccvn.cc (insert_predicates_for_cond): If the
	valueization for the new lhs for `lhs != 0`
	is the same as the old ones, don't recurse.

2024-12-01  Andrew Pinski  <quic_apinski@quicinc.com>

	* tree-ssa-loop-im.cc (move_computations_worker): While moving
	phi, reuse the lhs of the conditional if it is a boolean type.

2024-12-01  Alexey Merzlyakov  <alexey.merzlyakov@samsung.com>

	PR rtl-optimization/112398
	PR rtl-optimization/117476
	* simplify-rtx.cc (simplify_context::simplify_unary_operation_1):
	Simplify ZERO_EXTEND (SUBREG (NOT X)) to XOR (X, GET_MODE_MASK(SUBREG))
	when X doesn't have any non-zero bits outside of SUBREG mode.

2024-11-30  Lewis Hyatt  <lhyatt@gmail.com>

	* diagnostic-show-locus.cc
	(test_one_liner_fixit_validation_adhoc_locations): Adapt so it can
	effectively test 7-bit ranges instead of 5-bit ranges.
	(test_one_liner_fixit_validation_adhoc_locations_utf8): Likewise.
	* input.cc (get_end_location): Adjust types to support 64-bit
	location_t.
	(write_digit_row): Likewise.
	(dump_location_range): Likewise.
	(dump_location_info): Likewise.
	(class line_table_case): Likewise.
	(test_accessing_ordinary_linemaps): Replace some hard-coded
	constants with the values defined in line-map.h.
	(for_each_line_table_case): Likewise.

2024-11-30  Lewis Hyatt  <lhyatt@gmail.com>

	* toplev.cc (general_init): Replace hard-coded constant with
	line_map_suggested_range_bits.

2024-11-30  Lewis Hyatt  <lhyatt@gmail.com>

	* config/aarch64/aarch64-c.cc (aarch64_resolve_overloaded_builtin):
	Change "unsigned int" argument to "location_t".
	* config/avr/avr-c.cc (avr_resolve_overloaded_builtin): Likewise.
	* config/riscv/riscv-c.cc (riscv_resolve_overloaded_builtin): Likewise.
	* target.def: Likewise.
	* doc/tm.texi: Regenerate.

2024-11-30  Joseph Myers  <josmyers@redhat.com>
	    Richard Biener  <rguenther@suse.de>

	PR c/100501
	PR c/100792
	* gimplify.cc (gimplify_asm_expr): Handle void expressions for
	memory inputs like other non-lvalues.

2024-11-30  Mark Harmstone  <mark@harmstone.com>

	* dwarf2codeview.cc (enum cv_sym_type): Add S_INLINESITE and
	S_INLINESITE_END.
	(get_func_id): Add declaration.
	(write_s_inlinesite): New function.
	(write_inlinesite_records): New function.
	(write_function): Call write_inlinesite_records.

2024-11-30  Mark Harmstone  <mark@harmstone.com>

	* dwarf2codeview.cc (DEBUG_S_INLINEELINES): Define.
	(CV_INLINEE_SOURCE_LINE_SIGNATURE): Define.
	(struct codeview_inlinee_lines): Define.
	(struct inlinee_lines_hasher): Define.
	(func_htab, inlinee_lines_htab): New global variables.
	(get_file_id): New function.
	(codeview_source_line): Move file_id logic to get_file_id.
	(write_inlinee_lines_entry): New function.
	(write_inlinee_lines): New function.
	(codeview_debug_finish): Call write_inlinee_lines, and free func_htab
	and inlinee_lines_htab.
	(get_func_id): New function.
	(add_function): Move func_id logic to get_func_id.
	(codeview_abstract_function): New function.
	* dwarf2codeview.h (codeview_abstract_function): Add declaration.
	* dwarf2out.cc (dwarf2out_abstract_function): Call
	codeview_abstract_function if outputting CodeView debug info.

2024-11-30  Mark Harmstone  <mark@harmstone.com>

	* dwarf2codeview.cc (struct codeview_function): Add parent and
	inline_block fields.
	(cur_func): New global variable.
	(new_codeview_function): New function.
	(codeview_source_line): Call new_codeview_function, and use cur_func
	instead of last_func.
	(codeview_begin_block): New function.
	(codeview_end_block): New function.
	(write_line_numbers): No longer free data as we go along.
	(codeview_switch_text_section): Call new_codeview_function, and use
	cur_func instead of last_func.
	(codeview_end_epilogue): Use cur_func instead of last_func.
	(codeview_debug_finish): Free funcs list and its contents.
	* dwarf2codeview.h (codeview_begin_block): Add declaration.
	(codeview_end_block): Add declaration.
	* dwarf2out.cc (dwarf2out_begin_block): Call codeview_begin_block if
	outputting CodeView debug info.
	(dwarf2out_end_block): Call codeview_end_block if outputting CodeView
	debug info.

2024-11-30  Mark Harmstone  <mark@harmstone.com>

	* debug.cc (do_nothing_debug_hooks): Change begin_block
	function pointer.
	(debug_nothing_int_int_tree): New function.
	* debug.h (struct gcc_debug_hooks): Add tree parameter to begin_block.
	(debug_nothing_int_int_tree): Add declaration.
	* dwarf2out.cc (dwarf2out_begin_block): Add tree parameter.
	(dwarf2_lineno_debug_hooks): Use new dummy function for begin_block.
	* final.cc (final_scan_insn_1): Pass insn block through to
	debug_hooks->begin_block.
	* vmsdbgout.cc (vmsdbgout_begin_block): Add tree parameter.

2024-11-30  Georg-Johann Lay  <avr@gjlay.de>

	PR target/84211
	* config/avr/avr-passes.cc (try_split_any) [SET, MOVW]: Prefer
	reg=reg move over reg=const when splitting a reg=reg insn.

2024-11-30  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/117057
	* tree-ssa-strlen.cc (strlen_pass::count_nonzero_bytes): Punt also
	when byte_size is equal to offset or nchars.  Punt if offset is bigger
	than INT_MAX.  Handle vector CONSTRUCTOR with some elements constant,
	possibly followed by non-constant.

2024-11-30  Jakub Jelinek  <jakub@redhat.com>

	PR libgomp/117851
	* lto-wrapper.cc (find_crtoffloadtable): Add PIE_OR_SHARED argument,
	search for crtoffloadtableS.o rather than crtoffloadtable.o if
	true.
	(run_gcc): Add pie_or_shared variable.  If OPT_pie or OPT_shared or
	OPT_static_pie is seen, set pie_or_shared to true, if OPT_no_pie is
	seen, set pie_or_shared to false.  Pass it to find_crtoffloadtable.

2024-11-30  Jinyang He  <hejinyang@loongson.cn>

	* config/loongarch/constraints.md (Uuv6, Uuvx): Remove Uuv6,
	add Uuvx as replicated vector const with unsigned range [0,umax].
	* config/loongarch/lasx.md (xvsrl, xvsra, xvsll): Mask shift
	offset by its unit bits.
	* config/loongarch/lsx.md (vsrl, vsra, vsll): Likewise.
	* config/loongarch/loongarch-protos.h
	(loongarch_const_vector_same_int_p): Set default for low and high.
	* config/loongarch/predicates.md: Replace reg_or_vector_same_uimm6
	_operand to reg_or_vector_same_uimm_operand.

2024-11-30  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/117360
	* ext-dce.cc (ext_dce_process_sets): Use HOST_WIDE_INT_UC
	macro instead of ULL suffixed constants.
	(carry_backpropagate): Likewise.  Use HOST_WIDE_INT_1U instead of
	1ULL.  Use GET_MODE_BITSIZE (smode) instead of
	GET_MODE_BITSIZE (mode) and with that avoid having to use
	known_lt instead of < or use .to_constant ().  Formatting fixes.
	(case SIGN_EXTEND): Set mode to GET_MODE_INNER (GET_MODE (XEXP (x, 0)))
	rather than GET_MODE (XEXP (x, 0)) and don't use GET_MODE_INNER (mode).
	(ext_dce_process_uses): Use HOST_WIDE_INT_UC macro instead of ULL
	suffixed constants.

2024-11-30  Jakub Jelinek  <jakub@redhat.com>

	* doc/invoke.texi (-Wdeprecated-variadic-comma-omission): Document.

2024-11-29  David Malcolm  <dmalcolm@redhat.com>

	* Makefile.in: Rename "libdiagnostics" to "libgdiagnostics".
	* configure.ac: Likewise.
	* configure: Regenerate.
	* doc/install.texi: Rename "libdiagnostics" to
	"libgdiagnostics".
	* doc/libdiagnostics/*: Rename to doc/libgdiagnostics, renaming
	"libdiagnostics" to "libgdiagnostics" throughout.
	* libdiagnostics++.h: Rename to...
	* libgdiagnostics++.h: ...this, renaming "libdiagnostics" to
	"libgdiagnostics" throughout.
	* libdiagnostics.cc: Rename to...
	* libgdiagnostics.cc: ...this, renaming "libdiagnostics" to
	"libgdiagnostics" throughout.
	* libdiagnostics.h: Rename to...
	* libgdiagnostics.h: ...this, renaming "libdiagnostics" to
	"libgdiagnostics" throughout.
	* libdiagnostics.map: Rename to...
	* libgdiagnostics.map: ...this, renaming "libdiagnostics" to
	"libgdiagnostics" throughout.
	* libsarifreplay.cc: Update for renaming of "libdiagnostics"
	to "libgdiagnostics".
	* libsarifreplay.h: Likewise.
	* sarif-replay.cc: Likewise.
	* doc/libgdiagnostics/Makefile: New file.
	* doc/libgdiagnostics/conf.py: New file.
	* doc/libgdiagnostics/index.rst: New file.
	* doc/libgdiagnostics/make.bat: New file.
	* doc/libgdiagnostics/topics/diagnostic-manager.rst: New file.
	* doc/libgdiagnostics/topics/diagnostics.rst: New file.
	* doc/libgdiagnostics/topics/execution-paths.rst: New file.
	* doc/libgdiagnostics/topics/fix-it-hints.rst: New file.
	* doc/libgdiagnostics/topics/index.rst: New file.
	* doc/libgdiagnostics/topics/logical-locations.rst: New file.
	* doc/libgdiagnostics/topics/message-formatting.rst: New file.
	* doc/libgdiagnostics/topics/metadata.rst: New file.
	* doc/libgdiagnostics/topics/physical-locations.rst: New file.
	* doc/libgdiagnostics/topics/retrofitting.rst: New file.
	* doc/libgdiagnostics/topics/sarif.rst: New file.
	* doc/libgdiagnostics/topics/text-output.rst: New file.
	* doc/libgdiagnostics/topics/ux.rst: New file.
	* doc/libgdiagnostics/tutorial/01-hello-world.rst: New file.
	* doc/libgdiagnostics/tutorial/02-physical-locations.rst: New file.
	* doc/libgdiagnostics/tutorial/03-logical-locations.rst: New file.
	* doc/libgdiagnostics/tutorial/04-notes.rst: New file.
	* doc/libgdiagnostics/tutorial/05-warnings.rst: New file.
	* doc/libgdiagnostics/tutorial/06-fix-it-hints.rst: New file.
	* doc/libgdiagnostics/tutorial/07-execution-paths.rst: New file.
	* doc/libgdiagnostics/tutorial/example-1.png: New file.
	* doc/libgdiagnostics/tutorial/index.rst: New file.

2024-11-29  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr-c.cc: Fix some coding rule nits and typos.
	* config/avr/avr-passes.cc: Same
	* config/avr/avr.h: Same.
	* config/avr/avr.cc: Same.
	(avr_function_arg_regno_p, avr_hard_regno_rename_ok)
	(avr_epilogue_uses, extra_constraint_Q): Return bool instead of int.
	* config/avr/avr-protos.h (avr_function_arg_regno_p)
	(avr_hard_regno_rename_ok, avr_epilogue_uses)
	(extra_constraint_Q): Return bool instead of int.

2024-11-29  Andrew Pinski  <quic_apinski@quicinc.com>

	* config/aarch64/aarch64-builtins.cc (aarch64_init_data_intrinsics): Call
	aarch64_get_attributes and update calls to aarch64_general_add_builtin.

2024-11-29  Andrew Pinski  <quic_apinski@quicinc.com>

	* config/aarch64/aarch64-builtins.cc (aarch64_init_prefetch_builtin):
	Updete call to aarch64_general_add_builtin in AARCH64_INIT_PREFETCH_BUILTIN.
	Add new variable prefetch_attrs.

2024-11-29  Andrew Pinski  <quic_apinski@quicinc.com>

	* config/aarch64/aarch64-builtins.cc (VREINTERPRET_BUILTIN): Use
	FLAG_NONE instead of FLAG_AUTO_FP.
	(VGET_LOW_BUILTIN): Likewise.
	(VGET_HIGH_BUILTIN): Likewise.

2024-11-29  Andrew Pinski  <quic_apinski@quicinc.com>

	PR target/117665
	* config/aarch64/aarch64-builtins.cc (aarch64_init_simd_builtin_functions):
	Pass nothrow and leaf as attributes to aarch64_general_add_builtin for
	__builtin_aarch64_im_lane_boundsi.

2024-11-29  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/117770
	* lra-lives.cc: Include ira-int.h.
	(process_bb_lives): Check hard regs corresponding insn operands
	for dying hard wired reg clobbers.

2024-11-29  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117681
	* config/avr/avr.cc (TARGET_UNWIND_WORD_MODE): Define to...
	(avr_unwind_word_mode): ...this new static function.

2024-11-29  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117726
	* config/avr/avr-passes.cc (avr_shift_is_3op, avr_emit_shift):
	Also handle 2-byte and 3-byte shifts.
	(avr_split_shift4, avr_split_shift3, avr_split_shift2): New
	local helper functions.
	(avr_split_shift): Use them.
	* config/avr/avr-passes.def (avr_pass_split_after_peephole2):
	Adjust comments.
	* config/avr/avr.cc (avr_out_ashlpsi3, avr_out_ashrpsi3)
	(avr_out_lshrpsi3): Support offset 15.
	(ashrhi3_out): Support offset 7 as 3-op.
	(ashrsi3_out): Support offset 15.
	(avr_rtx_costs_1): Adjust shift costs.
	* config/avr/avr.md (2op): Remove attribute value and all such insn
	alternatives.
	(ashlhi3, *ashlhi3, *ashlhi3_const): Add 3-op alternatives like C2l.
	(ashrhi3, *ashrhi3, *ashrhi3_const): Add 3-op alternatives like C2a.
	(lshrhi3, *lshrhi3, *lshrhi3_const): Add 3-op alternatives like C2r.
	(*ashlpsi3_split, *ashlpsi3): Add 3-op alternatives C15 and C3l.
	(*ashrpsi3_split, *ashrpsi3): Add 3-op alternatives C15 and C3r.
	(*lshrpsi3_split, *lshrpsi3): Add 3-op alternatives C15 and C3r.
	(ashlsi3, *ashlsi3, *ashlsi3_const): Remove "2op" alternative.
	(ashrsi3, *ashrsi3, *ashrsi3_const): Same.
	(lshrsi3, *lshrsi3, *lshrsi3_const): Same.
	(constr_split_suffix): Code attr morphed from constr_split_shift4.
	* config/avr/constraints.md (C2a, C2r, C2l)
	(C3a, C3r, C3l): New constraints.
	* doc/invoke.texi (AVR Options) <-msplit-bit-shift>: Adjust doc.

2024-11-29  Andre Vieira  <andre.simoesdiasvieira@arm.com>

	PR target/117814
	* config/arm/arm.cc (arm_attempt_dlstp_transform): Use
	reg_overlap_mentioned_p instead of rtx_equal_p to detect uses of
	vctp_vpr_generated inside subregs.

2024-11-29  Mariam Arutunian  <mariamarutunian@gmail.com>

	* expr.cc (gf2n_poly_long_div_quotient): New function.
	* expr.h (gf2n_poly_long_div_quotient):  New function declaration.
	* hwint.cc (reflect_hwi): New function.
	* hwint.h (reflect_hwi): New function declaration.
	* config/riscv/bitmanip.md (crc_rev<ANYI1:mode><ANYI:mode>4): New
	expander for reversed CRC.
	(crc<SUBX1:mode><SUBX:mode>4): New expander for bit-forward CRC.
	* config/riscv/iterators.md (SUBX1, ANYI1): New iterators.
	* config/riscv/riscv-protos.h (generate_reflecting_code_using_brev):
	New function declaration.
	(expand_crc_using_clmul): Likewise.
	(expand_reversed_crc_using_clmul): Likewise.
	* config/riscv/riscv.cc (generate_reflecting_code_using_brev): New
	function.
	(expand_crc_using_clmul): Likewise.
	(expand_reversed_crc_using_clmul): Likewise.
	* config/riscv/riscv.md (UNSPEC_CRC, UNSPEC_CRC_REV):  New unspecs.
	* doc/sourcebuild.texi: Document new target selectors.

2024-11-29  yulong  <shiyulong@iscas.ac.cn>

	* config.gcc: Add new SiFive *.o files.
	* config/riscv/generic-vector-ooo.md: New reservation.
	* config/riscv/genrvv-type-indexer.cc (main): New type.
	* config/riscv/riscv-vector-builtins-shapes.cc (struct sf_vqmacc_def): New function.
	(SHAPE): Ditto.
	* config/riscv/riscv-vector-builtins-shapes.h: Ditto.
	* config/riscv/riscv-vector-builtins-types.def (DEF_RVV_QMACC_OPS): New macros type.
	(vint32m1_t): Ditto.
	(vint32m2_t): Ditto.
	(vint32m4_t): Ditto.
	(vint32m8_t): Ditto.
	* config/riscv/riscv-vector-builtins.cc (DEF_RVV_QMACC_OPS): New builtins def.
	(DEF_RVV_TYPE_INDEX): Ditto.
	(DEF_RVV_FUNCTION): Ditto.
	* config/riscv/riscv-vector-builtins.def (DEF_RVV_TYPE_INDEX): New types def.
	(4x8x4): New op type.
	(2x8x2): Ditto.
	(quad_emul_vector): New base type.
	(quad_emul_signed_vector): Ditto.
	(quad_emul_unsigned_vector): Ditto.
	(quad_fixed_vector): Ditto.
	(quad_fixed_signed_vector): Ditto.
	(quad_fixed_unsigned_vector): Ditto.
	(quad_lmul1_vector): Ditto.
	(quad_lmul1_signed_vector): Ditto.
	(quad_lmul1_unsigned_vector): Ditto.
	* config/riscv/riscv-vector-builtins.h (enum required_ext): New extensions.
	(required_ext_to_isa_name): Ditto.
	(required_extensions_specified): Ditto.
	(struct function_group_info): Ditto.
	* config/riscv/riscv.md: New attr.
	* config/riscv/t-riscv: Add include for SiFive files.
	* config/riscv/vector-iterators.md: New iterator.
	* config/riscv/vector.md: New include for SiFive file.
	* config/riscv/sifive-vector-builtins-bases.cc: New file.
	* config/riscv/sifive-vector-builtins-bases.h: New file.
	* config/riscv/sifive-vector-builtins-functions.def: New file.
	* config/riscv/sifive-vector.md: New file.

2024-11-29  Tamar Christina  <tamar.christina@arm.com>

	* config/aarch64/aarch64-errata.h (TARGET_SUPPRESS_OPT_SPEC,
	TARGET_TURN_OFF_OPT_SPEC, CA53_ERR_835769_COMPILE_SPEC,
	CA53_ERR_843419_COMPILE_SPEC): New.
	(CA53_ERR_835769_SPEC, CA53_ERR_843419_SPEC): Use them.
	* config/aarch64/aarch64-elf-raw.h (CC1_SPEC, CC1PLUS_SPEC): Add
	AARCH64_ERRATA_COMPILE_SPEC.
	* config/aarch64/aarch64-freebsd.h (CC1_SPEC, CC1PLUS_SPEC): Likewise.
	* config/aarch64/aarch64-gnu.h (CC1_SPEC, CC1PLUS_SPEC): Likewise.
	* config/aarch64/aarch64-linux.h (CC1_SPEC, CC1PLUS_SPEC): Likewise.
	* config/aarch64/aarch64-netbsd.h (CC1_SPEC, CC1PLUS_SPEC): Likewise.
	* common/config/aarch64/aarch64-common.cc
	(is_host_cpu_not_armv8_base): New.
	* config/aarch64/driver-aarch64.cc: Remove extra newline
	* config/aarch64/aarch64.h (is_host_cpu_not_armv8_base): New.
	(MCPU_TO_MARCH_SPEC_FUNCTIONS): Add is_local_not_armv8_base.
	(EXTRA_SPEC_FUNCTIONS): Add is_local_cpu_armv8_base.
	* doc/invoke.texi: Document it.

2024-11-29  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-sme.md: In the section comments, add the
	architecture requirements alongside some mnemonics.
	* config/aarch64/aarch64-sve2.md: Likewise.

2024-11-29  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-option-extensions.def
	(fp8dot4, ssve-fp8dot4): Add new extensions.
	(fp8dot2, ssve-fp8dot2): Likewise.
	* config/aarch64/aarch64-sve-builtins-base.cc (svdot_impl): Support fp8.
	(svdotprod_lane_impl): Likewise.
	(svdot_lane): Provide an unspec for fp8 types.
	* config/aarch64/aarch64-sve-builtins-shapes.cc
	(ternary_mfloat8_def): Add new class.
	(ternary_mfloat8): Add new shape.
	(ternary_mfloat8_lane_group_selection_def): Add new class.
	(ternary_mfloat8_lane_group_selection): Add new shape.
	* config/aarch64/aarch64-sve-builtins-shapes.h
	(ternary_mfloat8, ternary_mfloat8_lane_group_selection): Declare.
	* config/aarch64/aarch64-sve-builtins-sve2.def
	(svdot, svdot_lane): Add new DEF_SVE_FUNCTION_GS_FPM, twice to deal
	with the combination of features providing support for 32 and 16 bit
	floating point.
	* config/aarch64/aarch64-sve2.md (@aarch64_sve_dot<mode>): Add new.
	(@aarch64_sve_dot_lane<mode>): Likewise.
	* config/aarch64/aarch64.h:
	(TARGET_FP8DOT4, TARGET_SSVE_FP8DOT4): Add new defines.
	(TARGET_FP8DOT2, TARGET_SSVE_FP8DOT2): Likewise.
	* config/aarch64/iterators.md
	(UNSPEC_DOT_FP8, UNSPEC_DOT_LANE_FP8): Add new unspecs.
	* doc/invoke.texi: Document fp8dot4, fp8dot2, ssve-fp8dot4, ssve-fp8dot2
	extensions.

2024-11-29  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-option-extensions.def
	(fp8fma, ssve-fp8fma): Add new options.
	* config/aarch64/aarch64-sve-builtins-functions.h
	(unspec_based_function_base): Add unspec_for_mfp8.
	(unspec_for): Return unspec_for_mfp8 on fpm-using cases.
	(sme_1mode_function): Fix call to parent ctor.
	(sme_2mode_function_t): Likewise.
	(unspec_based_mla_function, unspec_based_mla_lane_function): Handle
	fpm-using cases.
	* config/aarch64/aarch64-sve-builtins-shapes.cc
	(parse_element_type): Treat M as TYPE_SUFFIX_mf8
	(ternary_mfloat8_lane_def): Add new class.
	(ternary_mfloat8_opt_n_def): Likewise.
	(ternary_mfloat8_lane): Add new shape.
	(ternary_mfloat8_opt_n): Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.h
	(ternary_mfloat8_lane, ternary_mfloat8_opt_n): Declare.
	* config/aarch64/aarch64-sve-builtins-sve2.cc
	(svmlalb_lane, svmlalb, svmlalt_lane, svmlalt): Update definitions
	with mfloat8_t unspec in ctor.
	(svmlallbb_lane, svmlallbb, svmlallbt_lane, svmlallbt, svmlalltb_lane,
	svmlalltb, svmlalltt_lane, svmlalltt, svmlal_impl): Add new FUNCTIONs.
	(svqrshr, svqrshrn, svqrshru, svqrshrun): Update definitions with
	nop mfloat8 unspec in ctor.
	* config/aarch64/aarch64-sve-builtins-sve2.def
	(svmlalb, svmlalt, svmlalb_lane, svmlalt_lane, svmlallbb, svmlallbt,
	svmlalltb, svmlalltt, svmlalltt_lane, svmlallbb_lane, svmlallbt_lane,
	svmlalltb_lane): Add new DEF_SVE_FUNCTION_GS_FPMs.
	* config/aarch64/aarch64-sve-builtins-sve2.h
	(svmlallbb_lane, svmlallbb, svmlallbt_lane, svmlallbt, svmlalltb_lane,
	svmlalltb, svmlalltt_lane, svmlalltt): Declare.
	* config/aarch64/aarch64-sve-builtins.cc
	(TYPES_h_float_mf8, TYPES_s_float_mf8): Add new types.
	(h_float_mf8, s_float_mf8): Add new SVE_TYPES_ARRAY.
	* config/aarch64/aarch64-sve2.md
	(@aarch64_sve_add_<sve2_fp8_fma_op_vnx8hf><mode>): Add new.
	(@aarch64_sve_add_<sve2_fp8_fma_op_vnx4sf><mode>): Add new.
	(@aarch64_sve_add_lane_<sve2_fp8_fma_op_vnx8hf><mode>): Likewise.
	(@aarch64_sve_add_lane_<sve2_fp8_fma_op_vnx4sf><mode>): Likewise.
	* config/aarch64/aarch64.h
	(TARGET_FP8FMA, TARGET_SSVE_FP8FMA): Likewise.
	* config/aarch64/iterators.md
	(VNx8HF_ONLY): Add new.
	(UNSPEC_FMLALB_FP8, UNSPEC_FMLALLBB_FP8, UNSPEC_FMLALLBT_FP8,
	UNSPEC_FMLALLTB_FP8, UNSPEC_FMLALLTT_FP8, UNSPEC_FMLALT_FP8): Likewise.
	(SVE2_FP8_TERNARY_VNX8HF, SVE2_FP8_TERNARY_VNX4SF): Likewise.
	(SVE2_FP8_TERNARY_LANE_VNX8HF, SVE2_FP8_TERNARY_LANE_VNX4SF): Likewise.
	(sve2_fp8_fma_op_vnx8hf, sve2_fp8_fma_op_vnx4sf): Likewise.
	* doc/invoke.texi: Document fp8fma and sve-fp8fma extensions.

2024-11-29  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-sve-builtins-shapes.cc
	(parse_signature): Add an fpm_t (uint64_t) argument to functions that
	set the fpm register.
	(unary_convertxn_narrowt_def): New class.
	(unary_convertxn_narrowt): New shape.
	(unary_convertxn_narrow_def): New class.
	(unary_convertxn_narrow): New shape.
	* config/aarch64/aarch64-sve-builtins-shapes.h
	(unary_convertxn_narrowt): Declare.
	(unary_convertxn_narrow): Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.cc
	(svcvt_fp8_impl): New class.
	(svcvtn_impl): Handle fp8 cases.
	(svcvt1, svcvt2, svcvtlt1, svcvtlt2): Add new FUNCTION.
	(svcvtnb): Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.def
	(svcvt1, svcvt2, svcvtlt1, svcvtlt2): Add new DEF_SVE_FUNCTION_GS_FPM.
	(svcvtn): Likewise.
	(svcvtnb, svcvtnt): Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.h
	(svcvt1, svcvt2, svcvtlt1, svcvtlt2, svcvtnb, svcvtnt): Declare.
	* config/aarch64/aarch64-sve-builtins.cc
	(TYPES_cvt_mf8, TYPES_cvtn_mf8, TYPES_cvtnx_mf8): Add new types arrays.
	(function_builder::get_name): Append _fpm to functions that set fpmr.
	(function_resolver::check_gp_argument): Deal with the fpm_t argument.
	(function_expander::expand): Set the fpm register before
	calling the insn if the function warrants it.
	* config/aarch64/aarch64-sve2.md (@aarch64_sve2_fp8_cvt): Add new.
	(@aarch64_sve2_fp8_cvtn): Likewise.
	(@aarch64_sve2_fp8_cvtnb): Likewise.
	(@aarch64_sve_cvtnt): Likewise.
	* config/aarch64/aarch64.h (TARGET_SSVE_FP8): Add new.
	* config/aarch64/iterators.md
	(VNx8SF_ONLY, SVE_FULL_HFx2): New mode iterators.
	(UNSPEC_F1CVT, UNSPEC_F1CVTLT, UNSPEC_F2CVT, UNSPEC_F2CVTLT): Add new.
	(UNSPEC_FCVTNB, UNSPEC_FCVTNT): Likewise.
	(UNSPEC_FP8FCVTN): Likewise.
	(FP8CVT_UNS, fp8_cvt_uns_op): Likewise.

2024-11-29  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-sve-builtins-base.cc
	(svdiv_impl): Specify FPM_unused when folding.
	(svmul_impl): Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.cc
	(build_one): Use the group fpm_mode when creating function instances.
	* config/aarch64/aarch64-sve-builtins-sve2.cc
	(svaba_impl, svqrshl_impl, svqshl_impl,svrshl_impl, svsra_impl):
	Specify FPM_unused when folding.
	* config/aarch64/aarch64-sve-builtins.cc (function_groups): Set
	fpm_mode on all elements.
	(neon_sve_function_groups, sme_function_groups): Likewise.
	(function_instance::hash): Include fpm_mode in hash.
	(function_builder::add_overloaded_functions): Use the group fpm mode.
	(function_resolver::lookup_form): Use the function instance fpm_mode
	when looking up a function.
	* config/aarch64/aarch64-sve-builtins.def
	(DEF_SVE_FUNCTION_GS_FPM): add define.
	(DEF_SVE_FUNCTION_GS): redefine against DEF_SVE_FUNCTION_GS_FPM.
	* config/aarch64/aarch64-sve-builtins.h (fpm_mode_index): New.
	(function_group_info): Add fpm_mode.
	(function_instance): Likewise.
	(function_instance::operator==): Handle fpm_mode.

2024-11-29  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-sve-builtins.cc (TYPES_b_data): Add mf8.
	(TYPES_reinterpret1, TYPES_reinterpret): Likewise.
	* config/aarch64/aarch64-sve-builtins.def (svmfloat8_t): New type.
	(mf8): New type suffix.
	* config/aarch64/aarch64-sve-builtins.h (TYPE_mfloat): New
	type_class_index.

2024-11-29  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/115438
	* tree-vect-loop.cc (vect_transform_cycle_phi): For SLP also
	try to do the reduction adjustment by the initial value
	in the epilogue.

2024-11-29  Tejas Belagod  <tejas.belagod@arm.com>

	* tree.cc (build_vector_from_ctor): Add support to construct VLA vector
	constants from init constructors.

2024-11-29  Tejas Belagod  <tejas.belagod@arm.com>

	* gimple-fold.cc (maybe_canonicalize_mem_ref_addr): Handle variable
	sized vector types in BIT_FIELD_REF canonicalization.
	* tree-cfg.cc (verify_types_in_gimple_reference): Change object-size-
	checking for BIT_FIELD_REF to error offsets that are known_gt to be
	outside object-size.  Out-of-range offsets can happen in the case of
	indices that reference VLA SVE vector elements that may be outside the
	minimum vector size range and therefore maybe_gt is not appropirate
	here.

2024-11-29  Tejas Belagod  <tejas.belagod@arm.com>

	* config/aarch64/aarch64-sve-builtins.cc (register_builtin_types): Flip
	TYPE_INDIVISBLE flag for SVE ACLE vector types.

2024-11-29  Tejas Belagod  <tejas.belagod@arm.com>

	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins): Define
	__ARM_FEATURE_SVE_VECTOR_OPERATORS.

2024-11-29  Yury Khrustalev  <yury.khrustalev@arm.com>

	* config/aarch64/arm_acle.h (_CHKFEAT_GCS): New.

2024-11-29  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/117065
	* gimple-fold.cc (type_has_padding_at_level_p) <case UNION_TYPE>:
	Also continue if f has error_mark_node type.

2024-11-29  Jakub Jelinek  <jakub@redhat.com>

	PR target/117608
	* doc/extend.texi (__builtin_prefetch): Document that second
	argument may be also 2 and its meaning.
	* config/i386/i386.md (prefetch): Remove unreachable code.
	Clear write set operands[1] to const0_rtx if !TARGET_MOVRS or
	of locality is not 1.  Formatting fixes.
	* config/i386/i386-expand.cc (ix86_expand_builtin): Use IN_RANGE.
	Call gen_prefetch even for TARGET_MOVRS.
	* config/alpha/alpha.md (prefetch): Treat read_or_write 2 like 0.
	* config/mips/mips.md (prefetch): Likewise.
	* config/arc/arc.md (prefetch_1, prefetch_2, prefetch_3): Likewise.
	* config/riscv/riscv.md (prefetch): Likewise.
	* config/loongarch/loongarch.md (prefetch): Likewise.
	* config/sparc/sparc.md (prefetch): Likewise.  Use IN_RANGE.
	* config/ia64/ia64.md (prefetch): Likewise.
	* config/pa/pa.md (prefetch): Likewise.
	* config/aarch64/aarch64.md (prefetch): Likewise.
	* config/rs6000/rs6000.md (prefetch): Likewise.

2024-11-29  Alexandre Oliva  <oliva@adacore.com>

	PR tree-optimization/117723
	* tree-ssa-ifcombine.cc (tree_ssa_ifcombine_bb): Record
	forwarder blocks in path to exit, and stick to them.  Avoid
	computing the exit if obviously not needed, and if that
	enables additional optimizations.
	(tree_ssa_ifcombine_bb_1): Fix typos.

2024-11-28  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.md (*<any_shift:insn><mode>3_mask): Macroize
	pattern from *ashl<mode>3_mask and *<any_shiftrt:insn><mode>3_mask
	using any_shift code iterator.
	(*<any_shift:insn><mode>3_mask_1): Macroize pattern
	from *ashl<mode>3_mask_1 and *<any_shiftrt:insn><mode>3_mask_1
	using any_shift code iterator.
	(*<any_shift:insn><mode>3_add): Macroize pattern
	from *ashl<mode>3_add and *<any_shiftrt:insn><mode>3_add
	using any_shift code iterator.
	(*<any_shift:insn><mode>3_add_1): Macroize pattern
	from *ashl<mode>3_add_1 and *<any_shiftrt:insn><mode>3_add_1
	using any_shift code iterator.
	(*<insn><mode>3_sub): Macroize pattern
	from *ashl<mode>3_sub and *<any_shiftrt:insn><mode>3_sub
	using any_shift code iterator.
	(*<any_shift:insn><mode>3_sub_1): Macroize pattern
	from *ashl<mode>3_sub_1 and *<any_shiftrt:insn><mode>3_sub_1
	using any_shift code iterator.

2024-11-28  Mariam Arutunian  <mariamarutunian@gmail.com>

	* builtin-types.def (BT_FN_UINT8_UINT8_UINT8_CONST_SIZE): Define.
	(BT_FN_UINT16_UINT16_UINT8_CONST_SIZE): Likewise.
	(BT_FN_UINT16_UINT16_UINT16_CONST_SIZE): Likewise.
	(BT_FN_UINT32_UINT32_UINT8_CONST_SIZE): Likewise.
	(BT_FN_UINT32_UINT32_UINT16_CONST_SIZE): Likewise.
	(BT_FN_UINT32_UINT32_UINT32_CONST_SIZE): Likewise.
	(BT_FN_UINT64_UINT64_UINT8_CONST_SIZE): Likewise.
	(BT_FN_UINT64_UINT64_UINT16_CONST_SIZE): Likewise.
	(BT_FN_UINT64_UINT64_UINT32_CONST_SIZE): Likewise.
	(BT_FN_UINT64_UINT64_UINT64_CONST_SIZE): Likewise.
	* builtins.cc (associated_internal_fn): Handle CRC related builtins.
	(expand_builtin_crc_table_based): New function.
	(expand_builtin): Handle CRC related builtins.
	* builtins.def (BUILT_IN_CRC8_DATA8): New builtin.
	(BUILT_IN_CRC16_DATA8): Likewise.
	(BUILT_IN_CRC16_DATA16): Likewise.
	(BUILT_IN_CRC32_DATA8): Likewise.
	(BUILT_IN_CRC32_DATA16): Likewise.
	(BUILT_IN_CRC32_DATA32): Likewise.
	(BUILT_IN_CRC64_DATA8): Likewise.
	(BUILT_IN_CRC64_DATA16): Likewise.
	(BUILT_IN_CRC64_DATA32): Likewise.
	(BUILT_IN_CRC64_DATA64): Likewise.
	(BUILT_IN_REV_CRC8_DATA8): New builtin.
	(BUILT_IN_REV_CRC16_DATA8): Likewise.
	(BUILT_IN_REV_CRC16_DATA16): Likewise.
	(BUILT_IN_REV_CRC32_DATA8): Likewise.
	(BUILT_IN_REV_CRC32_DATA16): Likewise.
	(BUILT_IN_REV_CRC32_DATA32): Likewise.
	(BUILT_IN_REV_CRC64_DATA8): Likewise.
	(BUILT_IN_REV_CRC64_DATA16): Likewise.
	(BUILT_IN_REV_CRC64_DATA32): Likewise.
	(BUILT_IN_REV_CRC64_DATA64): Likewise.
	* builtins.h (expand_builtin_crc_table_based): New function
	declaration.
	* doc/extend.texi: Add documentation for new CRC builtins.

2024-11-28  Mariam Arutunian  <mariamarutunian@gmail.com>

	* doc/md.texi (crc@var{m}@var{n}4, crc_rev@var{m}@var{n}4): Document.
	* expr.cc (calculate_crc): New function.
	(assemble_crc_table): Likewise.
	(generate_crc_table): Likewise.
	(calculate_table_based_CRC): Likewise.
	(expand_crc_table_based): Likewise.
	(gen_common_operation_to_reflect): Likewise.
	(reflect_64_bit_value): Likewise.
	(reflect_32_bit_value): Likewise.
	(reflect_16_bit_value): Likewise.
	(reflect_8_bit_value): Likewise.
	(generate_reflecting_code_standard): Likewise.
	(expand_reversed_crc_table_based): Likewise.
	* expr.h (generate_reflecting_code_standard): New function declaration.
	(expand_crc_table_based): Likewise.
	(expand_reversed_crc_table_based): Likewise.
	* internal-fn.cc: (crc_direct): Define.
	(direct_crc_optab_supported_p): Likewise.
	(expand_crc_optab_fn): New function
	* internal-fn.def (CRC, CRC_REV): New internal functions.
	* optabs.def (crc_optab, crc_rev_optab): New optabs.
	Signed-off-by: Mariam Arutunian <mariamarutunian@gmail.com>
	Co-authored-by: Joern Rennecke <joern.rennecke@embecosm.com>
	Co-authored-by: Jeff Law <jlaw@ventanamicro.com>

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR target/117642
	* doc/extend.texi: Remove documentation of warning for unimplemented
	__sync_* operations, such warning has never been implemented.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR c/117023
	* gimple-range-infer.cc (gimple_infer_range::gimple_infer_range):
	Handle also nonnull_if_nonzero attributes.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR c/117023
	* gimple.h (infer_nonnull_range_by_attribute): Add a tree *
	argument defaulted to NULL.
	* gimple.cc (infer_nonnull_range_by_attribute): Add op2 argument.
	Handle also nonnull_if_nonzero attributes.
	* tree.cc (get_nonnull_args): Fix comment typo.
	* builtins.cc (validate_arglist): Handle nonnull_if_nonzero attribute.
	* tree-ssa-ccp.cc (pass_post_ipa_warn::execute): Handle
	nonnull_if_nonzero attributes.
	* ubsan.cc (instrument_nonnull_arg): Adjust
	infer_nonnull_range_by_attribute caller.  If it returned true and
	filed in non-NULL arg2, check that arg2 is non-zero as another
	condition next to checking that arg is zero.
	* doc/extend.texi (nonnull_if_nonzero): Document new attribute.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.h (struct machine_function): Add
	asm_redzone_clobber_seen member.
	* config/rs6000/rs6000-logue.cc (rs6000_stack_info): Force
	info->push_p if cfun->machine->asm_redzone_clobber_seen.
	* config/rs6000/rs6000.cc (TARGET_REDZONE_CLOBBER): Redefine.
	(rs6000_redzone_clobber): New function.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	* target.def (redzone_clobber): New target hook.
	* varasm.cc (decode_reg_name_and_count): Return -5 for
	"redzone".
	* cfgexpand.cc (expand_asm_stmt): Handle redzone clobber.
	* config/i386/i386.h (struct machine_function): Add
	asm_redzone_clobber_seen member.
	* config/i386/i386.cc (ix86_compute_frame_layout): Don't
	use red zone if cfun->machine->asm_redzone_clobber_seen.
	(ix86_redzone_clobber): New function.
	(TARGET_REDZONE_CLOBBER): Redefine.
	* doc/extend.texi (Clobbers and Scratch Registers): Document
	the "redzone" clobber.
	* doc/tm.texi.in: Add @hook TARGET_REDZONE_CLOBBER.
	* doc/tm.texi: Regenerate.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR c++/116416
	* flag-types.h (enum zero_init_padding_bits_kind): New type.
	* tree.h (CONSTRUCTOR_ZERO_PADDING_BITS): Define.
	* common.opt (fzero-init-padding-bits=): New option.
	* expr.cc (categorize_ctor_elements_1): Handle
	CONSTRUCTOR_ZERO_PADDING_BITS or
	flag_zero_init_padding_bits == ZERO_INIT_PADDING_BITS_ALL.  Fix
	up *p_complete = -1; setting for unions.
	(complete_ctor_at_level_p): Handle unions differently for
	flag_zero_init_padding_bits == ZERO_INIT_PADDING_BITS_STANDARD.
	* gimple-fold.cc (type_has_padding_at_level_p): Fix up UNION_TYPE
	handling, return also true for UNION_TYPE with no FIELD_DECLs
	and non-zero size, handle QUAL_UNION_TYPE like UNION_TYPE.
	* doc/invoke.texi (-fzero-init-padding-bits=@var{value}): Document.

2024-11-28  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/117557
	* tree-vect-stmts.cc (vectorizable_store): Flatten the ncopies and
	vec_num loops.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/117358
	* gimple-fold.cc (gimple_fold_builtin_memory_op): Punt if stmt has no
	vdef in ssa form.
	(gimple_fold_builtin_bcmp): Punt if stmt has no vuse in ssa form.
	(gimple_fold_builtin_bcopy): Punt if stmt has no vdef in ssa form.
	(gimple_fold_builtin_bzero): Likewise.
	(gimple_fold_builtin_memset): Likewise.  Use return false instead of
	return NULL_TREE.
	(gimple_fold_builtin_strcpy): Punt if stmt has no vdef in ssa form.
	(gimple_fold_builtin_strncpy): Likewise.
	(gimple_fold_builtin_strchr): Punt if stmt has no vuse in ssa form.
	(gimple_fold_builtin_strstr): Likewise.
	(gimple_fold_builtin_strcat): Punt if stmt has no vdef in ssa form.
	(gimple_fold_builtin_strcat_chk): Likewise.
	(gimple_fold_builtin_strncat): Likewise.
	(gimple_fold_builtin_strncat_chk): Likewise.
	(gimple_fold_builtin_string_compare): Likewise.
	(gimple_fold_builtin_fputs): Likewise.
	(gimple_fold_builtin_memory_chk): Likewise.
	(gimple_fold_builtin_stxcpy_chk): Likewise.
	(gimple_fold_builtin_stxncpy_chk): Likewise.
	(gimple_fold_builtin_stpcpy): Likewise.
	(gimple_fold_builtin_snprintf_chk): Likewise.
	(gimple_fold_builtin_sprintf_chk): Likewise.
	(gimple_fold_builtin_sprintf): Likewise.
	(gimple_fold_builtin_snprintf): Likewise.
	(gimple_fold_builtin_fprintf): Likewise.
	(gimple_fold_builtin_printf): Likewise.
	(gimple_fold_builtin_realloc): Likewise.

2024-11-28  Jakub Jelinek  <jakub@redhat.com>

	PR c/117802
	* builtins.cc (fold_builtin_iseqsig): Handle BITINT_TYPE like
	INTEGER_TYPE.

2024-11-28  David Malcolm  <dmalcolm@redhat.com>

	* timevar.cc: Include "make-unique.h".
	(timer::named_items::make_json): Convert return type to unique_ptr.
	Avoid naked "new".
	(make_json_for_timevar_time_def): Likewise.
	(timer::timevar_def::make_json): Likewise.
	(timer::make_json): Likewise.
	* timevar.h (timer::make_json): Likewise.
	(timer::timevar_def::make_json): Likewise.
	* tree-diagnostic-client-data-hooks.cc: Update for above changes.

2024-11-28  David Malcolm  <dmalcolm@redhat.com>

	PR c/104896
	* common/config/ia64/ia64-common.cc (ia64_handle_option): Replace
	"%<%s%>" with "%qs" in message wording.
	* common/config/rs6000/rs6000-common.cc (rs6000_handle_option):
	Likewise.
	* config/aarch64/aarch64.cc (aarch64_validate_sls_mitigation):
	Likewise.
	(aarch64_override_options): Likewise.
	(aarch64_process_target_attr): Likewise.
	* config/arm/aarch-common.cc (aarch_validate_mbranch_protection):
	Likewise.
	* config/pru/pru.cc (pru_insert_attributes): Likewise.
	* config/riscv/riscv-target-attr.cc
	(riscv_target_attr_parser::parse_arch): Likewise.
	* omp-general.cc (oacc_verify_routine_clauses): Likewise.
	* tree-ssa-uninit.cc (maybe_warn_read_write_only): Likewise.
	(maybe_warn_pass_by_reference): Likewise.

2024-11-27  Uros Bizjak  <ubizjak@gmail.com>

	PR target/36503
	* config/i386/i386.md (*ashl<mode>3_add):
	New define_insn_and_split pattern.
	(*ashl<mode>3_add_1): Ditto.
	(*<insn><mode>3_add): Ditto.
	(*<insn><mode>3_add_1): Ditto.
	(*ashl<mode>3_sub): Rename from *ashl<mode>3_negcnt.
	(*ashl<mode>3_sub_1): Rename from *ashl<mode>3_negcnt_1.
	(*<insn><mode>3_sub): Rename from *<insn><mode>3_negcnt.
	(*<insn><mode>3_sub_1): Rename from *<insn><mode>3_negcnt_1.

2024-11-27  Andrew Pinski  <quic_apinski@quicinc.com>

	PR tree-optimization/117776
	* match.pd (nested int casts): Allow for the case
	where the final prec is greater than the original
	prec.

2024-11-27  Pan Li  <pan2.li@intel.com>

	* match.pd: Refactor sorts of unsigned SAT_ADD match pattern for
	IFN ADD_OVERFLOW.

2024-11-27  Jakub Jelinek  <jakub@redhat.com>

	PR target/117642
	* builtins.cc (expand_builtin_sync_lock_release): Change return type
	from void to rtx, return result of expand_atomic_store.
	(expand_builtin) <case BUILT_IN_SYNC_LOCK_RELEASE_16>: If
	expand_builtin_sync_lock_release returns NULL, do a break rather
	than return const0_rtx.

2024-11-27  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/117692
	* tree.cc (get_range_pos_neg): Adjust function comment, use
	non-negative instead of positive.
	* match.pd
	(((X /[ex] C1) +- C2) * (C1 * C3) -> (X * C3) +- (C1 * C2 * C3)):
	Use casts to utype if type is signed, factor isn't 1 and
	C1 and C2 could have different sign for + or could have the
	same sign for -.

2024-11-27  Alexandre Oliva  <oliva@adacore.com>

	* tree-ssa-ifcombine.cc (ifcombine_ifandif): Avoid fallback
	conjunction of noncontiguous conditions.

2024-11-27  Florian Weimer  <fweimer@redhat.com>

	* doc/invoke.texi: Document -Wfree-labels.

2024-11-27  Jason Merrill  <jason@redhat.com>
	    Andrew Pinski  <quic_apinski@quicinc.com>
	    Andi Kleen  <ak@gcc.gnu.org>

	PR bootstrap/117350
	* tree.cc (need_assembler_name_p): Keep assembler name
	for abstract declarations when autofdo is used.

2024-11-26  David Malcolm  <dmalcolm@redhat.com>

	* selftest.cc (selftest::print_diff): New function.
	(selftest::assert_streq): Call it when we have non-equal
	non-null strings.

2024-11-26  David Malcolm  <dmalcolm@redhat.com>

	PR translation/90160
	* config/csky/csky.cc (csky_configure_build_target): Use %qs when
	referring to cpu and arch names.
	(csky_option_override): Likewise.

2024-11-26  David Malcolm  <dmalcolm@redhat.com>

	PR translation/80760
	* tree-ssa-loop-prefetch.cc (pass_loop_prefetch::execute): Add
	missing colon to not-a-power-of-two param warning.

2024-11-26  David Malcolm  <dmalcolm@redhat.com>

	PR plugins/93746
	* plugin.cc (try_init_one_plugin): Add missing colon in error
	message.

2024-11-26  Alex Coplan  <alex.coplan@arm.com>

	* gdbhooks.py (strip_ref): New. Use it ...
	(VecPrinter.to_string): ... here,
	(VecPrinter.children): ... and here.

2024-11-26  Robin Dapp  <rdapp@ventanamicro.com>

	* config/riscv/riscv-avlprop.cc (pass_avlprop::get_vlmax_ta_preferred_avl):
	Check whether the use insn is valid for propagation.

2024-11-26  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/102674
	* builtins.cc (fold_builtin_fpclassify): Use real_from_string3 rather
	than real_from_string.  Use "1E%d" format string rather than "0x1p%d"
	for decimal float minimum.  Formatting fixes.

2024-11-26  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/43374
	* real.cc (get_max_float): Handle decimal float.
	* builtins.cc (fold_builtin_interclass_mathfn): Use
	real_from_string3 rather than real_from_string.  Use
	"1E%d" format string rather than "0x1p%d" for decimal
	float minimum.

2024-11-26  Andrew Pinski  <quic_apinski@quicinc.com>

	* tree-affine.cc (wide_int_constant_multiple_p): Remove unused rem variable.

2024-11-26  Cui, Lili  <lili.cui@intel.com>

	PR target/116675
	* config/i386/i386-expand.cc (expand_vec_perm_pand_pandn_por):
	New subroutine.
	(ix86_expand_vec_perm_const_1): Call expand_vec_perm_pand_pandn_por.

2024-11-25  Andrew Pinski  <quic_apinski@quicinc.com>

	PR target/117771
	* system.h: Move the include of sstream above safe-ctype.h.

2024-11-25  H.J. Lu  <hjl.tools@gmail.com>

	PR middle-end/117098
	* calls.cc (store_one_arg): Check partial != 0 for BLKmode argument
	passed on stack.

2024-11-25  John David Anglin  <danglin@gcc.gnu.org>

	PR target/117645
	* config/pa/pa.md (addti3): Revise pattern to support
	arith11_operands.  Use "R" operand prefix to print least
	significant register of TImode register pair.
	(addvti3, subti3, subvti3): Likewise.
	(negti2, negvti2): Use "R" operand prefix.

2024-11-25  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR target/117105
	* lra-constraints.cc (get_reload_reg): Create unique value reload
	pseudos for early clobbered operands.

2024-11-25  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.md (*ashl<mode>3_negcnt):
	For SImode shifts allow multiples of 32 (or multiples
	of 64 for DImode shifts) for immediate operand 3.
	(*ashl<mode>3_negcnt_1): Ditto.
	(*<insn><mode>3_negcnt): Ditto.
	(*<insn><mode>3_negcnt_1): Ditto.

2024-11-25  Andrew Pinski  <quic_apinski@quicinc.com>

	* config/g.opt.urls: Regenerate.
	* config/i386/i386.opt.urls: Regenerate.
	* config/i386/nto.opt.urls: Regenerate.
	* config/nvptx/nvptx.opt.urls: Regenerate.
	* config/riscv/riscv.opt.urls: Regenerate.
	* config/s390/s390.opt.urls: Regenerate.
	* config/sol2.opt.urls: Regenerate.

2024-11-25  Sandra Loosemore  <sloosemore@baylibre.com>

	* common/config/nios2/*: Delete entire directory.
	* config/nios2/*: Delete entire directory.
	* config.gcc: Remove references to nios2.
	* configure.ac: Likewise.
	* doc/extend.texi: Likewise.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.
	* doc/md.texi: Likewise.
	* regenerate-opt-urls.py: Likewise.
	* config.in: Regenerated.
	* configure: Regenerated.

2024-11-25  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/117544
	* config/riscv/vector.md (*mov<mode>_whole): Split.
	(*mov<mode>_fract): Ditto.
	(*mov<mode>): Ditto.
	(*mov<mode>_vls): Ditto.
	(*mov<mode>_reg_whole_vtype): New pattern with vtype use.
	(*mov<mode>_fract_vtype): Ditto.
	(*mov<mode>_vtype): Ditto.
	(*mov<mode>_vls_vtype): Ditto.

2024-11-25  Robin Dapp  <rdapp@ventanamicro.com>

	PR target/111600
	* genemit.cc (handle_arg): Use files instead of filenames.
	(main): Ditto.
	* gensupport.cc (SIZED_BASED_CHUNKS): Define.
	(choose_output): New function.
	* gensupport.h (choose_output): Declare.

2024-11-25  Richard Biener  <rguenther@suse.de>

	PR target/116760
	* config/i386/i386.cc (ix86_vector_costs::add_stmt_cost):
	Scale vec_construct for single-lane VMAT_STRIDED_SLP the
	same as VMAT_ELEMENTWISE.
	* tree-vect-stmts.cc (vectorizable_store): Pass SLP node
	down to costing for vec_to_scalar for VMAT_STRIDED_SLP.

2024-11-25  Richard Biener  <rguenther@suse.de>

	* config/i386/i386.cc (ix86_vector_costs::finish_cost): For an
	128bit SSE epilogue request a 64bit SSE epilogue if the 128bit
	SSE epilogue VF was 16 or higher.

2024-11-25  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117767
	* tree-vect-stmts.cc (vectorizable_store): Check for supported
	alignment before using a an alternate store vector type.
	(vectorizable_load): Likewise for loads.

2024-11-25  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/115825
	* tree-ssa-loop-ivcanon.cc (loop_size::not_eliminatable_after_peeling):
	New.
	(loop_size::last_iteration_not_eliminatable_after_peeling): Likewise.
	(tree_estimate_loop_size): Count stmts with side-effects as
	not optimistically eliminatable.
	(estimated_unrolled_size): Compute the number of stmts that can
	be optimistically eliminated by followup transforms.
	(try_unroll_loop_completely): Adjust.

2024-11-25  Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/riscv.cc (riscv_asan_shadow_offset): Use dynamic
	offset for RV64.
	(riscv_asan_dynamic_shadow_offset_p): New.
	(TARGET_ASAN_DYNAMIC_SHADOW_OFFSET_P): New.

2024-11-25  Kito Cheng  <kito.cheng@sifive.com>

	* asan.cc (asan_dynamic_shadow_offset_p): New.
	(asan_shadow_memory_dynamic_address): New.
	(asan_local_shadow_memory_dynamic_address): New.
	(get_asan_shadow_memory_dynamic_address_decl): New.
	(asan_maybe_insert_dynamic_shadow_at_function_entry): New.
	(asan_emit_stack_protection): Support dynamic shadow offset.
	(build_shadow_mem_access): Ditto.
	* asan.h (asan_maybe_insert_dynamic_shadow_at_function_entry): New.
	* doc/tm.texi (TARGET_ASAN_DYNAMIC_SHADOW_OFFSET_P): New.
	* doc/tm.texi.in (TARGET_ASAN_DYNAMIC_SHADOW_OFFSET_P): Ditto.
	* sanopt.cc (pass_sanopt::execute): Handle dynamic shadow offset.
	* target.def (asan_dynamic_shadow_offset_p): New.
	* toplev.cc (process_options): Handle dynamic shadow offset.

2024-11-25  Dongyan Chen  <chendongyan@isrc.iscas.ac.cn>

	* common/config/riscv/riscv-common.cc: New extension.
	* common/config/riscv/riscv-ext-bitmask.def (RISCV_EXT_BITMASK): Ditto.
	* config/riscv/riscv.opt: New mask.

2024-11-25  Xi Ruoyao  <xry111@xry111.site>

	* config/pa/pa.cc (pa_section_type_flags): Remove.
	(TARGET_SECTION_TYPE_FLAGS): Remove.

2024-11-25  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>
	    Philipp Tomsich  <philipp.tomsich@vrull.eu>

	* Makefile.in (OBJS): Add avoid-store-forwarding.o.
	* common.opt (favoid-store-forwarding): New option.
	* common.opt.urls: Regenerate.
	* doc/invoke.texi: New param store-forwarding-max-distance.
	* doc/passes.texi: Document new pass.
	* doc/tm.texi: Regenerate.
	* doc/tm.texi.in: Document new pass.
	* params.opt (store-forwarding-max-distance): New param.
	* passes.def: Add pass_rtl_avoid_store_forwarding before
	pass_early_remat.
	* target.def (avoid_store_forwarding_p): New DEFHOOK.
	* target.h (struct store_fwd_info): Declare.
	* targhooks.cc (default_avoid_store_forwarding_p): New function.
	* targhooks.h (default_avoid_store_forwarding_p): Declare.
	* tree-pass.h (make_pass_rtl_avoid_store_forwarding): Declare.
	* avoid-store-forwarding.cc: New file.
	* avoid-store-forwarding.h: New file.
	* timevar.def (TV_AVOID_STORE_FORWARDING): New timevar.

2024-11-25  liuhongt  <hongtao.liu@intel.com>

	PR target/117562
	* config/i386/sse.md (vec_unpacks_hi_v4sf): Initialize
	operands[2] with CONST0_RTX.

2024-11-24  Martin Jambor  <mjambor@suse.cz>

	* ipa-prop.cc (ipa_duplicate_jump_function): New function.
	(ipa_edge_args_sum_t::duplicate): Move individual jump function
	copying to ipa_duplicate_jump_function.

2024-11-24  Uros Bizjak  <ubizjak@gmail.com>

	PR target/36503
	* config/i386/i386.md (*ashl<mode>3_negcnt):
	New define_insn_and_split pattern.
	(*ashl<mode>3_negcnt_1): Ditto.
	(*<insn><mode>3_negcnt): Ditto.
	(*<insn><mode>3_negcnt_1): Ditto.

2024-11-24  Andrew Pinski  <quic_apinski@quicinc.com>

	* config/avr/avr.opt.urls: Regenerate.
	* config/g.opt.urls: Regenerate.
	* config/i386/nto.opt.urls: Regenerate.
	* config/riscv/riscv.opt.urls: Regenerate.
	* config/rx/rx.opt.urls: Regenerate.
	* config/sol2.opt.urls: Regenerate.

2024-11-24  Eric Botcazou  <ebotcazou@adacore.com>

	PR target/117715
	* config/sparc/sparc-protos.h (sparc_expand_vcond): Rename to...
	(sparc_expand_vcond_mask): ...this.
	* config/sparc/sparc.cc (TARGET_VECTORIZE_GET_MASK_MODE): Define.
	(sparc_vis_init_builtins): Adjust the CODE_FOR_* identifiers.
	(sparc_get_mask_mode): New function.
	(sparc_expand_vcond): Rename to...
	(sparc_expand_vcond_mask): ...this and adjust.
	* config/sparc/sparc.md (unspec): Remove UNSPEC_FCMP & UNSPEC_FUCMP
	and rename UNSPEC_FPUCMPSHL into UNSPEC_FPCMPUSHL.
	(fcmp<gcond:code><GCM:gcm_name><P:mode>_vis): Merge into...
	(fpcmp<gcond:code>8<P:mode>_vis): Merge into...
	(fpcmp<fpcmpcond:code><FPCMP:vbits><P:mode>_vis): ...this.
	(fucmp<gcond:code>8<P:mode>_vis): Merge into...
	(fpcmpu<gcond:code><GCM:gcm_name><P:mode>_vis): Merge into...
	(fpcmpu<fpcmpucond:signed_code><FPCMP:vbits><P:mode>_vis): ...this.
	(vec_cmp<FPCMP:mode><P:mode>): New expander.
	(vec_cmpu<FPCMP:mode><P:mode>): Likewise.
	(vcond<GCM:mode><GCM:mode>): Delete.
	(vcondv8qiv8qi): Likewise.
	(vcondu<GCM:mode><GCM:mode>): Likewise.
	(vconduv8qiv8qi): Likewise.
	(vcond_mask_<FPCMP:mode><P:mode>): New expander.
	(fpcmp<fpcscond:code><FPCSMODE:vbits><P:mode>shl): Adjust.
	(fpcmpu<fpcsucond:code><FPCSMODE:vbits><P:mode>shl): Likewise.
	(fpcmpde<FPCSMODE:vbits><P:mode>shl): Likewise.
	(fpcmpur<FPCSMODE:vbits><P:mode>shl): Likewise.
	* doc/md.texi (vcond_mask_len_): Fix pasto.

2024-11-24  Eric Botcazou  <ebotcazou@adacore.com>

	* doc/invoke.texi (-fno-zero-initialized-in-bss): Adjust for Ada.
	* varasm.cc (get_variable_section): Adjust the error message for an
	initialized variable in .bss to -fno-zero-initialized-in-bss.

2024-11-23  Lewis Hyatt  <lhyatt@gmail.com>

	* gimple.cc (get_tail_padding_adjustment): New function.
	(DEFGSSTRUCT): Adjust the computation of gimple_ops_offset_ to be
	correct in the presence of tail padding.

2024-11-23  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117744
	* config/avr/avr.cc (out_movqi_r_mr): Fix code when a load
	only partially clobbers an address register due to
	changing the address register temporally to accomodate for
	faked addressing modes.

2024-11-23  Andrew Pinski  <quic_apinski@quicinc.com>

	* doc/rtl.texi: Add a note about quotes in braced strings.

2024-11-22  Andrew Pinski  <quic_apinski@quicinc.com>

	PR bootstrap/117737
	* asan.cc (INCLUDE_MEMORY): Remove.
	* attribs.cc (INCLUDE_MEMORY): Remove.
	* auto-profile.cc (INCLUDE_MEMORY): Remove.
	* calls.cc (INCLUDE_MEMORY): Remove.
	* cfganal.cc (INCLUDE_MEMORY): Remove.
	* cfgexpand.cc (INCLUDE_MEMORY): Remove.
	* cfghooks.cc (INCLUDE_MEMORY): Remove.
	* cfgloop.cc (INCLUDE_MEMORY): Remove.
	* cgraph.cc (INCLUDE_MEMORY): Remove.
	* cgraphclones.cc (INCLUDE_MEMORY): Remove.
	* cgraphunit.cc (INCLUDE_MEMORY): Remove.
	* collect-utils.cc (INCLUDE_MEMORY): Remove.
	* collect2.cc (INCLUDE_MEMORY): Remove.
	* common/config/aarch64/aarch64-common.cc (INCLUDE_MEMORY): Remove.
	* common/config/arm/arm-common.cc (INCLUDE_MEMORY): Remove.
	* common/config/avr/avr-common.cc (INCLUDE_MEMORY): Remove.
	* config/aarch64/aarch64-cc-fusion.cc (INCLUDE_MEMORY): Remove.
	* config/aarch64/aarch64-early-ra.cc (INCLUDE_MEMORY): Remove.
	* config/aarch64/aarch64-sve-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/aarch64/aarch64.cc (INCLUDE_MEMORY): Remove.
	* config/arc/arc.cc (INCLUDE_MEMORY): Remove.
	* config/arm/aarch-common.cc (INCLUDE_MEMORY) Remove.:
	* config/arm/arm-mve-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/arm/arm.cc (INCLUDE_MEMORY): Remove.
	* config/avr/avr-devices.cc (INCLUDE_MEMORY): Remove.
	* config/avr/driver-avr.cc (INCLUDE_MEMORY): Remove.
	* config/bpf/bpf.cc (INCLUDE_MEMORY): Remove.
	* config/bpf/btfext-out.cc (INCLUDE_MEMORY): Remove.
	* config/bpf/core-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/darwin.cc (INCLUDE_MEMORY): Remove.
	* config/gcn/mkoffload.cc (INCLUDE_MEMORY): Remove.
	* config/i386/driver-i386.cc (INCLUDE_MEMORY): Remove.
	* config/i386/i386-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/i386/i386-expand.cc (INCLUDE_MEMORY): Remove.
	* config/i386/i386-features.cc (INCLUDE_MEMORY): Remove.
	* config/i386/i386-options.cc (INCLUDE_MEMORY): Remove.
	* config/i386/i386.cc (INCLUDE_MEMORY): Remove.
	* config/loongarch/loongarch-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/loongarch/loongarch.cc (INCLUDE_MEMORY): Remove.
	* config/mingw/winnt-cxx.cc (INCLUDE_MEMORY): Remove.
	* config/mingw/winnt.cc (INCLUDE_MEMORY): Remove.
	* config/mips/mips.cc (INCLUDE_MEMORY): Remove.
	* config/msp430/driver-msp430.cc (INCLUDE_MEMORY): Remove.
	* config/nvptx/mkoffload.cc (INCLUDE_MEMORY): Remove.
	* config/nvptx/nvptx.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv-avlprop.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv-target-attr.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv-vector-builtins.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv-vector-costs.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv-vsetvl.cc (INCLUDE_MEMORY): Remove.
	* config/riscv/riscv.cc (INCLUDE_MEMORY): Remove.
	* config/rs6000/driver-rs6000.cc (INCLUDE_MEMORY): Remove.
	* config/rs6000/host-darwin.cc (INCLUDE_MEMORY): Remove.
	* config/rs6000/rs6000-c.cc (INCLUDE_MEMORY): Remove.
	* config/rs6000/rs6000.cc (INCLUDE_MEMORY): Remove.
	* config/s390/s390-c.cc (INCLUDE_MEMORY): Remove.
	* config/s390/s390.cc (INCLUDE_MEMORY): Remove.
	* config/sol2-cxx.cc (INCLUDE_MEMORY): Remove.
	* config/vms/vms-c.cc (INCLUDE_MEMORY): Remove.
	* config/xtensa/xtensa-dynconfig.cc (INCLUDE_MEMORY): Remove.
	* coroutine-passes.cc (INCLUDE_MEMORY): Remove.
	* coverage.cc (INCLUDE_MEMORY): Remove.
	* data-streamer-in.cc (INCLUDE_MEMORY): Remove.
	* data-streamer-out.cc (INCLUDE_MEMORY): Remove.
	* data-streamer.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-format-json.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-format-sarif.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-format-text.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-global-context.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-macro-unwinding.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-path.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-show-locus.cc (INCLUDE_MEMORY): Remove.
	* diagnostic-spec.cc (INCLUDE_MEMORY): Remove.
	* diagnostic.cc (INCLUDE_MEMORY): Remove.
	* diagnostic.h: Remove check for INCLUDE_MEMORY.
	* digraph.cc (INCLUDE_MEMORY): Remove.
	* dumpfile.cc (INCLUDE_MEMORY): Remove.
	* dwarf2out.cc (INCLUDE_MEMORY): Remove.
	* edit-context.cc (INCLUDE_MEMORY): Remove.
	* except.cc (INCLUDE_MEMORY): Remove.
	* expr.cc (INCLUDE_MEMORY): Remove.
	* file-prefix-map.cc (INCLUDE_MEMORY): Remove.
	* final.cc (INCLUDE_MEMORY): Remove.
	* fwprop.cc (INCLUDE_MEMORY): Remove.
	* gcc-plugin.h (INCLUDE_MEMORY): Remove.
	* gcc-rich-location.cc (INCLUDE_MEMORY): Remove.
	* gcc-urlifier.cc (INCLUDE_MEMORY): Remove.
	* gcc.cc (INCLUDE_MEMORY): Remove.
	* gcov-dump.cc (INCLUDE_MEMORY): Remove.
	* gcov-tool.cc (INCLUDE_MEMORY): Remove.
	* gcov.cc (INCLUDE_MEMORY): Remove.
	* gengtype.cc (open_base_files): Don't print `#define INCLUDE_MEMORY`.
	* genmatch.cc (INCLUDE_MEMORY): Remove.
	* gimple-fold.cc (INCLUDE_MEMORY): Remove.
	* gimple-harden-conditionals.cc (INCLUDE_MEMORY): Remove.
	* gimple-harden-control-flow.cc (INCLUDE_MEMORY): Remove.
	* gimple-if-to-switch.cc (INCLUDE_MEMORY): Remove.
	* gimple-loop-interchange.cc (INCLUDE_MEMORY): Remove.
	* gimple-loop-jam.cc (INCLUDE_MEMORY): Remove.
	* gimple-loop-versioning.cc (INCLUDE_MEMORY): Remove.
	* gimple-lower-bitint.cc (INCLUDE_MEMORY): Remove.
	* gimple-predicate-analysis.cc (INCLUDE_MEMORY): Remove.
	* gimple-pretty-print.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-cache.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-edge.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-fold.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-gori.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-infer.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-op.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-path.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-phi.cc (INCLUDE_MEMORY): Remove.
	* gimple-range-trace.cc (INCLUDE_MEMORY): Remove.
	* gimple-range.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-backprop.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-sprintf.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-store-merging.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-strength-reduction.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-warn-access.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-warn-alloca.cc (INCLUDE_MEMORY): Remove.
	* gimple-ssa-warn-restrict.cc (INCLUDE_MEMORY): Remove.
	* gimple-streamer-in.cc (INCLUDE_MEMORY): Remove.
	* gimple-streamer-out.cc (INCLUDE_MEMORY): Remove.
	* gimple.cc (INCLUDE_MEMORY): Remove.
	* gimplify.cc (INCLUDE_MEMORY): Remove.
	* graph.cc (INCLUDE_MEMORY): Remove.
	* graphite-dependences.cc (INCLUDE_MEMORY): Remove.
	* graphite-isl-ast-to-gimple.cc (INCLUDE_MEMORY): Remove.
	* graphite-optimize-isl.cc (INCLUDE_MEMORY): Remove.
	* graphite-poly.cc (INCLUDE_MEMORY): Remove.
	* graphite-scop-detection.cc (INCLUDE_MEMORY): Remove.
	* graphite-sese-to-poly.cc (INCLUDE_MEMORY): Remove.
	* graphite.cc (INCLUDE_MEMORY): Remove.
	* graphviz.cc (INCLUDE_MEMORY): Remove.
	* input.cc (INCLUDE_MEMORY): Remove.
	* ipa-cp.cc (INCLUDE_MEMORY): Remove.
	* ipa-devirt.cc (INCLUDE_MEMORY): Remove.
	* ipa-fnsummary.cc (INCLUDE_MEMORY): Remove.
	* ipa-free-lang-data.cc (INCLUDE_MEMORY): Remove.
	* ipa-icf-gimple.cc (INCLUDE_MEMORY): Remove.
	* ipa-icf.cc (INCLUDE_MEMORY): Remove.
	* ipa-inline-analysis.cc (INCLUDE_MEMORY): Remove.
	* ipa-inline.cc (INCLUDE_MEMORY): Remove.
	* ipa-modref-tree.cc (INCLUDE_MEMORY): Remove.
	* ipa-modref.cc (INCLUDE_MEMORY): Remove.
	* ipa-param-manipulation.cc (INCLUDE_MEMORY): Remove.
	* ipa-polymorphic-call.cc (INCLUDE_MEMORY): Remove.
	* ipa-predicate.cc (INCLUDE_MEMORY): Remove.
	* ipa-profile.cc (INCLUDE_MEMORY): Remove.
	* ipa-prop.cc (INCLUDE_MEMORY): Remove.
	* ipa-pure-const.cc (INCLUDE_MEMORY): Remove.
	* ipa-reference.cc (INCLUDE_MEMORY): Remove.
	* ipa-split.cc (INCLUDE_MEMORY): Remove.
	* ipa-sra.cc (INCLUDE_MEMORY): Remove.
	* ipa-strub.cc (INCLUDE_MEMORY): Remove.
	* ipa-utils.cc (INCLUDE_MEMORY): Remove.
	* json-parsing.cc (INCLUDE_MEMORY): Remove.
	* json.cc (INCLUDE_MEMORY): Remove.
	* json.h: Don't check INCLUDE_MEMORY.
	* langhooks.cc (INCLUDE_MEMORY): Remove.
	* late-combine.cc (INCLUDE_MEMORY): Remove.
	* lazy-diagnostic-path.cc (INCLUDE_MEMORY): Remove.
	* libdiagnostics.cc (INCLUDE_MEMORY): Remove.
	* libsarifreplay.cc (INCLUDE_MEMORY): Remove.
	* lto-cgraph.cc (INCLUDE_MEMORY): Remove.
	* lto-compress.cc (INCLUDE_MEMORY): Remove.
	* lto-opts.cc (INCLUDE_MEMORY): Remove.
	* lto-section-in.cc (INCLUDE_MEMORY): Remove.
	* lto-section-out.cc (INCLUDE_MEMORY): Remove.
	* lto-streamer-in.cc (INCLUDE_MEMORY): Remove.
	* lto-streamer-out.cc (INCLUDE_MEMORY): Remove.
	* lto-streamer.cc (INCLUDE_MEMORY): Remove.
	* lto-wrapper.cc (INCLUDE_MEMORY): Remove.
	* make-unique.h (GCC_MAKE_UNIQUE): Remove.
	* multiple_target.cc (INCLUDE_MEMORY): Remove.
	* omp-expand.cc (INCLUDE_MEMORY): Remove.
	* omp-general.cc (INCLUDE_MEMORY): Remove.
	* omp-low.cc (INCLUDE_MEMORY): Remove.
	* omp-oacc-neuter-broadcast.cc (INCLUDE_MEMORY): Remove.
	* omp-offload.cc (INCLUDE_MEMORY): Remove.
	* omp-simd-clone.cc (INCLUDE_MEMORY): Remove.
	* opt-problem.cc (INCLUDE_MEMORY): Remove.
	* optinfo-emit-json.cc (INCLUDE_MEMORY): Remove.
	* optinfo.cc (INCLUDE_MEMORY): Remove.
	* optinfo.h: Don't check INCLUDE_MEMORY.
	* opts-common.cc (INCLUDE_MEMORY): Remove.
	* opts-diagnostic.cc (INCLUDE_MEMORY): Remove.
	* opts-global.cc (INCLUDE_MEMORY): Remove.
	* opts.cc (INCLUDE_MEMORY): Remove.
	* pair-fusion.cc (INCLUDE_MEMORY): Remove.
	* passes.cc (INCLUDE_MEMORY): Remove.
	* pointer-query.cc (INCLUDE_MEMORY): Remove.
	* predict.cc (INCLUDE_MEMORY): Remove.
	* pretty-print.cc (INCLUDE_MEMORY): Remove.
	* pretty-print.h: Don't check INCLUDE_MEMORY.
	* print-rtl.cc (INCLUDE_MEMORY): Remove.
	* print-tree.cc (INCLUDE_MEMORY): Remove.
	* profile-count.cc (INCLUDE_MEMORY): Remove.
	* range-op-float.cc (INCLUDE_MEMORY): Remove.
	* range-op-ptr.cc (INCLUDE_MEMORY): Remove.
	* range-op.cc (INCLUDE_MEMORY): Remove.
	* range.cc (INCLUDE_MEMORY): Remove.
	* read-rtl-function.cc (INCLUDE_MEMORY): Remove.
	* rtl-error.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/accesses.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/blocks.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/changes.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/functions.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/insns.cc (INCLUDE_MEMORY): Remove.
	* rtl-ssa/movement.cc (INCLUDE_MEMORY): Remove.
	* rtl-tests.cc (INCLUDE_MEMORY): Remove.
	* sanopt.cc (INCLUDE_MEMORY): Remove.
	* sched-rgn.cc (INCLUDE_MEMORY): Remove.
	* selftest-diagnostic-path.cc (INCLUDE_MEMORY): Remove.
	* selftest-diagnostic.cc (INCLUDE_MEMORY): Remove.
	* selftest-json.cc (INCLUDE_MEMORY): Remove.
	* sese.cc (INCLUDE_MEMORY): Remove.
	* simple-diagnostic-path.cc (INCLUDE_MEMORY): Remove.
	* splay-tree-utils.cc (INCLUDE_MEMORY): Remove.
	* sreal.cc (INCLUDE_MEMORY): Remove.
	* stmt.cc (INCLUDE_MEMORY): Remove.
	* substring-locations.cc (INCLUDE_MEMORY): Remove.
	* symtab-clones.cc (INCLUDE_MEMORY): Remove.
	* symtab-thunks.cc (INCLUDE_MEMORY): Remove.
	* symtab.cc (INCLUDE_MEMORY): Remove.
	* system.h: Include memory unconditionally for C++.
	Also remove support for INCLUDE_MEMORY.
	* targhooks.cc (INCLUDE_MEMORY): Remove.
	* text-art/box-drawing.cc (INCLUDE_MEMORY): Remove.
	* text-art/canvas.cc (INCLUDE_MEMORY): Remove.
	* text-art/ruler.cc (INCLUDE_MEMORY): Remove.
	* text-art/selftests.cc (INCLUDE_MEMORY): Remove.
	* text-art/style.cc (INCLUDE_MEMORY): Remove.
	* text-art/styled-string.cc (INCLUDE_MEMORY): Remove.
	* text-art/table.cc (INCLUDE_MEMORY): Remove.
	* text-art/theme.cc (INCLUDE_MEMORY): Remove.
	* text-art/tree-widget.cc (INCLUDE_MEMORY): Remove.
	* text-art/widget.cc (INCLUDE_MEMORY): Remove.
	* timevar.cc (INCLUDE_MEMORY): Remove.
	* toplev.cc (INCLUDE_MEMORY): Remove.
	* trans-mem.cc (INCLUDE_MEMORY): Remove.
	* tree-affine.cc (INCLUDE_MEMORY): Remove.
	* tree-assume.cc (INCLUDE_MEMORY): Remove.
	* tree-call-cdce.cc (INCLUDE_MEMORY): Remove.
	* tree-cfg.cc (INCLUDE_MEMORY): Remove.
	* tree-chrec.cc (INCLUDE_MEMORY): Remove.
	* tree-data-ref.cc (INCLUDE_MEMORY): Remove.
	* tree-dfa.cc (INCLUDE_MEMORY): Remove.
	* tree-diagnostic-client-data-hooks.cc (INCLUDE_MEMORY): Remove.
	* tree-diagnostic.cc (INCLUDE_MEMORY): Remove.
	* tree-dump.cc (INCLUDE_MEMORY): Remove.
	* tree-if-conv.cc (INCLUDE_MEMORY): Remove.
	* tree-inline.cc (INCLUDE_MEMORY): Remove.
	* tree-into-ssa.cc (INCLUDE_MEMORY): Remove.
	* tree-logical-location.cc (INCLUDE_MEMORY): Remove.
	* tree-loop-distribution.cc (INCLUDE_MEMORY): Remove.
	* tree-nested.cc (INCLUDE_MEMORY): Remove.
	* tree-nrv.cc (INCLUDE_MEMORY): Remove.
	* tree-object-size.cc (INCLUDE_MEMORY): Remove.
	* tree-outof-ssa.cc (INCLUDE_MEMORY): Remove.
	* tree-parloops.cc (INCLUDE_MEMORY): Remove.
	* tree-predcom.cc (INCLUDE_MEMORY): Remove.
	* tree-pretty-print.cc (INCLUDE_MEMORY): Remove.
	* tree-profile.cc (INCLUDE_MEMORY): Remove.
	* tree-scalar-evolution.cc (INCLUDE_MEMORY): Remove.
	* tree-sra.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-address.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-alias.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-ccp.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-coalesce.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-copy.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-dce.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-dom.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-dse.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-forwprop.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-ifcombine.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-live.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-ch.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-im.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-ivcanon.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-ivopts.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-manip.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-niter.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-prefetch.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-split.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-loop-unswitch.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-math-opts.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-operands.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-phiopt.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-phiprop.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-pre.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-propagate.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-reassoc.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-sccvn.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-scopedtables.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-sink.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-strlen.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-structalias.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-ter.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-threadbackward.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-threadupdate.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa-uninit.cc (INCLUDE_MEMORY): Remove.
	* tree-ssa.cc (INCLUDE_MEMORY): Remove.
	* tree-ssanames.cc (INCLUDE_MEMORY): Remove.
	* tree-stdarg.cc (INCLUDE_MEMORY): Remove.
	* tree-streamer-in.cc (INCLUDE_MEMORY): Remove.
	* tree-streamer-out.cc (INCLUDE_MEMORY): Remove.
	* tree-streamer.cc (INCLUDE_MEMORY): Remove.
	* tree-switch-conversion.cc (INCLUDE_MEMORY): Remove.
	* tree-tailcall.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-data-refs.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-generic.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-loop-manip.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-loop.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-patterns.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-slp-patterns.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-slp.cc (INCLUDE_MEMORY): Remove.
	* tree-vect-stmts.cc (INCLUDE_MEMORY): Remove.
	* tree-vectorizer.cc (INCLUDE_MEMORY): Remove.
	* tree-vrp.cc (INCLUDE_MEMORY): Remove.
	* tree.cc (INCLUDE_MEMORY): Remove.
	* ubsan.cc (INCLUDE_MEMORY): Remove.
	* value-pointer-equiv.cc (INCLUDE_MEMORY): Remove.
	* value-prof.cc (INCLUDE_MEMORY): Remove.
	* value-query.cc (INCLUDE_MEMORY): Remove.
	* value-range-pretty-print.cc (INCLUDE_MEMORY): Remove.
	* value-range-storage.cc (INCLUDE_MEMORY): Remove.
	* value-range.cc (INCLUDE_MEMORY): Remove.
	* value-relation.cc (INCLUDE_MEMORY): Remove.
	* var-tracking.cc (INCLUDE_MEMORY): Remove.
	* varpool.cc (INCLUDE_MEMORY): Remove.
	* vr-values.cc (INCLUDE_MEMORY): Remove.
	* wide-int-print.cc (INCLUDE_MEMORY): Remove.

2024-11-22  Jeff Law  <jlaw@ventanamicro.com>

	PR target/109279
	* config/riscv/riscv.cc (riscv_build_integer): Handle another 64-bit
	synthesis where high half is one less than the low half and the 32-bit
	sign bit is on.

2024-11-22  Andrew Pinski  <quic_apinski@quicinc.com>

	* text-art/types.h: Fix comment.

2024-11-22  Georg-Johann Lay  <avr@gjlay.de>

	* common/config/avr/avr-common.cc: Tabify.

2024-11-22  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117726
	* config/avr/avr-passes.cc (avr_split_shift): Also handle
	ASHIFTRT and LSHIFTRT codes for 4-byte shifts.
	(constr_split_shift4): New code_attr.
	(avr_emit_shift): Adjust to new shift capabilities.
	* config/avr/predicates.md (scratch_or_d_register_operand):
	rename to scratch_or_dreg_operand.
	* config/avr/avr.md: Same.
	(define_peephole2): Write the RTL scratch peephole for 2-byte and
	4-byte shifts that generates *sh*<mode>3_const insns using code
	iterator any_shift.
	(*ashlhi3_const_split, *ashrhi3_const_split, *ashrhi3_const_split)
	(*lshrsi3_const_split, *lshrhi3_const_split): Remove useless
	split insns.
	(define_split) [avropt_split_bit_shift]: Add splitters
	for 4-byte ASHIFTRT and LSHIFTRT insns using avr_split_shift().
	(ashrsi3, *ashrsi3, *ashrsi3_const): Add "r,0,C4a" and "r,r,C4a"
	constraint alternatives depending on 2op, 3op.
	(lshrsi3, *lshrsi3, *lshrsi3_const): Add "r,0,C4r" and "r,r,C4r"
	constraint alternatives depending on 2op, 3op. Add "r,r,C15".
	(lshrhi3, *lshrhi3, *lshrhi3_const, ashlhi3, *ashlhi3)
	(*ashlhi3_const): Add "r,r,C7c" alternative.
	(ashrpsi, *ashrpsi3): Add "r,r,C22" alternative.
	(ashlqi, *ashlqi): Turn C06 alternative into "r,r,C06".
	* config/avr/constraints.md (C14, C22, C30, C7c): New constraints.
	* config/avr/avr.cc (ashlhi3_out, lshrhi3_out)
	[case 7, 9, 10, 11, 12]: Support as 3-operand insn.
	(lshrsi3_out) [case 15]: Same.
	(ashrsi3_out) [case 30]: Same.
	(ashrhi3_out) [case 14]: Same.
	(ashrqi3_out) [case 6]: Same.
	(avr_out_ashrpsi3) [case 22]: Same.
	* config/avr/avr.h: Fix comment typo.
	* doc/invoke.texi (AVR Options) <-msplit-bit-shift>: Document.

2024-11-22  Siddhesh Poyarekar  <siddhesh@gotplt.org>

	PR tree-optimization/117355
	* tree-object-size.cc (size_for_offset): New argument STRICT,
	return SZ if it is set to false.
	(plus_stmt_object_size): Adjust call to SIZE_FOR_OFFSET.

2024-11-22  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.opt (avr_bits_e, avr_lra_p, avr_mmcu)
	(avr_gasisr_prologues, avr_n_flash, avr_log_details)
	(avr_branch_cost, avr_split_bit_shift, avr_strict_X)
	(avr_flmap, avr_rodata_in_ram, avr_sp8, avr_fuse_add)
	(avr_warn_addr_space_convert, avr_warn_misspelled_isr)
	(avr_fuse_move, avr_double, avr_long_double): Rename
	to respectively: avropt_bits_e, avropt_lra_p, avropt_mmcu,
	avropt_gasisr_prologues, avropt_n_flash, avropt_log_details,
	avropt_branch_cost, avropt_split_bit_shift, avropt_strict_X,
	avropt_flmap, avropt_rodata_in_ram, avropt_sp8, avropt_fuse_add,
	avropt_warn_addr_space_convert, avropt_warn_misspelled_isr,
	avropt_fuse_move, avropt_double, avropt_long_double.
	* config/avr/avr.h: Same.
	* config/avr/avr.cc: Same.
	* config/avr/avr.md: Same.
	* config/avr/avr-passes.cc
	* config/avr/avr-log.cc: Same.
	* common/config/avr/avr-common.cc: Same.

2024-11-22  Jakub Jelinek  <jakub@redhat.com>

	PR c++/110137
	PR middle-end/101480
	* doc/invoke.texi (-fassume-sane-operators-new-delete,
	-fno-assume-sane-operators-new-delete): Document.
	* gimple.cc (gimple_call_fnspec): Handle
	-f{,no-}assume-sane-operators-new-delete.
	* ipa-inline-transform.cc (inline_call): Also clear
	flag_assume_sane_operators_new_delete on caller when inlining
	-fno-assume-sane-operators-new-delete callee into
	-fassume-sane-operators-new-delete caller.

2024-11-22  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/117420
	* match.pd ((X >> C1) << (C1 + C2) -> X << C2,
	(X >> C1) * (C2 << C1) -> X * C2, X / (1 << C) -> X /[ex] (1 << C)):
	Use with_possible_nonzero_bits@0 rather than
	(with_possible_nonzero_bits2 @0).

2024-11-22  Tobias Burnus  <tburnus@baylibre.com>

	* gimplify.cc (gimplify_call_expr): Add initial support for
	dispatch's 'interop' clause.
	(gimplify_scan_omp_clauses): Handle interop clause.
	* tree-pretty-print.cc (dump_omp_clause): Likewise.
	* tree-core.h (enum omp_clause_code): Add OMP_CLAUSE_INTEROP.
	* tree.cc (omp_clause_num_ops, omp_clause_code_name): Add interop.

2024-11-22  Tobias Burnus  <tburnus@baylibre.com>

	* gimplify.cc (gimplify_expr): Handle OMP_INTEROP by printing
	"sorry, uninplemented".
	* omp-api.h (omp_get_fr_id_from_name): Change return type to
	'char'.
	* omp-general.cc (omp_get_fr_id_from_name): Likewise; return
	GOMP_INTEROP_IFR_UNKNOWN not 0 if not found.
	(omp_get_name_from_fr_id): Return "<unknown>" not NULL
	if not found (used for dumps).
	* tree-core.h (enum omp_clause_code): Add OMP_CLAUSE_DESTROY,
	OMP_CLAUSE_USE, and OMP_CLAUSE_INIT.
	* tree-pretty-print.cc (dump_omp_init_prefer_type): New.
	(dump_omp_clause): Handle init, use and destroy clauses.
	(dump_generic_node): Handle interop directive.
	* tree.cc (omp_clause_num_ops, omp_clause_code_name): Add new
	init/use/destroy clauses.
	* tree.def (OACC_LOOP): Fix comment.
	(OMP_INTEROP): Add.
	* tree.h (OMP_INTEROP_CLAUSES, OMP_CLAUSE_INIT_TARGET,
	OMP_CLAUSE_INIT_TARGETSYNC, OMP_CLAUSE_INIT_PREFER_TYPE): New.

2024-11-22  Jakub Jelinek  <jakub@redhat.com>

	PR target/117165
	* config/i386/i386-builtin.def (IX86_BUILTIN_FNSTENV,
	IX86_BUILTIN_FLDENV, IX86_BUILTIN_FNSTSW, IX86_BUILTIN_FNCLEX): Add
	space to the end of the builtin name to make it really internal.

2024-11-22  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/116463
	* tree-vect-slp-patterns.cc (complex_mul_pattern::matches,
	complex_fms_pattern::matches): Try swapping operands on multiply.

2024-11-22  Lulu Cheng  <chenglulu@loongson.cn>

	* doc/invoke.texi: Remove the non-existent option
	'-msmall-data-limit' and add a description of '-G'.

2024-11-22  Lulu Cheng  <chenglulu@loongson.cn>

	* config/loongarch/loongarch-builtins.cc
	(loongarch_builtin_vectorized_function): Delete.
	(LARCH_GET_BUILTIN): Delete.
	* config/loongarch/loongarch-protos.h
	(loongarch_builtin_vectorized_function): Delete.
	* config/loongarch/loongarch.cc
	(TARGET_ASM_ALIGNED_HI_OP): Delete.
	(TARGET_ASM_ALIGNED_SI_OP): Delete.
	(TARGET_ASM_ALIGNED_DI_OP): Delete.

2024-11-22  Lulu Cheng  <chenglulu@loongson.cn>

	* config/loongarch/lasx.md: Fixed.
	* config/loongarch/lsx.md: Fixed.

2024-11-22  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch-builtins.cc (vorn_v, xvorn_v): Use
	unsigned vector modes.
	* config/loongarch/lsxintrin.h (__lsx_vorn_v): Cast arguments to
	v16u8.
	* config/loongarch/lasxintrin.h (__lasx_xvorn_v): Cast arguments
	to v32u8.

2024-11-21  Jeff Law  <jlaw@ventanamicro.com>

	PR target/117690
	* config/riscv/riscv.cc (riscv_build_integer): Add missing left
	shift when using shNadd to derive upper 32 bits from lower 32 bits.

2024-11-21  Arsen Arsenović  <arsen@aarsen.me>

	* doc/cpp.texi (__has_include): Document __has_include_next
	also.
	(Conditional Syntax): Mention __has_include_next in the
	description for the __has_include menu entry.

2024-11-21  David Malcolm  <dmalcolm@redhat.com>

	PR bootstrap/117677
	* json-parsing.cc (selftest::test_parse_number): Replace
	ASSERT_EQ of 'double' values with ASSERT_NEAR.  Eliminate
	ASSERT_PRINT_EQ for such values.
	* selftest.h (ASSERT_NEAR): New.
	(ASSERT_NEAR_AT): New.

2024-11-21  Georg-Johann Lay  <avr@gjlay.de>

	PR target/117726
	* config/avr/avr.opt (-msplit-bit-shift): Add new optimization option.
	* common/config/avr/avr-common.cc (avr_option_optimization_table)
	[OPT_LEVELS_2_PLUS]: Turn on -msplit-bit-shift.
	* config/avr/avr.h (machine_function.n_avr_fuse_add_executed):
	New bool component.
	* config/avr/avr.md (attr "isa") <2op, 3op>: Add new values.
	(attr "enabled"): Handle them.
	(ashlsi3, *ashlsi3, *ashlsi3_const): Add "r,r,C15" alternative.
	Add "r,0,C4l" and "r,r,C4l" alternatives (depending on 2op / 3op).
	(define_split) [avr_split_bit_shift]: Add 2 new ashift:ALL4 splitters.
	(define_peephole2) [ashift:ALL4]: Add (match_dup 3) so that the scratch
	won't overlap with the output operand of the matched insn.
	(*ashl<mode>3_const_split): Remove unused ashift:ALL4 splitter.
	* config/avr/avr-passes.cc (emit_valid_insn)
	(emit_valid_move_clobbercc): Move out of anonymous namespace.
	(make_avr_pass_fuse_add) <gate>: Don't override.
	<execute>: Set n_avr_fuse_add_executed according to
	func->machine->n_avr_fuse_add_executed.
	(pass_data avr_pass_data_split_after_peephole2): New object.
	(avr_pass_split_after_peephole2): New rtl_opt_pass.
	(avr_emit_shift): New static function.
	(avr_shift_is_3op, avr_split_shift_p, avr_split_shift)
	(make_avr_pass_split_after_peephole2): New functions.
	* config/avr/avr-passes.def (avr_pass_split_after_peephole2):
	Insert new pass after pass_peephole2.
	* config/avr/avr-protos.h
	(n_avr_fuse_add_executed, avr_shift_is_3op, avr_split_shift_p)
	(avr_split_shift, avr_optimize_size_level)
	(make_avr_pass_split_after_peephole2): New prototypes.
	* config/avr/avr.cc (n_avr_fuse_add_executed): New global variable.
	(avr_optimize_size_level): New function.
	(avr_set_current_function): Set n_avr_fuse_add_executed
	according to cfun->machine->n_avr_fuse_add_executed.
	(ashlsi3_out) [case 15]: Output optimized code for this offset.
	(avr_rtx_costs_1) [ASHIFT, SImode]: Adjust costs of oggsets 15, 16.
	* config/avr/constraints.md (C4a, C4r, C4r): New constraints.
	* pass_manager.h (pass_manager): Adjust comments.

2024-11-21  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr-passes.cc (absint_t::dump): Fix missing
	newline in dump.

2024-11-21  Jeff Law  <jlaw@ventanamicro.com>

	PR target/116590
	* config/riscv/vector.md (pred_mul_<optab>mode_undef): Drop
	unnecessary alternatives.
	(pred_<madd_msub><mode>): Likewise.
	(pred_<macc_msac><mode>): Likewise.
	(pred_<madd_msub><mode>_scalar): Likewise.
	(pred_<macc_msac><mode>_scalar): Likewise.
	(pred_mul_neg_<optab><mode>_undef): Likewise.
	(pred_<nmsub_nmadd><mode>): Likewise.
	(pred_<nmsac_nmacc><mode>): Likewise.
	(pred_<nmsub_nmadd><mode>_scalar): Likewise.
	(pred_<nmsac_nmacc><mode>_scalar): Likewise.

2024-11-21  Pan Li  <pan2.li@intel.com>

	* match.pd: Refactor sorts of unsigned SAT_ADD match pattern.

2024-11-21  Tamar Christina  <tamar.christina@arm.com>

	* tree-vect-data-refs.cc (vect_get_data_access_cost): Pass NULL for SLP
	node.
	* tree-vect-stmts.cc (record_stmt_cost): Expose.
	(vect_get_store_cost, vect_get_load_cost): Extend with SLP node.
	(vectorizable_store, vectorizable_load): Pass SLP node to all costing.
	* tree-vectorizer.h (record_stmt_cost): Always pass both SLP node and
	stmt_vinfo to costing.
	(vect_get_load_cost, vect_get_store_cost): Extend with SLP node.

2024-11-21  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	PR target/102296
	* config/i386/sol2.h (ASM_DECLARE_OBJECT_NAME): Use decl size
	instead of type size.
	* config/sparc/sol2.h (ASM_DECLARE_OBJECT_NAME): Likewise.

2024-11-21  Christoph Müllner  <christoph.muellner@vrull.eu>

	* tree-ssa-forwprop.cc (struct _vec_perm_simplify_seq): New data
	structure to store analysis results of a vec perm simplify sequence.
	(get_vect_selector_index_map): Helper to get an index map from the
	provided vector permute selector.
	(recognise_vec_perm_simplify_seq): Helper to recognise a
	vec perm simplify sequence.
	(narrow_vec_perm_simplify_seq): Helper to pack the lanes more
	tight.
	(can_blend_vec_perm_simplify_seqs_p): Test if two vec perm
	sequences can be blended.
	(calc_perm_vec_perm_simplify_seqs): Helper to calculate the new
	permutation indices.
	(blend_vec_perm_simplify_seqs): Helper to blend two vec perm
	simplify sequences.
	(process_vec_perm_simplify_seq_list): Helper to process a list
	of vec perm simplify sequences.
	(append_vec_perm_simplify_seq_list): Helper to add a vec perm
	simplify sequence to the list.
	(pass_forwprop::execute): Integrate new functionality.

2024-11-21  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117720
	* tree-vect-stmts.cc (vectorizable_load): For VMAT_STRIDED_SLP
	verify the choosen load type is OK with regard to alignment.

2024-11-21  Jakub Jelinek  <jakub@redhat.com>

	* doc/invoke.texi (-std=c23): Adjust documentation for
	publication of the ISO/IEC 9899:2024 standard.
	* doc/standards.texi: Likewise.  Document -std=gnu17 and
	-std=gnu23 options.  Mention that -std=gnu23 rather than
	-std=gnu17 is now the default for C.

2024-11-21  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/94589
	PR tree-optimization/117612
	* tree-ssa-phiopt.cc (spaceship_replacement): Handle
	HONOR_NANS (TREE_TYPE (lhs1)) case when possible.

2024-11-21  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/94589
	PR tree-optimization/117612
	* tree-ssa-phiopt.cc (spaceship_replacement): Fix up
	a pasto in check when arg1 is 2.

2024-11-21  Jakub Jelinek  <jakub@redhat.com>

	PR c/117024
	* coretypes.h (enum function_class): Add function_c2y_misc
	enumerator.
	* builtin-types.def (BT_FN_UINTMAX_INTMAX, BT_FN_ULONG_LONG,
	BT_FN_ULONGLONG_LONGLONG): New DEF_FUNCTION_TYPE_1s.
	* builtins.def (DEF_C2Y_BUILTIN): Define.
	(BUILT_IN_UABS, BUILT_IN_UIMAXABS, BUILT_IN_ULABS,
	BUILT_IN_ULLABS): New builtins.
	* builtins.cc (fold_builtin_abs): Handle also folding of u*abs
	to ABSU_EXPR.
	(fold_builtin_1): Handle BUILT_IN_U{,L,LL,IMAX}ABS.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	PR target/114567
	* config/rs6000/rs6000.md (expander signbit<FLOAT128:mode>2): Adjust.
	(*signbit<mode>2_dm_mem): Rename to ...
	(signbit<mode>2_dm_mem): ... this.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	* config/rs6000/altivec.md (altivec_vadduqm): Rename to ...
	(addv1ti3): ... this.
	(altivec_vsubuqm): Rename to ...
	(subv1ti3): ... this.
	* config/rs6000/rs6000-builtins.def (__builtin_altivec_vadduqm):
	Replace bif expander altivec_vadduqm with addv1ti3.
	(__builtin_altivec_vsubuqm): Replace bif expander altivec_vsubuqm with
	subv1ti3.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	* config/rs6000/altivec.md (mode attr for V1TI in VI_unit): Remove.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	* config/rs6000/rs6000.md (*eqv<BOOL_128:mode>3_internal1): Generate
	insn veqv if TARGET_ALTIVEC and operands are altivec_register_operand.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	* config/rs6000/rs6000-cpus.def (ISA_3_0_MASKS_IEEE): Remove.
	* config/rs6000/rs6000.cc (rs6000_option_override_internal): Replace
	ISA_3_0_MASKS_IEEE check with TARGET_P9_VECTOR.

2024-11-21  Kewen Lin  <linkw@linux.ibm.com>

	* config/rs6000/rs6000.cc (rs6000_option_override_internal): Simplify
	TARGET_P8_VECTOR && TARGET_DIRECT_MOVE as TARGET_P8_VECTOR.
	(rs6000_output_move_128bit): Simplify TARGET_VSX && TARGET_DIRECT_MOVE
	as TARGET_DIRECT_MOVE.
	* config/rs6000/rs6000.h (TARGET_XSCVDPSPN): Simplify conditions
	TARGET_DIRECT_MOVE || TARGET_P8_VECTOR as TARGET_P8_VECTOR.
	(TARGET_XSCVSPDPN): Likewise.
	(TARGET_DIRECT_MOVE_128): Simplify TARGET_DIRECT_MOVE &&
	TARGET_POWERPC64 as TARGET_DIRECT_MOVE_64BIT.
	(TARGET_VEXTRACTUB): Likewise.
	(TARGET_DIRECT_MOVE_64BIT): Simplify TARGET_P8_VECTOR &&
	TARGET_DIRECT_MOVE as TARGET_DIRECT_MOVE.
	* config/rs6000/rs6000.md (signbit<mode>2, @signbit<mode>2_dm,
	*signbit<mode>2_dm_mem, floatsi<mode>2_lfiwax,
	floatsi<SFDF:mode>2_lfiwax_<QHI:mode>_mem_zext,
	floatunssi<mode>2_lfiwzx, float<QHI:mode><SFDF:mode>2,
	*float<QHI:mode><SFDF:mode>2_internal, floatuns<QHI:mode><SFDF:mode>2,
	*floatuns<QHI:mode><SFDF:mode>2_internal, p8_mtvsrd_v16qidi2,
	p8_mtvsrd_df, p8_xxpermdi_<mode>, reload_vsx_from_gpr<mode>,
	p8_mtvsrd_sf, reload_vsx_from_gprsf, p8_mfvsrd_3_<mode>,
	reload_gpr_from_vsx<mode>, reload_gpr_from_vsxsf, unpack<mode>_dm):
	Simplify TARGET_DIRECT_MOVE && TARGET_POWERPC64 as
	TARGET_DIRECT_MOVE_64BIT.
	(unpack<mode>_nodm): Simplify !TARGET_DIRECT_MOVE || !TARGET_POWERPC64
	as !TARGET_DIRECT_MOVE_64BIT.
	(fix_trunc<mode>si2, fix_trunc<mode>si2_stfiwx,
	fix_trunc<mode>si2_internal): Simplify TARGET_P8_VECTOR &&
	TARGET_DIRECT_MOVE as TARGET_DIRECT_MOVE.
	(fix_trunc<mode>si2_stfiwx, fixuns_trunc<mode>si2_stfiwx): Remove some
	dead code as the guard TARGET_DIRECT_MOVE there never holds.
	(fixuns_trunc<mode>si2_stfiwx): Change TARGET_P8_VECTOR with
	TARGET_DIRECT_MOVE which is a better fit.
	* config/rs6000/vsx.md (define_peephole2 for SFmode in GPR): Simplify
	TARGET_DIRECT_MOVE && TARGET_POWERPC64 as TARGET_DIRECT_MOVE_64BIT.

2024-11-20  Lewis Hyatt  <lhyatt@gmail.com>

	* tree-cfg.cc (assign_discriminators): Fix incorrect value passed to
	next_discriminator_for_locus().

2024-11-20  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR target/116587
	* lra-assigns.cc (find_all_spills_for): Consider all pseudos whose
	classes intersect given pseudo class.

2024-11-20  Andrew Pinski  <quic_apinski@quicinc.com>

	* read-md.h (class rtx_reader): Don't include m_reuse_rtx_by_id
	when GENERATOR_FILE is defined.
	* read-rtl.cc (rtx_reader::read_rtx_code): Disable reuse_rtx
	support when GENERATOR_FILE is defined.

2024-11-20  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117709
	* tree-vect-stmts.cc (get_group_load_store_type): Only
	set *poffset when we end up with VMAT_CONTIGUOUS_DOWN
	or VMAT_CONTIGUOUS_REVERSE.

2024-11-20  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/117698
	* tree-vect-stmts.cc (get_group_load_store_type): Properly
	disregard alignment for VMAT_STRIDED_SLP and VMAT_INVARIANT.
	(vectorizable_load): Adjust guard for dumping whether we
	vectorize and unaligned access.
	(vectorizable_store): Likewise.

2024-11-20  Paul-Antoine Arras  <parras@baylibre.com>

	* builtins.cc (builtin_fnspec): Handle BUILT_IN_OMP_GET_MAPPED_PTR.
	* gimple-low.cc (lower_stmt): Handle GIMPLE_OMP_DISPATCH.
	* gimple-pretty-print.cc (dump_gimple_omp_dispatch): New function.
	(pp_gimple_stmt_1): Handle GIMPLE_OMP_DISPATCH.
	* gimple-walk.cc (walk_gimple_stmt): Likewise.
	* gimple.cc (gimple_build_omp_dispatch): New function.
	(gimple_copy): Handle GIMPLE_OMP_DISPATCH.
	* gimple.def (GIMPLE_OMP_DISPATCH): Define.
	* gimple.h (gimple_build_omp_dispatch): Declare.
	(gimple_has_substatements): Handle GIMPLE_OMP_DISPATCH.
	(gimple_omp_dispatch_clauses): New function.
	(gimple_omp_dispatch_clauses_ptr): Likewise.
	(gimple_omp_dispatch_set_clauses): Likewise.
	(gimple_return_set_retval): Handle GIMPLE_OMP_DISPATCH.
	* gimplify.cc (enum omp_region_type): Add ORT_DISPATCH.
	(struct gimplify_omp_ctx): Add in_call_args.
	(gimplify_call_expr): Handle need_device_ptr arguments.
	(is_gimple_stmt): Handle OMP_DISPATCH.
	(gimplify_scan_omp_clauses): Handle OMP_CLAUSE_DEVICE in a dispatch
	construct. Handle OMP_CLAUSE_NOVARIANTS and OMP_CLAUSE_NOCONTEXT.
	(omp_has_novariants): New function.
	(omp_has_nocontext): Likewise.
	(omp_construct_selector_matches): Handle OMP_DISPATCH with nocontext
	clause.
	(find_ifn_gomp_dispatch): New function.
	(gimplify_omp_dispatch): Likewise.
	(gimplify_expr): Handle OMP_DISPATCH.
	* gimplify.h (omp_has_novariants): Declare.
	* internal-fn.cc (expand_GOMP_DISPATCH): New function.
	* internal-fn.def (GOMP_DISPATCH): Define.
	* omp-builtins.def (BUILT_IN_OMP_GET_MAPPED_PTR): Define.
	(BUILT_IN_OMP_GET_DEFAULT_DEVICE): Define.
	(BUILT_IN_OMP_SET_DEFAULT_DEVICE): Define.
	* omp-general.cc (omp_construct_traits_to_codes): Add OMP_DISPATCH.
	(struct omp_ts_info): Add dispatch.
	(omp_resolve_declare_variant): Handle novariants. Adjust
	DECL_ASSEMBLER_NAME.
	* omp-low.cc (scan_omp_1_stmt): Handle GIMPLE_OMP_DISPATCH.
	(lower_omp_dispatch): New function.
	(lower_omp_1): Call it.
	* tree-inline.cc (remap_gimple_stmt): Handle GIMPLE_OMP_DISPATCH.
	(estimate_num_insns): Handle GIMPLE_OMP_DISPATCH.

2024-11-20  Paul-Antoine Arras  <parras@baylibre.com>

	* builtin-types.def (BT_FN_PTR_CONST_PTR_INT): New.
	* omp-selectors.h (enum omp_ts_code): Add OMP_TRAIT_CONSTRUCT_DISPATCH.
	* tree-core.h (enum omp_clause_code): Add OMP_CLAUSE_NOVARIANTS and
	OMP_CLAUSE_NOCONTEXT.
	* tree-pretty-print.cc (dump_omp_clause): Handle OMP_CLAUSE_NOVARIANTS
	and OMP_CLAUSE_NOCONTEXT.
	(dump_generic_node): Handle OMP_DISPATCH.
	* tree.cc (omp_clause_num_ops): Add OMP_CLAUSE_NOVARIANTS and
	OMP_CLAUSE_NOCONTEXT.
	(omp_clause_code_name): Add "novariants" and "nocontext".
	* tree.def (OMP_DISPATCH): New.
	* tree.h (OMP_DISPATCH_BODY): New macro.
	(OMP_DISPATCH_CLAUSES): New macro.
	(OMP_CLAUSE_NOVARIANTS_EXPR): New macro.
	(OMP_CLAUSE_NOCONTEXT_EXPR): New macro.

2024-11-20  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-option-extensions.def (sme2p1): New extension.
	* doc/invoke.texi: Document it.
	* config/aarch64/aarch64.h (TARGET_STREAMING_SME2p1): New macro.
	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins):
	Conditionally define __ARM_FEATURE_SME2p1.
	* config/aarch64/iterators.md (UNSPEC_SME_READZ, UNSPEC_SME_READZ_HOR)
	(UNSPEC_SME_READZ_VER): New unspecs.
	(optab, hv): Handle them.
	(SME_READZ_HV): New int iterator.
	* config/aarch64/aarch64-sme.md
	(UNSPEC_SME_ZERO_SLICES): New unspec.
	(@aarch64_sme_<SME_READZ_HV:optab><v_int_container><mode>)
	(*aarch64_sme_<SME_READZ_HV:optab><v_int_container><mode>_plus)
	(@aarch64_sme_<SME_READZ_HV:optab><VNx1TI_ONLY:mode><SVE_FULL:mode>)
	(@aarch64_sme_<SME_READZ_HV:optab><SVE_FULLx24:mode><mode>)
	(*aarch64_sme_<SME_READZ_HV:optab><SVE_FULLx24:mode><mode>_plus)
	(@aarch64_sme_readz<mode>, *aarch64_sme_readz<mode>_plus)
	(@aarch64_sme_zero_za_slices<mode>): New patterns.
	(*aarch64_sme_zero_za_slices<mode>_plus): Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.h
	(inherent_za_slice): Declare.
	* config/aarch64/aarch64-sve-builtins-shapes.cc
	(inherent_za_slice_def, inherent_za_slice): New shape.
	* config/aarch64/aarch64-sve-builtins-sme.h (svreadz_za)
	(svreadz_hor_za, svreadz_ver_za): Declare.
	* config/aarch64/aarch64-sve-builtins-sme.cc
	(svread_za_slice_base): New class, split out from...
	(svread_za_impl): ...here.
	(svreadz_za_impl, svreadz_za_tile_impl): New type aliases.
	(zero_slices_mode): New function.
	(svzero_za_impl::expand): Handle the slice forms.
	(svreadz_za, svreadz_hor_za, svreadz_ver_za): New functions.
	* config/aarch64/aarch64-sve-builtins-sme.def: Add the SME2p1
	instructions.

2024-11-20  Richard Sandiford  <richard.sandiford@arm.com>

	* config/aarch64/aarch64-option-extensions.def
	(sme-b16b16): New extension.
	* doc/invoke.texi: Document it.
	* config/aarch64/aarch64.h (TARGET_STREAMING_SME_B16B16): New macro.
	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins):
	Conditionally define __ARM_FEATURE_SME_B16B16.
	* config/aarch64/aarch64-sve-builtins-sme.def: Add SME_B16B16 forms
	of existing intrinsics.
	* config/aarch64/aarch64-sme.md
	(@aarch64_sme_<SME_BINARY_SLICE_HSDF:optab><mode>)
	(*aarch64_sme_<SME_BINARY_SLICE_HSDF:optab><mode>_plus)
